async function applySimpleCodeChanges(tabUid, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, CHANGE_MY_PROJECT_NAME, CHANGE_MY_PROJECT_PATH) {
    let simpleChangesSucceeded = false;
    STUI.updateLoaderText("Applying Change");
    let changeError = false;
    let allCodeChanges = DIFFR.parseCodeChanges(assistantMessage, justFilesLinux);
    console.log("code changes");
    console.log(allCodeChanges);

    for(let c = 0; c < allCodeChanges.length; c++){
        let codechangePath = allCodeChanges[c]['file_path'];
        let foundPath = false;
        for(let x = 0; x < finalOriginalPaths.length; x++){
            let fPath = finalOriginalPaths[x];
            let sPath = finalShortPaths[x];
            console.log("PATH: ");
            console.log(sPath);
            if(comparePaths(codechangePath, sPath)){
                allCodeChanges[c]['real_path'] = fPath;     
                allCodeChanges[c]['short_path'] = sPath;     
                allCodeChanges[c]['file_content'] = await fs.readFile(fPath, 'utf8');  
                let lineCount = allCodeChanges[c]['file_content'].split(/\r?\n/).length;
                allCodeChanges[c]['line_count'] = lineCount;  
                allCodeChanges[c]['mod_content'] = "//NOT MODIFIED\n" + allCodeChanges[c]['file_content'];  
                foundPath = true;
                break;
            }
        }            
        if(!foundPath){
            if(arrayHasPath(justFilesLinux, codechangePath)){
                let theShortPath = arrayGetPath(justFilesLinux, codechangePath);
                let theFullPath = path.join(CHANGE_MY_PROJECT_PATH, theShortPath);                   
                allCodeChanges[c]['real_path'] = theFullPath;     
                allCodeChanges[c]['short_path'] = theShortPath;     
                allCodeChanges[c]['file_content'] = await fs.readFile(theFullPath, 'utf8');  
                let lineCount = allCodeChanges[c]['file_content'].split(/\r?\n/).length;
                allCodeChanges[c]['line_count'] = lineCount;                     
                allCodeChanges[c]['mod_content'] = "//NOT MODIFIED\n" + allCodeChanges[c]['file_content'];  
                foundPath = true;
            }else{
                console.log("CHANGE ERROR - Could not find path: " + codechangePath);
                changeError = true;
                break;
            }
        }
    }
    
    if(!changeError){        
        console.log("ALL PATHS FOUND - now allCodeChanges has ");
        console.log(allCodeChanges);            
        //apply the changes
        for(let a = 0; a < allCodeChanges.length; a++){
            let currRealPath = allCodeChanges[a]['real_path'];     
            let originalCode = allCodeChanges[a]['file_content'];
            if(a > 0){
                for(let b = 0; b < a; b++){
                    let pastRealPath = allCodeChanges[b]['real_path'];     
                    if(currRealPath == pastRealPath){
                        console.log("FOUND PAST FILE MODIFICATION - CHANGING ORIGINAL CODE OF THIS ONE");
                        originalCode = allCodeChanges[b]['mod_content'];    
                    }
                }
            }
            let newCode = allCodeChanges[a]['code_changes'];                
            let modFile = DIFFR.simpleCodeChanges(originalCode, newCode);
            console.log("WE applied codechanges");
            console.log(newCode);
            console.log("Got new code");
            console.log(modFile);
            
            allCodeChanges[a]['mod_content'] = modFile;                
        }
        
        let originalCode = {};
        let originalProjectData = {};
        let modifiedCodeArr = {};
        let alreadyProcessedChanges = new Array();
        for(let m = (allCodeChanges.length - 1); m >= 0; m--){                
            let codeChangeData = allCodeChanges[m];
            console.log("doing ");
            console.log(codeChangeData);
            
            if(alreadyProcessedChanges.includes(codeChangeData['short_path'])){
                continue;
            }                
            alreadyProcessedChanges.push(codeChangeData['short_path']);
            modifiedCodeArr[codeChangeData['short_path']] =  codeChangeData['mod_content'];
            originalCode[codeChangeData['short_path']] = codeChangeData['file_content'];
            originalProjectData[codeChangeData['short_path']] = {
                project_name: CHANGE_MY_PROJECT_NAME,
                project_path: CHANGE_MY_PROJECT_PATH,
                is_new: codeChangeData['is_new']
            };
            console.log("added");
        }            
        
        let formalChangesWithLine = new Array();

        let reversedModifiedCodeArr = {};
        Object.keys(modifiedCodeArr).reverse().forEach(function(key) {
            reversedModifiedCodeArr[key] = modifiedCodeArr[key];
        });     
        console.log("loading new diffs");
        console.log("Original code");
        console.log(originalCode);
        console.log("reversedModifiedCodeArr");
        console.log(reversedModifiedCodeArr);
        console.log("orig project data");
        console.log(originalProjectData);
        
        if(Object.keys(originalCode).length > 0){
            DIFFR.loadNewDiffs(formalChangesWithLine, originalCode, reversedModifiedCodeArr, originalProjectData, false, tabUid);
            simpleChangesSucceeded = true;
            STUI.stopLoader();
            //$('#reapply_changes').css('display', 'block');
            $('#accept_all_changes').css('display', 'block');
        }else{
            console.log("SIMPLE CHANGES WERE ATTEMPTED, BUT NOT APPLIED");
            STUI.updateLoaderText("Using LLM to Apply Changes");
        }
    }
    
    return simpleChangesSucceeded;
}


var reapplyUsingFormalizedChanges = async function(myProjectArr, myProjectPathArr, myTask, tabUid, allRelevantText, assistantMessage, moreTasks, moreResponses, moreUpdate) {
    let currTab = TABS.getTabByUid(tabUid);
    let tabIndex = TABS.getIndexByUid(tabUid);    
    let allFileData = TABS.TAB_ARR[tabIndex]['file_data'];
    let justFilesLinux = TABS.TAB_ARR[tabIndex]['just_files_linux'];

    console.log("reloaded filedata");
    console.log(allFileData);
    let CHANGE_MY_PROJECT_NAME = myProjectArr[0];
    let CHANGE_MY_PROJECT_PATH = myProjectPathArr[0];
    
    $('#reapply_changes').css('display', 'none');
    STUI.updateLoaderText("Using LLM to Apply Changes");
    let retriesLeft = CHATGPT.retryAttempts;
    //Now use the assitant message to get formalized changes
    let formalizeTaskResponse = await CHATGPT.formalizeCodeChanges(false, myTask, allRelevantText, assistantMessage, tabUid, moreTasks, moreResponses, moreUpdate);
    if(STUI.hasChatGPTError(formalizeTaskResponse)){
        let retrySucceeded = false;
        while(retriesLeft > 0 && CHATGPT.SWITCH_LLM(tabUid)){
            console.log("RETRYING STEP 4");
            retriesLeft--;
            formalizeTaskResponse = await CHATGPT.formalizeCodeChanges(false, myTask, allRelevantText, assistantMessage, tabUid, moreTasks, moreResponses, moreUpdate);
            if(!STUI.hasChatGPTError(formalizeTaskResponse)){
                retrySucceeded = true;
                break;
            }
        }
        if(!retrySucceeded){
            
            //we can set the Reapply LLM button to visible here?
            $('#reapply_changes').css('display', 'block');
            $('#diffheader').css('display', 'flex');
            console.log("ERROR STEP 4");
            STUI.loaderError("Error formalizing changes - press reapply to try again");
            return;
        }
    }

    let formalChangeArr = formalizeTaskResponse['response'];
    //maybe save time... here
    //if(STUI.checkToDelayNextRequest()){
    //}    
    console.log("=====================");
    console.log("STEP 5");      
    console.log("formalize change array: ");
    console.log(formalChangeArr);
    let originalCode = {};
    let originalProjectData = {};
    for(let m = 0; m < allFileData.length; m++){
        /*
        output.push({
            file_path: filePath,
            short_path: shortPath,
            full_source: fullSource,
            relevant_source: relevantSource,
            relevant_lines: uniqueLineNumbers
        });
                 */
        let origfileData = allFileData[m];

        originalCode[origfileData['short_path']] = origfileData['full_source'];
        originalProjectData[origfileData['short_path']] = {
            project_name: CHANGE_MY_PROJECT_NAME,
            project_path: CHANGE_MY_PROJECT_PATH,
            is_new: false
        };
    }

    let addedNew = false;
    console.log("trying to add new file");
    for(let f = 0; f < formalChangeArr.length; f++){
        console.log("fchange");
        console.log(formalChangeArr[f]);
        if(formalChangeArr[f]['insertion_type'] == 'create-new' || formalChangeArr[f]['insertion_type'] == 'create-file'){
            if(arrayHasPath(justFilesLinux, formalChangeArr[f]['file_path'])){
                //should not happen
                console.log("TRYING TO CREATE NEW ON FILE THAT ALREADY EXISTS");
            }
            else{
                originalCode[formalChangeArr[f]['file_path']] = '';
                originalProjectData[formalChangeArr[f]['file_path']] = {
                    project_name: CHANGE_MY_PROJECT_NAME,
                    project_path: CHANGE_MY_PROJECT_PATH,
                    is_new: true
                };  
                addedNew = true;
            }
        }
        formalChangeArr[f]['full_path'] = path.join(CHANGE_MY_PROJECT_PATH, formalChangeArr[f]['file_path']);
    }
    if(addedNew){
        console.log("ADDED NEW FILE - YESssssssssssssss");            
    }
    
    //else{    console.log("ADDED NEW FILE - NOoooooooooooooooo");}

    console.log("original code array:");
    console.log(originalCode);
    //console.log("pausing");
    //await gotosleep(5000); 
    
    let modifiedAndFormalChanges = await DIFFR.getFileDiffs(originalCode, formalChangeArr, justFilesLinux);    
    let modifiedCodeArr = modifiedAndFormalChanges[0];    
    let formalChangesWithLine = modifiedAndFormalChanges[1];
    
    console.log("before fix modifiedCodeArr");
    console.log(modifiedCodeArr);    
    let fixedModFileArr = {};
    for(let modKey in modifiedCodeArr) {
        let matchingOrigKey = Object.keys(originalCode).find(origKey => comparePaths(origKey, modKey));
        if(matchingOrigKey) {            
            fixedModFileArr[matchingOrigKey] = modifiedCodeArr[modKey];
        } else {
            fixedModFileArr[modKey] = modifiedCodeArr[modKey];
        }
    }
    modifiedCodeArr = fixedModFileArr;  
    console.log("after fix modifiedCodeArr");
    console.log(modifiedCodeArr);        
    
    
    if (formalChangesWithLine.length === 0) {
        STUI.updateLoaderText('There was an Error getting Diffs<br><i class="ti ti-exclamation-circle"></i>');
        $('.loader').css('display', 'none');
        //STUI.updateLoaderText("There was an Error getting Diffs);
        return;
    }     
    console.log("modified code array");
    console.log(modifiedCodeArr);
    //console.log("pausing");    
    //await gotosleep(5000);   
    //we can stop the loader now
    
    console.log("Loading diffs which is FINAL THING");
    STUI.stopLoader();
    console.log("sending tab uid");
    console.log(tabUid);
    DIFFR.loadNewDiffs(formalChangesWithLine, originalCode, modifiedCodeArr, originalProjectData, false, tabUid);


    //after check the diffs for syntax errors
    // USE TREESITTER TO CHECK FOR SYNTAX ERRORS
    doSyntaxChecking(originalCode, modifiedCodeArr, originalProjectData, tabUid);   
    
    return true;
};



async function applyPiecemealCodeChanges(tabUid, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, myProjectArr, myProjectPathArr, myProjectDescArr, existingEditors = null) {
    let piecemealChangeError = false;
    let piecemealChangesSucceeded = false;
    console.log("just files:");
    console.log(justFilesLinux);
    console.log("finalShortPaths: ");
    console.log(finalShortPaths);
    let allCodeChanges = DIFFR.parseCodeChanges(assistantMessage, justFilesLinux);
    console.log("code changes");
    console.log(allCodeChanges);
    
    let CHANGE_MY_PROJECT_NAME = myProjectArr[0];
    let CHANGE_MY_PROJECT_PATH = myProjectPathArr[0];    
    
    let allFileChanges = new Array();

    for(let c = 0; c < allCodeChanges.length; c++){
        let codechangePath = allCodeChanges[c]['file_path'];
        let codeChanges = allCodeChanges[c]['code_changes'];
        let fileExtension = path.extname(codechangePath);
        let theExt = fileExtension.slice(1);                

        let foundPath = false;
        for(let x = 0; x < finalOriginalPaths.length; x++){
            let fPath = finalOriginalPaths[x];
            let sPath = finalShortPaths[x];      


            console.log("PATH: ");
            console.log(fPath);
            if(!sPath){
                //console.log("BAD PATH?");
                //console.log(fPath);
                //console.log(sPath);
                continue;
            }
            if(comparePaths(codechangePath, sPath)){
                allCodeChanges[c]['real_path'] = fPath;     
                allCodeChanges[c]['short_path'] = sPath;     
                //allCodeChanges[c]['file_content'] = await fs.readFile(fPath, 'utf8');  
                allCodeChanges[c]['file_content'] = readFileWithCache(fPath);
                allCodeChanges[c]['line_count'] = allCodeChanges[c]['file_content'].split(/\r?\n/).length;                   
                //THESE ARE THE CODE CHANGES NOT ORIGINAL FILE STRUCTURE
                let controlStructure = null;
                if(DGRAPH.markupExtensions.includes(theExt)){
                    controlStructure = "markup";
                }else if(DGRAPH.styleExtensions.includes(theExt)){
                    controlStructure = "styles";
                }else{
                    controlStrucutre = await DGRAPH.getControlStructureForCode(fPath, codeChanges);
                }
                allCodeChanges[c]['control_structure'] = controlStructure;   
                //set mod_content to same for now
                allCodeChanges[c]['mod_content'] = "//NOT MODIFIED\n" + allCodeChanges[c]['file_content'];  


                if(sPath in allFileChanges){
                    allFileChanges[sPath]['code_changes'].push(allCodeChanges[c]);
                }else{
                    allFileChanges[sPath] = new Array();
                    allFileChanges[sPath]['code_changes'] = new Array();
                    allFileChanges[sPath]['code_changes'].push(allCodeChanges[c]);
                    allFileChanges[sPath]['file_content'] = allCodeChanges[c]['file_content'];
                    allFileChanges[sPath]['line_count'] = allCodeChanges[c]['file_content'].split(/\r?\n/).length;      
                    allFileChanges[sPath]['mod_content'] = "//NOT MODIFIED";
                    allFileChanges[sPath]['is_new'] = false;
                }

                foundPath = true;
                break;
            }
        }            
        if(!foundPath){
            //asked to change some code in a file that wasn't originally retrieved                
            if(arrayHasPath(justFilesLinux, codechangePath)){
                let theShortPath = arrayGetPath(justFilesLinux, codechangePath);
                let theFullPath = path.join(CHANGE_MY_PROJECT_PATH, theShortPath);
                allCodeChanges[c]['real_path'] = theFullPath;     
                allCodeChanges[c]['short_path'] = theShortPath;     
                //allCodeChanges[c]['file_content'] = await fs.readFile(theFullPath, 'utf8');     
                allCodeChanges[c]['file_content'] = readFileWithCache(theFullPath);
                //THESE ARE THE CODE CHANGES NOT ORIGINAL FILE STRUCTURE
                let controlStructure = null;
                if(DGRAPH.markupExtensions.includes(theExt)){
                    controlStructure = "markup";
                }else if(DGRAPH.styleExtensions.includes(theExt)){
                    controlStructure = "styles";
                }else{
                    controlStructure = await DGRAPH.getControlStructureForCode(allCodeChanges[c]['file_content'], codeChanges);
                }
                
                
                allCodeChanges[c]['control_structure'] = controlStructure;   

                console.log("THE FULL PATH " + theFullPath);
                allFileChanges[codechangePath] = new Array();
                allFileChanges[codechangePath]['code_changes'] = new Array();
                allFileChanges[codechangePath]['code_changes'].push(allCodeChanges[c]);
                allFileChanges[codechangePath]['file_content'] = allCodeChanges[c]['file_content'];
                console.log("FILE CONTENT " + allFileChanges[codechangePath]['file_content']);
                allFileChanges[codechangePath]['line_count'] = allFileChanges[codechangePath]['file_content'].split(/\r?\n/).length;
                console.log("LINE NUM" + allFileChanges[codechangePath]['line_count']);
                allFileChanges[codechangePath]['mod_content'] = "//NOT MODIFIED";
                allFileChanges[codechangePath]['is_new'] = false;
            }else{
                console.log("path not found: " + codechangePath);
                allFileChanges[codechangePath] = new Array();
                allFileChanges[codechangePath]['code_changes'] = new Array();
                allCodeChanges[c]['control_structure'] = "new_file";
                allFileChanges[codechangePath]['code_changes'].push(allCodeChanges[c]);                 
                //empty file for new_file
                allFileChanges[codechangePath]['file_content'] = "";
                allFileChanges[codechangePath]['line_count'] = 0;                      
                allFileChanges[codechangePath]['mod_content'] = codeChanges;  
                allFileChanges[codechangePath]['is_new'] = true;
            }                

            //console.log("PIECEMEAL CHANGE ERROR - Could not find path: " + codechangePath);
            //piecemealChangeError = true;
            //break;
        }

    }
    
// ... new parallel version
        if(!piecemealChangeError){                    
            console.log("PIECEMEAL allFileChanges has ");
            console.log(allFileChanges);            
            // Apply the changes
            let originalCode = {};
            let originalProjectData = {};
            let modifiedCodeArr = {};         
            

            let llmRequestBlockArray = []; // Collect blocks across all files

            for(let updateFilePath in allFileChanges){
                let fileContent = allFileChanges[updateFilePath]['file_content'];    
                let lineCount = allFileChanges[updateFilePath]['line_count']; 
                let fileExtension = path.extname(updateFilePath);
                let theExt = fileExtension.slice(1);

                console.log("testing line count " + lineCount);

                if(lineCount <= STUBS.PIECEMEAL_FULL_REPLACE_LINES){                   
                    console.log("PIECEMEAL SMALL FILE: " + updateFilePath + " REPLACING COMPLETELY");     

                    // Push a block for full file replacement
                    llmRequestBlockArray.push({
                        index: llmRequestBlockArray.length,
                        replace_type: 'full_file',
                        file_path: updateFilePath,
                        ext: theExt,
                        original_file_code: fileContent,
                        new_code: null, 
                        originalFileContent: fileContent
                    });                
                } else {
                    console.log("ALL CODE CHANGES: " + updateFilePath);
                    console.log("====================================");
                    let fileCodeChanges = allFileChanges[updateFilePath]['code_changes'];
                    console.log(fileCodeChanges);

                    let originalFileContent = allFileChanges[updateFilePath]['file_content'];

                for (let f = 0; f < fileCodeChanges.length; f++) {
                    let oneCodeChange = fileCodeChanges[f];
                    let oneCodeText = oneCodeChange['code_changes'];
                    
                    let currentBlock = null;
                    let prevLineIndex = -1;
                    let skipLines = [];                    

                    if(theExt == 'html' || theExt == 'tpl'){
                        console.log("HTML SCOPES ext" + theExt);
                        console.log(oneCodeText);
                        let theScopes = await WEBFILE.getHtmlTopLevelScopesAsync(oneCodeText, theExt);
                        console.log("scopes for " + f);
                        console.log(theScopes);
                        

                        for (let s = 0; s < theScopes.length; s++) {
                            let scope = theScopes[s];
                            let startLine = scope['start_line'].trim();
                            let scopeCategory = scope['category'];

                            // Skip comment lines
                            if (startLine.startsWith('<!--') || startLine.startsWith('//') || startLine.startsWith('/*') || startLine.startsWith('{*')) {
                                continue;
                            }
                            console.log("DOING NEW BEST LINE INDEX");
                            let lineIndex = DIFFR.getBestLineIndex(originalFileContent, startLine, scope['all_lines']);
                            console.log(lineIndex);
                            
                            
                            let exactMatch = true;
                            if (lineIndex === null) {
                                exactMatch = false;
                                let bestMatch = getLineAndSimilarity(originalFileContent, startLine);
                                if (bestMatch && bestMatch.score >= 0.95) {
                                    if(!STUBS.isPackaged){ 
                                        alert("html dangerous bestMatch being used " + startLine + " === " + bestMatch.index);
                                    }
                                    lineIndex = bestMatch.index;
                                }
                            }

                            let replaceType;
                            let endLineIndex = null;
                            if (lineIndex !== null) {
                                console.log("getting control structure for html");
                                console.log(originalFileContent);
                                //always do replace for the top level html scopes
                                console.log("and line index");
                                console.log(lineIndex);
                                let controlStructure = null;
                                try {
                                    let testLineArr = originalFileContent.split(/\r?\n/);
                                    let testLine = testLineArr[lineIndex];
                                    console.log("test line: " + testLine);
                                    console.log("USING NEW SCOPE PARSER");
                                    controlStructure = WEBFILE.getMarkupScopeFallback(originalFileContent, lineIndex, theExt);
                                    /*
                                    if(WEBFILE.quickHtmlValidate(originalFileContent)){
                                        const result = await TREESIT.getHtmlElementScopeForLine(originalFileContent, lineIndex);
                                        if (result === null) {
                                            console.log("HTML parsing timed out, using fallback111");
                                            controlStructure = await WEBFILE.getHtmlScopeFallback(originalFileContent, lineIndex);
                                        } else {
                                            controlStructure = result;
                                        }
                                    }else{
                                        console.log("HTML parser check failed - fallback444");
                                        controlStructure = await WEBFILE.getHtmlScopeFallback(originalFileContent, lineIndex);                                        
                                    }*/
                                } catch(exx) {
                                    console.log(exx);
                                    console.log("bad html doing fallback: ");
                                    console.log(originalFileContent);
                                    controlStructure = await WEBFILE.getHtmlScopeFallback(originalFileContent, lineIndex);
                                }
                                //(updateFilePath, startLine, originalFileContent);
                                console.log("got HTML control structure");
                                console.log(controlStructure);
                                // Check if the scope should be skipped
                                const scopeLines = scope['all_lines'].split(/\r?\n/);
                                //console.log("checking if should skip scope");
                                //console.log(scopeLines);
                                //console.log(originalFileContent);
                                if (shouldSkipScope(originalFileContent, scopeLines)) {
                                    console.log("SKIPPING");
                                    replaceType = 'skip';
                                } else {
                                    console.log("no skip");                                    
                                    replaceType = 'replace';
                                }                     
                                if (!controlStructure) {
                                    console.log("SHOULD NOT HAPPEN!!!!!!!!!!  NO START END LINE FOR AN HTML ELEMENT!!!!");

                                    //TODO - should just do next line that has same indentation here...                                    
                                    endLineIndex = lineIndex + 100;
                                }
                                else{
                                    endLineIndex = controlStructure.endLine;
                                }
                            } else {
                                replaceType = 'newcode';
                            }

                            // Always create a new block for each scope
                            if (currentBlock) {
                                llmRequestBlockArray.push(currentBlock);
                            }                            
                            currentBlock = {
                                index: llmRequestBlockArray.length,
                                replace_type: replaceType,
                                file_path: updateFilePath,
                                ext: theExt,
                                line_index: lineIndex,
                                original_file_start: lineIndex !== null ? lineIndex + 1 : null,
                                original_file_end: endLineIndex !== null ? endLineIndex + 1 : null,
                                original_file_code: lineIndex !== null ? 
                                    originalFileContent.split(/\r?\n/).slice(lineIndex, endLineIndex + 1).join('\n') : '',
                                new_code: scope['all_lines'],
                                scope_objects: [scope]
                            };

                            prevLineIndex = endLineIndex !== null ? endLineIndex : prevLineIndex;                            
                        }

                        // Add the last block after the loop
                        if (currentBlock) {
                            llmRequestBlockArray.push(currentBlock);
                        }                                                
                    }
                    else if(theExt == 'css'){
                        let theScopes = await WEBFILE.getCSSTopLevelScopesAsync(oneCodeText);
                        console.log("scopes for " + f);
                        console.log(theScopes);

                        let currentBlock = null;
                        let prevLineIndex = -1;

                        for (let s = 0; s < theScopes.length; s++) {
                            let scope = theScopes[s];
                            let startLine = scope['start_line'].trim();
                            console.log("startline: " + startLine);
                            let scopeCategory = scope['category'] || 'rule';

                            // Skip comment lines
                            if (startLine.startsWith('/*') || startLine.startsWith('//')) {
                                console.log("skipping scope");
                                console.log(scope);
                                continue;
                            }
                            let lineIndex = DIFFR.getBestLineIndex(originalFileContent, startLine, scope['all_lines']);
                            console.log("css line index");
                            console.log(lineIndex);
                            let exactMatch = true;
                            if (lineIndex === null) {
                                exactMatch = false;
                                let bestMatch = getLineAndSimilarity(originalFileContent, startLine);
                                if (bestMatch && bestMatch.score >= 0.9) {
                                    if(!STUBS.isPackaged){ 
                                        alert("css dangerous bestMatch being used " + startLine + " === " + bestMatch.index);
                                    }
                                    lineIndex = bestMatch.index;
                                }
                            }

                            let replaceType;
                            let endLineIndex = null;
                            let cssRuleScope;
                            if (lineIndex !== null) {
                                try {
                                    cssRuleScope = await WEBFILE.getCSSRuleScopeForLine(originalFileContent, lineIndex);
                                    endLineIndex = cssRuleScope.endLine - 1; // Adjust for 0-based index
                                    replaceType = 'replace';
                                    console.log("cssrulescope");
                                    console.log(cssRuleScope);
                                } catch (error) {
                                    console.log("Error getting CSS rule scope:", error);
                                    endLineIndex = lineIndex;
                                    replaceType = 'replace';
                                }
                            } else {
                                replaceType = 'newcode';
                            }

                            // Start a new block if:
                            // 1. There's no current block
                            // 2. There's a large gap (> 100 lines) in the original file
                            // 3. The replace type changes
                            if (!currentBlock || 
                                (lineIndex !== null && prevLineIndex !== -1 && (lineIndex - prevLineIndex) > 100) || 
                                (currentBlock && replaceType !== currentBlock.replace_type)) {
                                
                                console.log("creating new css block");

                                if (currentBlock) {
                                    console.log("adding old css block");
                                    console.log(currentBlock);
                                    llmRequestBlockArray.push(currentBlock);
                                }

                                currentBlock = {
                                    index: llmRequestBlockArray.length,
                                    replace_type: replaceType,
                                    file_path: updateFilePath,
                                    ext: theExt,
                                    original_file_start: lineIndex !== null ? lineIndex + 1 : null,
                                    original_file_end: endLineIndex !== null ? endLineIndex + 1 : null,
                                    original_file_code: lineIndex !== null ? 
                                        originalFileContent.split(/\r?\n/).slice(lineIndex, endLineIndex + 1).join('\n') : '',
                                    new_code: scope['all_lines'],
                                    scope_objects: [scope]
                                };
                            } else {
                                console.log("extending current css block");
                                // Extend the current block
                                currentBlock.original_file_end = endLineIndex !== null ? 
                                    Math.max(currentBlock.original_file_end, endLineIndex + 1) : null;
                                if (lineIndex !== null && prevLineIndex !== null && lineIndex > prevLineIndex) {
                                    let additionalLines = originalFileContent.split(/\r?\n/).slice(prevLineIndex + 1, endLineIndex + 1).join('\n');
                                    currentBlock.original_file_code += '\n' + additionalLines;
                                }
                                currentBlock.new_code += '\n' + scope['all_lines'];
                                currentBlock.scope_objects.push(scope);
                            }

                            prevLineIndex = endLineIndex !== null ? endLineIndex : prevLineIndex;
                        }

                        // Add the last block if it exists
                        if (currentBlock) {
                            llmRequestBlockArray.push(currentBlock);
                        }
                    }
                    else{
                        //console.log("getting scopes");
                        //console.log(oneCodeText);
                        let theScopes = await DGRAPH.getTopLevelScopes(oneCodeText, updateFilePath, originalFileContent);

                        console.log("scopes for " + f);
                        console.log(theScopes);
                        for (let s = 0; s < theScopes.length; s++) {
                            let scope = theScopes[s];
                            let startLine = scope['start_line'].trim();
                            let scopeCategory = scope['category'];

                            // Skip comment lines
                            if (allLinesAreComment(scope['all_lines'])) {
                                continue;
                            }
                            console.log("doing start line: " + startLine);

                            //let lineIndex = getLineIndex(originalFileContent, startLine);
                            let lineIndex = DIFFR.getBestLineIndex(originalFileContent, startLine, scope['all_lines']);
                            let exactMatch = true;
                            let bestMatch = null;
                            if (lineIndex === null) {
                                
                                exactMatch = false;
                                bestMatch = getLineAndSimilarity(originalFileContent, startLine);
                                console.log("best match is ");
                                console.log(bestMatch);
                                let functionName = extractFunctionFromLine(startLine);
                                if (bestMatch) {
                                    if(bestMatch.score >= 0.9){
                                        if(!STUBS.isPackaged){ 
                                            alert("dangerous bestMatch being tested " + startLine + " === " + bestMatch.index);
                                        }
                                        let theIndex = bestMatch.index;
                                        let bestmatchLine = originalFileContent.split(/\r?\n/)[theIndex];
                                        let bestStructure = await DGRAPH.getLargestControlStructureForLine(updateFilePath, bestmatchLine, originalFileContent, null);                                                                        
                                        console.log("best structure");
                                        console.log(bestStructure);
                                        if(bestStructure){
                                            let bestMatchLines = originalFileContent.split(/\r?\n/).slice(bestStructure.startLine, bestStructure.endLine + 1).join('\n');
                                            console.log("best match lines");
                                            console.log(bestMatchLines);
                                            console.log("VS SCOPE LINES");
                                            console.log(scope['all_lines']);
                                            let codeScore = DIFFR.compareCodeSimilarity(scope['all_lines'], bestMatchLines);
                                            if(codeScore > 0.5){
                                                console.log("score high enough");
                                                lineIndex = bestMatch.index;
                                            }
                                        }
                                    }
                                    else if(functionName.length > 0 && bestMatch['function_name'] == functionName){
                                        if(!STUBS.isPackaged){ 
                                            alert("dangerous function bestMatch being used " + startLine + " === " + bestMatch.index);
                                        }
                                        console.log("function match " + bestMatch['function_name']);
                                        console.log("function match " + functionName);
                                        
                                        lineIndex = bestMatch.index;                                        
                                    }
                                    
                                }
                            }

                            let replaceType;
                            let endLineIndex = null;
                            if (lineIndex !== null) {
                                let controlStructure = await DGRAPH.getLargestControlStructureForLine(updateFilePath, startLine, originalFileContent, bestMatch);                                
                                console.log("got control structure");
                                console.log(controlStructure);
                                
                                if (controlStructure) {
                                    endLineIndex = controlStructure.endLine + 1;
                                    
                                    if((controlStructure.endLine - controlStructure.startLine) > STUBS.PIECEMEAL_TOO_LARGE_BLOCK_LINES){
                                        console.log("CONTROL STRUCTURE TOO LARGE - GETTING NEXT INDEX INSIDE CONTROL STRUCTURE");

                                        // Split the scope's all_lines into lines
                                        let scopeLines = scope['all_lines'].split(/\r?\n/);

                                        // Remove the first line
                                        scopeLines.shift();

                                        // Check if the last line contains a closing brace/bracket
                                        let lastLine = scopeLines[scopeLines.length - 1]?.trim();
                                        if (lastLine && /^[\]\}\)];?$/.test(lastLine)) {
                                            scopeLines.pop();
                                        }

                                        // Update scope['all_lines'] with the inner content
                                        scope['all_lines'] = scopeLines.join('\n');

                                        if (scopeLines.length > 1) {
                                            let nextLine = scopeLines[1].trim();
                                            console.log("Trying next line: " + nextLine);

                                            // Try to find this line in the original file
                                            let nextLineIndex = DIFFR.getBestLineIndex(originalFileContent, nextLine, scope['all_lines']);
                                            if (nextLineIndex !== null) {
                                                // Found the line in the original file
                                                // Get the control structure for this line
                                                let innerControlStructure = await DGRAPH.getLargestControlStructureForLine(updateFilePath, nextLine, originalFileContent, null);
                                                if (innerControlStructure) {
                                                    if ((innerControlStructure.endLine - innerControlStructure.startLine) <= STUBS.PIECEMEAL_TOO_LARGE_BLOCK_LINES) {
                                                        // We can do a replace
                                                        lineIndex = nextLineIndex;
                                                        endLineIndex = innerControlStructure.endLine + 1;
                                                        replaceType = 'replace';
                                                    } else {
                                                        // Control structure still too large
                                                        console.log("Inner control structure still too large. Setting replaceType to 'newcode'");
                                                        replaceType = 'newcode';
                                                    }
                                                } else {
                                                    console.log("Could not get inner control structure. Setting replaceType to 'newcode'");
                                                    replaceType = 'newcode';
                                                }
                                            } else {
                                                console.log("Could not find next line in original file. Setting replaceType to 'newcode'");
                                                replaceType = 'newcode';
                                            }
                                        } else {
                                            console.log("No next line in scope's all_lines. Setting replaceType to 'newcode'");
                                            replaceType = 'newcode';
                                        }
                                    }else{

                                        // Compare allLines with the control structure content
                                        let controlStructureContent = originalFileContent.split(/\r?\n/).slice(controlStructure.startLine, controlStructure.endLine + 1).join('\n');
                                        let allLinesContent = scope['all_lines'];

                                        // Normalize both contents (remove whitespace at start/end of lines)
                                        controlStructureContent = controlStructureContent.split('\n').map(line => line.trim()).join('\n');
                                        allLinesContent = allLinesContent.split('\n').map(line => line.trim()).join('\n');
                                        //console.log("control structure content");
                                        //console.log(controlStructureContent);
                                        //console.log("scope all lines content");
                                        //console.log(allLinesContent);
                                        if (controlStructureContent === allLinesContent) {
                                            replaceType = 'skip';
                                            console.log("Content matches exactly. Skipping this block.");
                                        } else {
                                            replaceType = 'replace';
                                            console.log("Content differs. Will replace this block.");
                                        }
                                    }
                                } else if (scopeCategory === 'line' && exactMatch) {
                                    endLineIndex = lineIndex;
                                    replaceType = 'skip';
                                } else {
                                    console.log("no control structure replace");
                                    endLineIndex = lineIndex + 1;
                                    replaceType = 'replace';
                                }
                            } else {
                                console.log("Line Index not found");
                                replaceType = 'newcode';
                            }
                            
                            console.log("decided replaceType: " + replaceType);

                            // Start a new block if:
                            // 1. There's no current block
                            // 2. There's a large gap (> 100 lines) in the original file
                            // 3. The replace type changes (except when transitioning from 'skip' to 'newcode')
                            // 4. It's a new function/control structure
                            if(lineIndex !== null && prevLineIndex !== -1 && ((lineIndex - prevLineIndex) > 100)){
                                console.log("LINE INDEX FAR ENOUGH APART");
                            }else{
                                console.log("LINE INDEX NOT FAR APART ");
                                console.log("LINEINDEX");
                                console.log(lineIndex);
                                console.log("prevLineIndex");
                                console.log(prevLineIndex);
                                console.log("LINEINDEX");
                                
                            }
                            
                            if (!currentBlock || 
                                (lineIndex !== null && prevLineIndex !== -1 && (lineIndex - prevLineIndex) > 100) || 
                                (currentBlock && replaceType !== currentBlock.replace_type && !(currentBlock.replace_type === 'skip' && replaceType === 'newcode')) ||
                                (scopeCategory === 'function' || scopeCategory === 'control_structure')) {

                                if (currentBlock) {
                                    llmRequestBlockArray.push(currentBlock);
                                    skipLines = [];
                                }

                                let blockStartIndex = lineIndex;
                                let blockStartCode = '';
                                if (replaceType === 'newcode' && skipLines.length > 0) {
                                    blockStartIndex = skipLines[0].index;
                                    blockStartCode = skipLines.map(line => line.content).join('\n') + '\n';
                                }
                                
                                let origFileCode = blockStartCode + (lineIndex !== null ? 
                                        originalFileContent.split(/\r?\n/).slice(lineIndex, endLineIndex).join('\n') : '');

                                currentBlock = {
                                    index: llmRequestBlockArray.length,
                                    replace_type: replaceType,
                                    file_path: updateFilePath,
                                    ext: theExt,                                    
                                    original_file_start: blockStartIndex !== null ? blockStartIndex + 1 : null,
                                    original_file_end: endLineIndex !== null ? endLineIndex + 1 : null,
                                    original_file_code: origFileCode,                                
                                    new_code: scope['all_lines'],
                                    scope_objects: []
                                };
                                console.log("original file code: ");
                                console.log(origFileCode);        
                                console.log("block");
                                console.log(currentBlock);
                            } else {
                                
                                // Extend the current block
                                if(currentBlock && currentBlock.replace_type == 'skip'){
                                    console.log("skipping existing skipblock now");
                                    //do same as above starting a new block                                    
                                    let blockStartIndex = lineIndex;
                                    let blockStartCode = '';
                                    if (replaceType === 'newcode' && skipLines.length > 0) {
                                        blockStartIndex = skipLines[0].index;
                                        blockStartCode = skipLines.map(line => line.content).join('\n') + '\n';
                                    }

                                    let origFileCode = blockStartCode + (lineIndex !== null ? 
                                            originalFileContent.split(/\r?\n/).slice(lineIndex, endLineIndex).join('\n') : '');

                                    currentBlock = {
                                        index: llmRequestBlockArray.length,
                                        replace_type: replaceType,
                                        file_path: updateFilePath,
                                        ext: theExt,                                    
                                        original_file_start: blockStartIndex !== null ? blockStartIndex + 1 : null,
                                        original_file_end: endLineIndex !== null ? endLineIndex + 1 : null,
                                        original_file_code: origFileCode,                                
                                        new_code: scope['all_lines'],
                                        scope_objects: []
                                    };                                    
                                }
                                else{
                                    console.log("extending the current block to new endLineIndex " + endLineIndex);
                                    currentBlock.original_file_end = endLineIndex !== null ? 
                                        Math.max(currentBlock.original_file_end, endLineIndex + 1) : null;
                                    if (lineIndex !== null) {
                                        let additionalLines = originalFileContent.split(/\r?\n/).slice(prevLineIndex + 1, endLineIndex + 1).join('\n');
                                        currentBlock.original_file_code += '\n' + additionalLines;
                                    }
                                    currentBlock.new_code += '\n' + scope['all_lines'];
                                }
                            }

                            currentBlock.scope_objects.push(scope);

                            if (replaceType === 'skip') {
                                skipLines.push({
                                    index: lineIndex,
                                    content: originalFileContent.split(/\r?\n/)[lineIndex]
                                });
                            } else {
                                skipLines = [];
                            }

                            prevLineIndex = endLineIndex !== null ? endLineIndex : prevLineIndex;
                        }

                        if (currentBlock) {
                            llmRequestBlockArray.push(currentBlock);
                        }
                    }
                }
            }

            console.log("LLM REQUEST BLOCK ARRAY ");
            console.log(llmRequestBlockArray);                

            // Prepare to send ChatGPT requests in parallel
            // Array to hold promises
            let chatgptPromises = llmRequestBlockArray.map((block, index) => {
                const taskId = index; // Use index as the taskId
                return (async () => {
                    
                    console.log("clearing task id: " + taskId);
                    taskLogs[taskId] = [];

                    // Use addLog instead of console.log
                    const blocklog = (...args) => addLog(taskId, ...args);    
                    blocklog("Processing block");
                    blocklog(block);
                    let retriesLeft = 3;
                    let operationType = block['replace_type'];
                    let llmRequestFile = block['file_path'];
                    let llmExt = block['ext'];
                    let partialFileCode = block['original_file_code'];                    
                    let newCode = block['new_code'];
                    let originalFileStart = block['original_file_start'];
                    let originalFileEnd = block['original_file_end'];
                    
                    //what if we modified the message
                    let modifiedAssistantMessageArr = DIFFR.removeNonmatchingCodeFromMessage(assistantMessage, justFilesLinux, llmRequestFile);
                    let modifiedAssistantMessage = modifiedAssistantMessageArr['modifiedMessage'];

                    let responseData = null;
                    if(operationType == 'full_file'){
                        // Full file replacement
                        blocklog("Processing full file replacement for " + llmRequestFile);
                        let newFileResponse = await CHATGPT.singleFileFullChange(llmRequestFile, partialFileCode, assistantMessage, tabUid);
                        // Handle potential errors and retries
                        if(STUI.hasChatGPTError(newFileResponse, true)){
                            let retrySucceeded = false;
                            while(retriesLeft > 0 && CHATGPT.SWITCH_LLM(tabUid)){
                                blocklog("RETRYING STEP 1");  
                                retriesLeft--;
                                newFileResponse = await CHATGPT.singleFileFullChange(llmRequestFile, partialFileCode, assistantMessage, tabUid);
                                if(!STUI.hasChatGPTError(newFileResponse, true)){
                                    retrySucceeded = true;
                                    break;              
                                }
                            }        
                            if(!retrySucceeded){
                                throw new Error("Error communicating with LLM for Apply Changes");
                            }
                        }
                        let modFile = newFileResponse['response'];

                        responseData = {
                            index: block.index, 
                            file_path: llmRequestFile,
                            operationType: 'full_file',
                            modFile: modFile,
                        };
                    } 
                    else if(operationType == 'replace'){
                        // Send the LLM the code in the original file and get the replacement code
                        let replaceRequest;
                        if(STUBS.APPLY_PARTIAL_NOMESSAGE){
                            let originalSection = partialFileCode;
                            console.log("DOING NOMESSAGE PARTIAL");
                            console.log("originalSection");
                            console.log(originalSection);
                            console.log("newCode");
                            console.log(newCode);
                            // Normalize both contents (remove whitespace at start/end of lines)
                            let newcodeNormalized = newCode.split('\n').map(line => line.trim()).join('\n');
                            let originalSectioNormalized = originalSection.split('\n').map(line => line.trim()).join('\n');                            
                            if(newcodeNormalized === originalSectioNormalized){
                                if(!STUBS.isPackaged){
                                    alert("LLM GAVE US SAME EXACT CODE IN THIS SECTION");
                                }
                                replaceRequest = {
                                    'response': originalSection,   
                                    'success': 'false'
                                };
                            }else{
                                replaceRequest = await CHATGPT.singleFilePartialChangeNoMessage(llmRequestFile, originalSection, newCode, tabUid);
                                console.log("replace request");
                                console.log(replaceRequest);
                                // Handle potential errors and retries
                                if(STUI.hasChatGPTError(replaceRequest, true)){
                                    console.log("newcode HAS AN ERROR ");
                                    
                                    let retrySucceeded = false;
                                    while(retriesLeft > 0 && CHATGPT.SWITCH_LLM(tabUid)){
                                        blocklog("RETRYING STEP NOMESSAGE PARTIAL");  
                                        retriesLeft--;
                                        replaceRequest = await CHATGPT.singleFilePartialChangeNoMessage(llmRequestFile, originalSection, newCode, tabUid);
                                        if(!STUI.hasChatGPTError(replaceRequest, true)){
                                            retrySucceeded = true;
                                            break;              
                                        }
                                    }        
                                    if(!retrySucceeded){
                                        throw new Error("Error communicating with LLM for Apply Changes");
                                    }
                                }                        
                            }
                        }else{
                            let replaceRequest = await CHATGPT.singleFilePartialChange(llmRequestFile, partialFileCode, modifiedAssistantMessage, tabUid);
                            // Handle potential errors and retries
                            if(STUI.hasChatGPTError(replaceRequest, true)){
                                retrySucceeded = false;
                                while(retriesLeft > 0 && CHATGPT.SWITCH_LLM(tabUid)){
                                    blocklog("RETRYING STEP PARTIAL");  
                                    retriesLeft--;
                                    replaceRequest = await CHATGPT.singleFilePartialChange(llmRequestFile, partialFileCode, modifiedAssistantMessage, tabUid);
                                    if(!STUI.hasChatGPTError(replaceRequest, true)){
                                        retrySucceeded = true;
                                        break;              
                                    }
                                }        
                                if(!retrySucceeded){
                                    throw new Error("Error communicating with LLM for Apply Changes");
                                }
                            }                              
                        }
                        
                        let replaceCode = replaceRequest['response'];

                        responseData = {
                            file_path: llmRequestFile,
                            operationType: 'replace',
                            replaceCode: replaceCode,
                            originalFileStart: originalFileStart,
                            originalFileEnd: originalFileEnd,
                            llmExt: llmExt
                        };
                    } else if(operationType == 'newcode'){                        
                        //Instead of asking the LLM to insert code, ask it if it's completely new code and if so the line to put it at...
                        //if it is not new code, give a start line and end line of window... then do a call just like the replace
                        
                        // Ask the LLM where to insert the new code
                        let stubFile = await SFILE.getStubFileContent(CHANGE_MY_PROJECT_NAME, llmRequestFile);
                        if(stubFile == null){
                            stubFile = readFileWithCache(path.join(CHANGE_MY_PROJECT_PATH, llmRequestFile));
                        }
                        let replaceRequest = await CHATGPT.newCodePlacement(llmRequestFile, newCode, stubFile, assistantMessage, tabUid);
                        // Handle potential errors and retries
                        if(!replaceRequest || CHATGPT.badFormalizeResponse(replaceRequest['orig_response'])){
                            console.log("BAD FORMALIZE RESPONSE");
                            console.log(replaceRequest);
                            let retrySucceeded = false;
                            while(retriesLeft > 0 && CHATGPT.SWITCH_LLM(tabUid)){
                                blocklog("RETRYING STEP 1");  
                                retriesLeft--;
                                replaceRequest = await CHATGPT.newCodePlacement(llmRequestFile, newCode, stubFile, assistantMessage, tabUid);
                                if(!STUI.hasChatGPTError(replaceRequest, true)){
                                    retrySucceeded = true;
                                    break;              
                                }
                            }        
                            if(!retrySucceeded){
                                throw new Error("Error communicating with LLM for Apply Changes");
                            }
                        }     
                        let replaceData = replaceRequest['response'];                                               
                        
                        responseData = {
                            file_path: llmRequestFile,
                            operationType: 'newcode',
                            replaceData: replaceData,
                            newCode: newCode,
                            llmExt: llmExt
                        };
                        let replaceOp = replaceData['operation'];                       
                        let stubLine = replaceData['stub_line'];                         
                        if(replaceOp == 'inside'){
                            //get the control structure for the stubLine
                            //use that instead of stubFile to ask for the marker needed to place code 
                            //newCode is same
                            //then update replaceData in the responseData with 
                            console.log("INSIDE WITH fullFileContent: " + llmRequestFile);
                            //let fullFileContent = await fs.readFile(llmRequestFile, 'utf8');  
                            let fullFileContent = readFileWithCache(path.join(CHANGE_MY_PROJECT_PATH, llmRequestFile));
                            
                            console.log(fullFileContent);                          
                            
                            let controlStructure = await DGRAPH.getLargestControlStructureForLine(llmRequestFile, stubLine, fullFileContent);
                            console.log("INSIDE control structure");
                            console.log(controlStructure);
                            if(controlStructure){
                                console.log("got control structure");
                                console.log(controlStructure);
                                let blockCode = fullFileContent.split(/\r?\n/).slice(controlStructure.startLine, controlStructure.endLine + 1).join('\n');    
                                console.log("finding place in block");
                                console.log(blockCode);
                                let secondReplaceRequest = await CHATGPT.newCodePlacement(llmRequestFile, newCode, blockCode, assistantMessage, tabUid);    
                                if(secondReplaceRequest && secondReplaceRequest['response']){
                                    console.log("updating responseData to ");
                                    console.log(secondReplaceRequest['response']);
                                    responseData['replaceData'] = secondReplaceRequest['response'];
                                }
                            }                            
                            
                        }
                        
                    } else if(operationType == 'skip'){
                        responseData = {
                            file_path: llmRequestFile,
                            operationType: 'skip'
                        };
                    }
                    blocklog("responseData is");
                    blocklog(responseData);

                    return responseData;
                })();
            });

            // Wait for all ChatGPT requests to complete
            let chatgptResponses = [];
            try {
                chatgptResponses = await Promise.all(chatgptPromises);
            } catch (error) {
                STUI.loaderError(error.message);
                return false;
            }

            // Group responses by file_path
            let responsesByFile = {};
            for(let responseData of chatgptResponses){
                const taskId = responseData.index; // Use the index as taskId
                const logs = taskLogs[taskId] || [];
                console.log('====================================');
                console.log(`Logs for file: ${responseData.file_path}`);
                for (let message of logs) {
                    console.log(message);
                }
                console.log('====================================');                
                let filePath = responseData.file_path;
                if(!responsesByFile[filePath]){
                    responsesByFile[filePath] = [];
                }
                responsesByFile[filePath].push(responseData);
            }

            // Now apply the changes per file
            for(let updateFilePath in responsesByFile){
                let modifiedContent = allFileChanges[updateFilePath]['file_content'];
                modifiedContent = modifiedContent.replace(/\r\n/g, '\n');
                let responses = responsesByFile[updateFilePath];
                console.log("processing parallel responses for file: " + updateFilePath);
                console.log(responses);

                // Sort responses by the order of blocks in llmRequestBlockArray
                // Assuming llmRequestBlockArray maintains the order
                responses.sort((a, b) => a.index - b.index);

                // Change to a traditional for-loop to get the index 'i'
                for(let i = 0; i < responses.length; i++){
                    let responseData = responses[i];
                    let operationType = responseData.operationType;
                    console.log("operation type " + operationType);

                    if(operationType == 'replace'){
                        let replaceCode = responseData.replaceCode;
                        let originalFileStart = responseData.originalFileStart;
                        let originalFileEnd = responseData.originalFileEnd;
                        let llmExt = responseData.llmExt;

                        // Replace the content in modifiedContent
                        
                        let contentLines = modifiedContent.split(/\r?\n/);

                        // Handle indentation
                        let originalIndentation = '';
                        if (contentLines.length > 0 && originalFileStart >= 1) {
                            let theorigLine = contentLines[originalFileStart - 1];
                            if (theorigLine) {
                                const origmatch = theorigLine.match(/^\s*/);
                                if (origmatch) {
                                    originalIndentation = origmatch[0];
                                }
                            }
                        }                        

                        let replaceLines = replaceCode.split(/\r?\n/);

                        // Add the original indentation to the first line of replaceLines
                        if (replaceLines.length > 0) {
                            replaceLines[0] = originalIndentation + replaceLines[0];
                        }

                        // Replace the lines in modifiedContent
                        // KEEP CHANGING BACK BETWEEN THIS:
                        //contentLines.splice(originalFileStart - 1, originalFileEnd - originalFileStart, ...replaceLines);
                        
                        // AND THIS: 
                        contentLines.splice(originalFileStart - 1, originalFileEnd - originalFileStart + 1, ...replaceLines);
                        
                        modifiedContent = contentLines.join('\n');

                        // Calculate line difference
                        let lineDifference = replaceLines.length - (originalFileEnd - originalFileStart + 1);

                        // Update future block positions for this file
                        for(let block of llmRequestBlockArray){
                            if(block.file_path === updateFilePath && block.original_file_start > originalFileEnd) {
                                block.original_file_start += lineDifference;
                                block.original_file_end += lineDifference;
                            }
                        }

                        // Adjust line numbers in remaining responses
                        for(let j = i + 1; j < responses.length; j++){
                            let futureResponse = responses[j];

                            if(futureResponse.operationType == 'replace'){
                                if(futureResponse.originalFileStart > originalFileEnd){
                                    console.log("adjusting line difference: " + lineDifference);
                                    futureResponse.originalFileStart += lineDifference;
                                    futureResponse.originalFileEnd += lineDifference;
                                } else if(futureResponse.originalFileStart >= originalFileStart){
                                    // Future response overlaps with current modified lines
                                    console.warn("Future replace operation overlaps with current modified lines.");
                                }
                            }
                            // You can add adjustments for 'newcode' operations if needed
                        }

                    } else if(operationType == 'newcode'){
                        let replaceData = responseData.replaceData;
                        let newCode = responseData.newCode;
                        let llmExt = responseData.llmExt;
                        let replaceOp = replaceData['operation'];                       
                        let stubLine = replaceData['stub_line'];
                        let lastSkipIndex = 0; // Adjust as needed

                        newCode = newCode.replace(/\r\n/g, '\n');

                        // Find the index where to insert the new code
                        let replaceIndex = getLineIndex(modifiedContent, stubLine, lastSkipIndex);
                        let exactMatch = true;
                        let bestMatch = null;
                        if (replaceIndex === null) {
                            exactMatch = false;
                            bestMatch = getLineAndSimilarity(modifiedContent, stubLine, lastSkipIndex);
                            if (bestMatch) {                                
                                replaceIndex = bestMatch.index;
                            }
                        }        
                        if(replaceIndex == null){
                            console.log("Could not find stub line given for insert. Inserting at line 0.");
                            replaceIndex = 0;
                        } else if(replaceOp == 'outside-above'){
                            console.log("doing outside-above");
                            replaceIndex--;
                            if(replaceIndex < 0){
                                replaceIndex = 0;
                            }
                        } else if(replaceOp == 'outside-below'){
                            console.log("OUTSIDE BELOW MEANING WE HAVE TO FIND BOTTOM SCOPE: ");
                            console.log(stubLine);
                            console.log("IN: " + updateFilePath + " with " + llmExt);

                            if(llmExt == 'css' || llmExt == 'styl'){
                                let stubLineIndex = replaceIndex;
                                console.log("outsidebelow css styl stubline index: ");
                                console.log(stubLineIndex);
                                if(stubLineIndex !== null){
                                    let ruleScope = await WEBFILE.getCSSRuleScopeForLine(modifiedContent, stubLineIndex);
                                    console.log("got rule scope");
                                    console.log(ruleScope);                                    
                                    let totalLines = (ruleScope.endLine - ruleScope.startLine) + 1;
                                    replaceIndex += totalLines;                            
                                    console.log("replace index added totalLines " + totalLines + " and now: " + replaceIndex); 
                                }
                            }else if(DGRAPH.markupExtensions.includes(llmExt)){
                                console.log("outsidebelow html stubline index: " + replaceIndex);
                                const result = await TREESIT.getHtmlElementScopeForLine(modifiedContent, replaceIndex);
                                let htmlStructure = null;
                                if (result === null) {
                                    console.log("HTML parsing timed out, using fallback222");
                                    htmlStructure = await WEBFILE.getHtmlScopeFallback(modifiedContent, replaceIndex + 1);
                                } else {
                                    htmlStructure = result;
                                }                      
                                console.log("got html scope");
                                console.log(htmlStructure);                                    
                                let totalLines = (htmlStructure.endLine - htmlStructure.startLine) + 1;
                                replaceIndex += totalLines;                            
                                console.log("replace index added totalLines " + totalLines + " and now: " + replaceIndex);                                   
                            }else{
                                let controlStructure = await DGRAPH.getControlStructureForLine(updateFilePath, stubLine, modifiedContent, bestMatch);
                                if(controlStructure){
                                    console.log("got control structure");
                                    console.log(controlStructure);
                                    let totalLines = (controlStructure.endLine - controlStructure.startLine);
                                    replaceIndex += totalLines + 1;                            
                                    console.log("replace index added totalLines " + totalLines + " and now: " + replaceIndex);                            
                                }else{
                                    console.log("ERROR - NO CHANGE APPLIED BECAUSE CONTROL STRUCTURE NOT FOUND");
                                }
                            }
                        }else{
                            console.log("unknown response type");
                        }

                        // Insert the new code at the specified line number
                        let contentLines = modifiedContent.split(/\r?\n/);
                        let newCodeLines = newCode.split(/\r?\n/);
                        contentLines.splice(replaceIndex, 0, ...newCodeLines);
                        modifiedContent = contentLines.join('\n');

                        // Calculate line difference (number of lines added)
                        let lineDifference = newCodeLines.length;

                        // Update future block positions for this file
                        for(let block of llmRequestBlockArray){
                            if(block.file_path === updateFilePath && block.original_file_start > replaceIndex) {
                                block.original_file_start += newCodeLines.length;
                                block.original_file_end += newCodeLines.length;
                            }
                        }

                        // Adjust line numbers in remaining responses
                        for(let j = i + 1; j < responses.length; j++){
                            let futureResponse = responses[j];
                            if(futureResponse.operationType == 'replace'){
                                if(futureResponse.originalFileStart > replaceIndex){
                                    futureResponse.originalFileStart += lineDifference;
                                    futureResponse.originalFileEnd += lineDifference;
                                }
                            }
                            // Adjust 'newcode' operations if they rely on line numbers
                        }

                    } 
                    else if(operationType == 'full_file'){
                        // Just replace the entire file content
                        modifiedContent = responseData.modFile;

                        // Since we replaced the entire file, remaining operations may not be valid
                        console.warn("Full file replacement occurred, skipping remaining responses for " + updateFilePath);
                        break; // Exit the loop for this file
                    }
                    else if(operationType == 'skip'){
                        console.log("Skipping this code block because it already exists");
                    }
                    console.log("after " + operationType + " modified content: ");
                    console.log(modifiedContent);
                }
                // Update the necessary arrays per file
                allFileChanges[updateFilePath]['mod_content'] = modifiedContent;
                modifiedCodeArr[updateFilePath] = modifiedContent;
                originalCode[updateFilePath] = allFileChanges[updateFilePath]['file_content'];
                originalProjectData[updateFilePath] = {
                    project_name: CHANGE_MY_PROJECT_NAME,
                    project_path: CHANGE_MY_PROJECT_PATH,
                    is_new: false
                };
            }



        }        

        console.log("PIECEMEAL loading new diffs");
        console.log("Original code");
        console.log(originalCode);
        console.log("orig project data");
        console.log(originalProjectData);
        console.log("modified code");
        console.log(modifiedCodeArr);            

        // Prepare formal changes
        let formalChangesWithLine = new Array();
        if (existingEditors) {
            if(!STUBS.isPackaged){ 
                alert("Updating Existing editors");
            }
            // Use the existing editors to update instead of creating new ones
            await updateExistingEditors(existingEditors, allFileChanges, tabUid);
        } else {
            if(Object.keys(originalCode).length > 0){
                DIFFR.loadNewDiffs(formalChangesWithLine, originalCode, modifiedCodeArr, originalProjectData, false, tabUid);
                piecemealChangesSucceeded = true;
            } else {
                if(!STUBS.isPackaged){ 
                    alert("PIECEMEAL WERE ATTEMPTED, BUT NOT APPLIED");
                }
                let warningH3 = '<h3 style="margin-top: 0px;">APPLY CHANGES ERROR</h3>';
                let warningSpan = '<span style="font-size:16px">The code by LLM could not be parsed or applied</span>';
                $('.loader_problem_warning').append(warningH3); 
                $('.loader_problem_warning').append(warningSpan);                     
                
            }        
        }
    }
        
    
    return piecemealChangesSucceeded;
};



var doSyntaxChecking = async function(originalCode, modifiedCodeArr, originalProjectData, tabUid){
    
    //maybe enable button if syntax check fails on these?
    
    for(let theFileKey in modifiedCodeArr){
        let theFileContent = modifiedCodeArr[theFileKey];    
        let theFilePath = theFileKey;
        console.log("checking syntax of file: " + theFilePath);
        let ext = path.extname(theFilePath).slice(1);
        if(DGRAPH.markupExtensions.includes(ext)){
            console.log("syntax check html???");
        }
        else if(ext == 'css'){
            console.log("syntax check css???");            
        }
        else{
            console.log("syntax check file: " + theFilePath);
            TREESIT.syntaxCheck(theFileContent, theFilePath).then(result => {
                console.log("result of syntax check");
                console.log(result);
            }).catch(error => {
              console.error("Error during syntax check:", error);
            });            
        }                    
    }        
};


function codeContainsTargetCode(codeContent, targetCode){
  const codeLines = codeContent.split(/\r?\n/).map(line => line.trim()).filter(line => line !== '');
  const targetLines = targetCode.split(/\r?\n/).map(line => line.trim()).filter(line => line !== '');

  // Find all potential starting indices
  const potentialStartIndices = codeLines.reduce((indices, line, index) => {
    if (line === targetLines[0]) {
      indices.push(index);
    }
    return indices;
  }, []);

  // Check each potential starting point
  for (let startIndex of potentialStartIndices) {
    let allLinesMatch = true;

    for (let j = 0; j < targetLines.length; j++) {
      if (startIndex + j >= codeLines.length) {
        allLinesMatch = false;
        break;
      }

      const codeLine = codeLines[startIndex + j];
      const targetLine = targetLines[j];

      if (codeLine !== targetLine) {
        allLinesMatch = false;
        break;
      }
    }

    if (allLinesMatch) {
      return true;
    }
  }

  return false;
};

function shouldSkipScope(originalContent, scopeLines) {
    const originalLines = originalContent.split(/\r?\n/);
    const firstScopeLine = scopeLines[0].trim();

    // Find all potential starting indices
    const potentialStartIndices = originalLines.reduce((indices, line, index) => {
        if (line.trim() === firstScopeLine) {
            indices.push(index);
        }
        return indices;
    }, []);

    console.log(`Found ${potentialStartIndices.length} potential start indices for: "${firstScopeLine}"`);

    // Check each potential starting point
    for (let startIndex of potentialStartIndices) {
        console.log(`Checking start index: ${startIndex}`);
        let allLinesMatch = true;

        for (let j = 0; j < scopeLines.length; j++) {
            if (startIndex + j >= originalLines.length) {
                console.log(`Reached end of original content at line ${startIndex + j}`);
                allLinesMatch = false;
                break;
            }

            const originalLine = originalLines[startIndex + j].trim();
            const scopeLine = scopeLines[j].trim();

            if (originalLine !== scopeLine) {
                console.log(`Mismatch at line ${startIndex + j}`);
                console.log(`Original: "${originalLine}"`);
                console.log(`Scope:    "${scopeLine}"`);
                allLinesMatch = false;
                break;
            }
        }

        if (allLinesMatch) {
            console.log(`Full match found starting at line ${startIndex}`);
            return true;
        }
    }

    console.log("No full match found for the scope");
    return false;
}