var DIFFR = {};

const extToCodeMirrorLang = {
  'js': 'javascript',
  'c': 'clike',
  'cs': 'clike',
  'cpp': 'clike',
  'css': 'css',
  'html': 'htmlmixed',
  'go': 'go',
  'java': 'clike',
  'php': 'php',
  'py': 'python',
  'rb': 'ruby',
  'rs': 'rust',
  'styl': 'stylus',
  'vue': 'vue',
  'tpl': 'htmlmixed',
  'xml': 'xml',
  'jsx': 'jsx',
  'dart': 'dart',
  'sql': 'sql',
  'swift': 'swift',
  'pl': 'perl',
  'scala': 'clike',
  'kt': 'clike',
  'kts': 'clike',
  'm': 'clike',
  'h': 'clike',
  'ts': 'javascript',
  'tsx': 'javascript'
};
/*
  'lua': 'lua',
  'hs': 'haskell',
  'clj': 'clojure',
  'cljs': 'clojure',
  'cljc': 'clojure',
  'groovy': 'groovy',
  'ex': 'elixir',
  'exs': 'elixir',
  'erl': 'erlang',
  'yaml': 'yaml',
  'yml': 'yaml'
 */


/*
    <script src="jslib/mode/xml/xml.js"></script>
    <script src="jslib/mode/javascript/javascript.js"></script>
    <script src="jslib/mode/css/css.js"></script>
    <script src="jslib/mode/htmlmixed/htmlmixed.js"></script>    
    <script src="jslib/mode/vue/vue.js"></script>
    <script src="jslib/mode/jsx/jsx.js"></script>  
    <script src="jslib/mode/php/php.js"></script>  
    <script src="jslib/mode/dart/dart.js"></script>  
    <script src="jslib/mode/go/go.js"></script>  
    <script src="jslib/mode/python/python.js"></script>  
    <script src="jslib/mode/ruby/ruby.js"></script>  
    <script src="jslib/mode/rust/rust.js"></script>  
    <script src="jslib/mode/sql/sql.js"></script>  
    <script src="jslib/mode/stylus/stylus.js"></script>  
    <script src="jslib/mode/swift/swift.js"></script>  
    <script src="jslib/mode/smarty/smarty.js"></script>  
    <script src="jslib/mode/clike/clike.js"></script>  
    <script src="jslib/mode/perl/perl.js"></script>      
*/

DIFFR.handlersCreated = false;

DIFFR.emptyExistingDiffs = function(){
    
};

DIFFR.currentEditorIndex = 0;
DIFFR.currentLineIndex = 0;
DIFFR.searchVal = "";
DIFFR.dmp = null;

DIFFR.setupHandlers = function(){
    if(DIFFR.handlersCreated){
        return;
    }
    
    $('body').on('click', '.accept_changes', function(){
        let listItem = parseInt(this.id.split("_")[2]);
        let tabUid = this.id.split("_")[1];
        let changeIndex = listItem - 1;        
        console.log("accepting changes:" + changeIndex);

        let currTab = TABS.getTabByUid(tabUid);   
        let currIndex = TABS.getIndexByUid(tabUid);
        let theFilename = currTab['diff']['filename_arr'][changeIndex];
        let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];
        
        let allMatchingChanges = new Array();
        let isNewFile = false;
        if(theFilename in currTab['diff']['filename_matching_changes']){
            let allMatchingChanges = currTab['diff']['filename_matching_changes'][theFilename];
            console.log("Accepting changes - found formal changes for file");
            console.log(allMatchingChanges);
            for(let a in allMatchingChanges){
                if(allMatchingChanges[a]['insertion_type'] == 'create-file' || allMatchingChanges[a]['insertion_type'] == 'create-new'){
                    isNewFile = true;
                } 
                console.log("a change");
                console.log(a);
                console.log(allMatchingChanges[a]);
            }
        }else{
            console.log("Accepting Changes - did not find formal changes");
        }
        
        if (!mergeView) {
            console.error("No merge view found for index: " + changeIndex);
            return;
        }
        console.log("thefilename");
        console.log(theFilename);
        console.log("project data array");
        console.log(currTab['diff']['project_data_arr']);
        

        let myEditor = mergeView.getVisibleEditor();
        let newFileValue = myEditor.getDoc().getValue();
        let oldFileValue = currTab['diff']['orig_file_arr'][theFilename];
        let editProjectPath = currTab['diff']['project_data_arr'][theFilename]['project_path'];
        
        let editFilepath = path.normalize(path.join(editProjectPath, theFilename));
        
        //console.log("old file value");
        //console.log(oldFileValue);
        //console.log("new file value");
        //console.log(newFileValue);
        
        //console.log("THE REAL PATH");
        //console.log(editFilepath);
        if(!fs.existsSync(editFilepath) && !isNewFile){
            alert("Warning: Filepath could not be found " + editFilepath + ". Creating new file.");            
        }
        
        fs.writeFileSync(editFilepath, newFileValue);
        $(this).css('display', 'none');        
        $('#diffdiscard_' + tabUid + '_' + listItem).css('display', 'none');
        
        //unhide the undo button
        $('#diffundo_' + tabUid + '_' + listItem).css('display', 'block');
        
        
        $('#diffcontainer_' + tabUid + '_' + listItem).find('diff_collapseicon').html('<i class="chevron-icon ti ti-chevron-right"></i>');        
        $('#diffmap_' + tabUid + '_' + listItem).css('display', 'none');
        
        
        //slide up this element...
        $('#diffcode_' + tabUid + '_' + listItem).slideUp();
        
        TABS.TAB_ARR[currIndex]['diff']['accepted_changes'][changeIndex] = 1;  
        
    });
  
    $('body').on('click', '.discard_changes', function(){
        let listItem = parseInt(this.id.split("_")[2]);
        let tabUid = this.id.split("_")[1];
        let changeIndex = listItem - 1;
        console.log("discarding changes:" + changeIndex);

        let currTab = TABS.getTabByUid(tabUid);   
        let currIndex = TABS.getIndexByUid(tabUid);
        let theFilename = currTab['diff']['filename_arr'][changeIndex];
        let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];

        if (!mergeView) {
            console.error("No merge view found for index: " + changeIndex);
            return;
        }

        let originalCode = currTab['diff']['orig_file_arr'][theFilename];
        mergeView.getVisibleEditor().getDoc().setValue(originalCode);

        $(this).css('display', 'none');        
        $('#diffaccept_' + tabUid + '_' + listItem).css('display', 'none');

        //unhide the undo button
        $('#diffundo_' + tabUid + '_' + listItem).css('display', 'block');


        $('#diffcontainer_' + tabUid + '_' + listItem).find('diff_collapseicon').html('<i class="chevron-icon ti ti-chevron-right"></i>');        
        $('#diffmap_' + tabUid + '_' + listItem).css('display', 'none');


        //slide up this element...
        $('#diffcode_' + tabUid + '_' + listItem).slideUp();
    });  
    
    //aka sparkles or magic
    //< 500 lines do whole file, more than 500 do formalize 
    
    /*
    $('body').on('click', '.repair_diff', async function(){
        let listItem = parseInt(this.id.split("_")[2]);
        let tabUid = this.id.split("_")[1];
        let changeIndex = listItem - 1;        
        let currTab = TABS.getTabByUid(tabUid);   
        let currIndex = TABS.getIndexByUid(tabUid);
        let theFilename = currTab['diff']['filename_arr'][changeIndex];
        let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];
        let projectName = currTab['diff']['project_data_arr'][0];
        const { myProjectArr, myProjectPathArr, checkedProjectDescriptions } = SFILE.getProjectDataByName(projectName);
        
        console.log("repairing diff:" + changeIndex);
        let myEditor = mergeView.getVisibleEditor();
        
        // Show spinning icon and freeze editor
        $(this).html('<i class="ti ti-loader-quarter icon-spin"></i>');
        myEditor.setOption("readOnly", true);

        let originalCode = currTab['diff']['orig_file_arr'][theFilename];
        let modifiedCode = myEditor.getDoc().getValue();
        
        const lineCount = originalCode.split(/\r?\n/).length - 1; 
        if(lineCount < 300){
            let repairResponse = await CHATGPT.singleFileFullChange(theFilename, originalCode, modifiedCode, tabUid);
            if(repairResponse['success'] && repairResponse['response']){
                myEditor.getDoc().setValue(repairResponse['response']);
            }
        } else {
            
            console.log("Doing formalize placement for single file");
            let assistantMessage = currTab['llm_responses'][0];
            let justFilesLinux = currTab['diff']['filename_arr'];
            console.log("removing all other code blocks except " + theFilename);           
            
            let modifiedAssistantMessageArr = DIFFR.removeNonmatchingCodeFromMessage(assistantMessage, justFilesLinux, theFilename);
            let modifiedAssistantMessage = modifiedAssistantMessageArr['modifiedMessage'];      
            console.log("modified message: ");
            console.log(modifiedAssistantMessage);
            
            //await applyPiecemealCodeChanges(currentUid, assistantMessage, myProjectPathArr, myProjectArr, TABS.TAB_ARR[tabIndex]['just_files_linux'], myProjectArr, myProjectPathArr, myProjectDescArr);
            //reapplyUsingFormalizedChanges
            
            let originalFileText = theFilename + '\n' + originalCode;
            let moreTasks = currTab['more_tasks'];
            let moreResponses = currTab['more_responses'];
            let moreUpdated = false;
            
            //CHATGPT.formalizeCodeChanges(singleFile, theTask, filesListText, assistantResponse, tabUid, moreTasks, moreResponses, moreUpdated){
            let formalizeTaskResponse = await CHATGPT.formalizeCodeChanges(true, currTab['task_text'], originalFileText, assistantMessage, tabUid, moreTasks, moreResponses, moreUpdated);
            if(formalizeTaskResponse['success'] && formalizeTaskResponse['response']){
                let formalChangeArr = formalizeTaskResponse['response'];
                
                for(let f = 0; f < formalChangeArr.length; f++){
                    formalChangeArr[f]['file_path'] = theFilename;
                }
                
                console.log("got response");
                console.log(formalChangeArr);
                
                
                let [modifiedCodeArr, formalChangesWithLine] = await DIFFR.getFileDiffs({[theFilename]: originalCode}, formalChangeArr, currTab['just_files_linux']);
                
                console.log("got file diffs");
                console.log(modifiedCodeArr);
                
                if(modifiedCodeArr[theFilename]){
                    myEditor.getDoc().setValue(modifiedCodeArr[theFilename]);
                }
            }
        }
        
        // Hide icon and unfreeze editor
        $(this).html('<i class="ti ti-sparkles"></i>');
        myEditor.setOption("readOnly", false);      
    });
    */
  
    $('body').on('click', '.undo_changes', function(){
        
        let tabUid = this.id.split("_")[1];
        let listItem = parseInt(this.id.split("_")[2]);       
        
        let currIndex = TABS.getIndexByUid(tabUid);
        let currTab = TABS.getTabByUid(tabUid);   
        let origFileArr = TABS.TAB_ARR[currIndex]['diff']['orig_file_arr'];
        
        console.log("origfilearr");
        console.log(origFileArr);

        let changeIndex = listItem - 1;
        let theFilename = currTab['diff']['filename_arr'][changeIndex];
        let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];
        let originalCode = currTab['diff']['orig_file_arr'][theFilename];
        
        console.log("revert this file");
        console.log(theFilename);
        
        console.log("to this code:");
        console.log(originalCode);
        
        // Set the editor content back to the original code
        mergeView.getVisibleEditor().getDoc().setValue(originalCode);

        // Write the original code back to the file
        let editProjectPath = currTab['diff']['project_data_arr'][theFilename]['project_path'];
        let editFilepath = path.normalize(path.join(editProjectPath, theFilename));
        fs.writeFileSync(editFilepath, originalCode);

        // Hide the undo button
        $(this).css('display', 'none');

        // Show the accept and discard buttons
        $('#diffaccept_' + tabUid + '_' + listItem).css('display', 'block');
        $('#diffdiscard_' + tabUid + '_' + listItem).css('display', 'block');

        // Reset the accepted changes flag
        TABS.TAB_ARR[currIndex]['diff']['accepted_changes'][changeIndex] = 0;
        
        // Expand the editor
        $('#diffcontainer_' + tabUid + '_' + listItem).find('.diff_collapseicon').html('<i class="chevron-icon ti ti-chevron-down"></i>');        
        $('#diffmap_' + tabUid + '_' + listItem).slideDown();
        $('#diffcode_' + tabUid + '_' + listItem).slideDown();        
       
    });
    
    $('body').on('click', '#diff_search_button', function(){
        let newSearchVal = $('#diff_search_input').val();
        
        if(DIFFR.searchVal == newSearchVal){
            //do not reset
        }else{
            DIFFR.currentEditorIndex = 0;
            DIFFR.currentLineIndex = 0;      
            DIFFR.searchVal = newSearchVal;
            $('#diff_search_button').text('Next');
        }

        var searchNextEditor = function() {
            let editor = TABS.TAB_ARR[TABS.CURRENT_INDEX]['diff']['codemirror_editor_arr'][DIFFR.currentEditorIndex];
            let cursor = editor.getSearchCursor(DIFFR.searchVal, CodeMirror.Pos(DIFFR.currentLineIndex, 0), {caseFold: true, multiline: true});
            
            if (cursor.find(false)) {
                editor.setSelection(cursor.from(), cursor.to());
                editor.scrollIntoView({from: cursor.from(), to: cursor.to()}, 20);
                DIFFR.currentLineIndex = cursor.to().line + 1;
            } else {
                DIFFR.currentEditorIndex++;
                DIFFR.currentLineIndex = 0;
                if (currentEditorIndex < TABS.TAB_ARR[TABS.CURRENT_INDEX]['diff']['codemirror_editor_arr'].length) {
                    searchNextEditor();
                } else {
                    currentEditorIndex = 0;
                    searchNextEditor();
                }
            }
        }
        
        searchNextEditor();
    });
    
    $('body').on('keypress', '#diff_search_input', function(e){
        
        if($(this).val() == DIFFR.searchVal){
            $('#diff_search_button').text('Next');
        }else{
            $('#diff_search_button').text('Search');            
        }
        
        if(e.which == 13) {
            $('#diff_search_button').trigger('click');        
        }
    });    
    
    $('body').on('click', '.mapitem', function(e){
        let idParts = $(this).attr('id').split('_');
        let tabUid = idParts[1];
        let diffIndex = parseInt(idParts[2], 10) - 1; // Convert to number and adjust index
        let lineIndex = $(this).data('lineindex');

        let tabIndex = TABS.getIndexByUid(tabUid);
        let currentTab = TABS.TAB_ARR[tabIndex];

        if (currentTab && currentTab['diff'] && Array.isArray(currentTab['diff']['codemirror_editor_arr'])) {
            let editor = currentTab['diff']['codemirror_editor_arr'][diffIndex];

            if (editor && typeof editor.scrollIntoView === 'function') {
                editor.scrollIntoView({line: lineIndex-1, ch: 0}, 20);
            } else {
                console.error('Editor not found at index:', diffIndex);
            }
        } else {
            console.error('Invalid tab structure or missing editor array');
        }
    });

    $('body').on('click', '.diff_collapseicon', function(){
        let tabUid = $(this).closest('.diff-container').attr('id').split('_')[1];
        let listItem = $(this).closest('.diff-container').attr('id').split('_')[2];

        if ($(this).find('i').hasClass('ti-chevron-right')){
            $(this).html('<i class="chevron-icon ti ti-chevron-down"></i>');
            $('#diffmap_' + tabUid + '_' + listItem).slideDown();
            $('#diffcode_' + tabUid + '_' + listItem).slideDown();
        }else {
            $(this).html('<i class="chevron-icon ti ti-chevron-right"></i>');
            $('#diffmap_' + tabUid + '_' + listItem).slideUp();
            $('#diffcode_' + tabUid + '_' + listItem).slideUp();
        }
    });  
    
    
    $('body').on('click', '.dropdown_changes', function() {
        console.log("showing dropdown");
        let idSplit = this.id.split('_');
        let dropdownId = 'dropdown_' + idSplit[1] + "_" + idSplit[2];

        let dropdown = $('#' + dropdownId);
        if (dropdown.css('display') === 'block') {
            dropdown.css('display', 'none');
        } else {
            dropdown.css('display', 'block');
        }
        console.log("toggling dropdown visibility... " + dropdownId);
    });
  
    $('body').on('click', '#accept_all_changes', function(){
      let currentTabUid = TABS.TAB_ARR[TABS.CURRENT_INDEX].uid;
        $('.accept_changes').each(function(){
            let tabUid = $(this).attr('id').split('_')[1];
            let diffContainerId = $(this).closest('.diff-container').attr('id');
            if (tabUid === currentTabUid && diffContainerId.startsWith(`diffcontainer_${currentTabUid}`)) {
                $(this).trigger('click');
            }
        });
    });
    
    $('body').on('click', '.repair_diff', async function () {
        let listItem = parseInt(this.id.split("_")[2]);
        let tabUid = this.id.split("_")[1];
        let currTab = TABS.getTabByUid(tabUid);
        let changeIndex = listItem - 1;
        let theFilename = currTab['diff']['filename_arr'][changeIndex];
        let originalCode = currTab['diff']['orig_file_arr'][theFilename];
        const lineCount = originalCode.split(/\r?\n/).length - 1;

        if (lineCount < 300) {
            await reapplyFullFileChange(listItem, tabUid);
        } else {
            await reapplyFormalizeChange(listItem, tabUid);
        }
    });

    $('body').on('click', '.reapply_formalize', async function () {
        let listItem = $(this).data('listitem');
        let tabUid = $(this).data('tabuid');
        let dropdown = $(this).closest('.other-dropdown');
        dropdown.css('display', 'none');        
        await reapplyFormalizeChange(listItem, tabUid);
    });

    $('body').on('click', '.reapply_fullfile', async function () {
        let listItem = $(this).data('listitem');
        let tabUid = $(this).data('tabuid');
        let dropdown = $(this).closest('.other-dropdown');
        dropdown.css('display', 'none');        
        await reapplyFullFileChange(listItem, tabUid);
    });
    
    $('body').on('click', '.reapply_piecemeal', function() {
        let listItem = $(this).data('listitem');
        let tabUid = $(this).data('tabuid');
        let changeIndex = listItem - 1;
        
        let currTab = TABS.getTabByUid(tabUid);
        let currIndex = TABS.getIndexByUid(tabUid);
        let theFilename = currTab['diff']['filename_arr'][changeIndex];
        let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];        
        let dropdown = $(this).closest('.other-dropdown');
        dropdown.css('display', 'none');           
        
        let myEditor = mergeView.getVisibleEditor();
        let modifiedCode = myEditor.getValue();
        
        // Call applyPiecemealCodeChanges with the necessary parameters
        applyPiecemealCodeChanges(
            tabUid,
            currTab['llm_responses'][0],
            currTab['diff']['project_data_arr'][theFilename]['project_path'],
            [theFilename],
            currTab['just_files_linux'],
            currTab['diff']['project_data_arr'][theFilename]['project_name'],
            currTab['diff']['project_data_arr'][theFilename]['project_path'],
            currTab['project_desc'],
            { [theFilename]: myEditor }
        );
    });
    /*
                            <a href="#" class=" dropdown-item">Reapply Changes (Formalized Diff)</a>
                            <a href="#" class="reapply_piecemeal dropdown-item">Reapply Changes (Piecemeal)</a>
                            <a href="#" class="reapply_fullfile dropdown-item">Reapply Changes (Rewrite entire File)</a>    
    */
};


async function reapplyFullFileChange(listItem, tabUid) {
    let changeIndex = listItem - 1;
    let currTab = TABS.getTabByUid(tabUid);
    let currIndex = TABS.getIndexByUid(tabUid);
    let theFilename = currTab['diff']['filename_arr'][changeIndex];
    let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];
    let projectName = currTab['diff']['project_data_arr'][0];
    const { myProjectArr, myProjectPathArr, checkedProjectDescriptions } = SFILE.getProjectDataByName(projectName);

    console.log("Reapplying full file change for diff:", changeIndex);
    let myEditor = mergeView.getVisibleEditor();

    // Show spinning icon and freeze editor
    let repairButton = $('#diffrepair_' + tabUid + '_' + listItem);
    repairButton.html('<i class="ti ti-loader-quarter icon-spin"></i>');
    myEditor.setOption("readOnly", true);

    let originalCode = currTab['diff']['orig_file_arr'][theFilename];
    let modifiedCode = myEditor.getDoc().getValue();

    let repairResponse = await CHATGPT.singleFileFullChange(theFilename, originalCode, modifiedCode, tabUid);
    if (repairResponse['success'] && repairResponse['response']) {
        myEditor.getDoc().setValue(repairResponse['response']);
    }

    // Hide icon and unfreeze editor
    repairButton.html('<i class="ti ti-sparkles"></i>');
    myEditor.setOption("readOnly", false);
}

async function reapplyFormalizeChange(listItem, tabUid) {
    let changeIndex = listItem - 1;
    let currTab = TABS.getTabByUid(tabUid);
    let currIndex = TABS.getIndexByUid(tabUid);
    let theFilename = currTab['diff']['filename_arr'][changeIndex];
    let mergeView = currTab['diff']['codemirror_mergeview_arr'][changeIndex];
    let projectName = currTab['diff']['project_data_arr'][0];
    const { myProjectArr, myProjectPathArr, checkedProjectDescriptions } = SFILE.getProjectDataByName(projectName);

    console.log("Reapplying formalize change for diff:", changeIndex);
    let myEditor = mergeView.getVisibleEditor();

    // Show spinning icon and freeze editor
    let repairButton = $('#diffrepair_' + tabUid + '_' + listItem);
    repairButton.html('<i class="ti ti-loader-quarter icon-spin"></i>');
    myEditor.setOption("readOnly", true);

    let originalCode = currTab['diff']['orig_file_arr'][theFilename];
    let assistantMessage = currTab['llm_responses'][0];
    let justFilesLinux = currTab['diff']['filename_arr'];

    console.log("Removing non-matching code blocks except:", theFilename);
    let modifiedAssistantMessageArr = DIFFR.removeNonmatchingCodeFromMessage(assistantMessage, justFilesLinux, theFilename);
    let modifiedAssistantMessage = modifiedAssistantMessageArr['modifiedMessage'];
    console.log("Modified assistant message:", modifiedAssistantMessage);

    let originalFileText = theFilename + '\n' + originalCode;
    let moreTasks = currTab['more_tasks'];
    let moreResponses = currTab['more_responses'];
    let moreUpdated = false;

    let formalizeTaskResponse = await CHATGPT.formalizeCodeChanges(true, currTab['task_text'], originalFileText, assistantMessage, tabUid, moreTasks, moreResponses, moreUpdated);
    if (formalizeTaskResponse['success'] && formalizeTaskResponse['response']) {
        let formalChangeArr = formalizeTaskResponse['response'];

        // Update file paths in formal changes
        for (let f = 0; f < formalChangeArr.length; f++) {
            formalChangeArr[f]['file_path'] = theFilename;
        }

        console.log("Received formal changes:", formalChangeArr);

        let [modifiedCodeArr, formalChangesWithLine] = await DIFFR.getFileDiffs({ [theFilename]: originalCode }, formalChangeArr, currTab['just_files_linux']);

        console.log("Generated modified code:", modifiedCodeArr);

        if (modifiedCodeArr[theFilename]) {
            myEditor.getDoc().setValue(modifiedCodeArr[theFilename]);
        }
    }

    // Hide icon and unfreeze editor
    repairButton.html('<i class="ti ti-sparkles"></i>');
    myEditor.setOption("readOnly", false);
}


DIFFR.updateExistingEditors = async function(existingEditors, allFileChanges, tabUid) {
    for (let editorId in existingEditors) {
        let filePath = existingEditors[editorId];
        if (allFileChanges[filePath]) {
            let editor = CodeMirror.fromTextArea(document.getElementById(editorId));
            let originalContent = editor.getValue();
            let modifiedContent = allFileChanges[filePath]['mod_content'];

            // Apply changes to the existing editor
            editor.setValue(modifiedContent);

            // Create diff view
            let mergeView = CodeMirror.MergeView(document.getElementById(editorId), {
                value: modifiedContent,
                orig: originalContent,
                lineNumbers: true,
                mode: DIFFR.getEditorMode(filePath),
                highlightDifferences: true,
                connect: 'align',
                collapseIdentical: false
            });

            // Update the tab's diff information
            let currIndex = TABS.getIndexByUid(tabUid);
            TABS.TAB_ARR[currIndex]['diff']['codemirror_mergeview_arr'].push(mergeView);
            TABS.TAB_ARR[currIndex]['diff']['codemirror_editor_arr'].push(mergeView.editor());
            TABS.TAB_ARR[currIndex]['diff']['accepted_changes'].push(0);
        }
    }
};
DIFFR.getEditorMode = function(filePath) {
    let ext = path.extname(filePath).slice(1);
    return extToCodeMirrorLang[ext] || 'javascript';
};

DIFFR.showLoadingDiffs = function(){
    //show loading information
};

//do not do async because maybe editors would be created out of order???
DIFFR.createEditor = function(targetId, origFileCode, newFileCode, codemirrorMode, isPreview, tabUid, matchingFormalChanges){

    if(!codemirrorMode){
        codemirrorMode = "javascript";
    }

    var target = document.getElementById(targetId);
    target.innerHTML = "";
    let aMergeView = CodeMirror.MergeView(target, {
      value: origFileCode,
      orig: newFileCode,      
      origLeft: null,
      lineNumbers: true,
      mode: codemirrorMode,
      scrollbarStyle: "simple",
      highlightDifferences: true,
      allowEditingOriginals: true,      
      connect: "align",
      collapseIdentical: false,
      matchBrackets: true
    });

    //let currTab = TABS.getTabByUid(tabUid);   
    let currIndex = TABS.getIndexByUid(tabUid);
    TABS.TAB_ARR[currIndex]['diff']['codemirror_mergeview_arr'].push(aMergeView);
    let myEditor = aMergeView.getVisibleEditor();
    TABS.TAB_ARR[currIndex]['diff']['codemirror_editor_arr'].push(myEditor);
    TABS.TAB_ARR[currIndex]['diff']['accepted_changes'].push(0);
    
    
    setTimeout(function(){
        
        // Simulate typing a character at the start
        myEditor.replaceRange(' ', { line: 0, ch: 0 });

        // Immediately remove the character
        myEditor.replaceRange('', { line: 0, ch: 0 }, { line: 0, ch: 1 });

        let filenameIndex = targetId.split('_')[2];
        try{
            console.log("calculating line changes");
            const { linesAdded, linesRemoved } = DIFFR.calculateLineChanges(origFileCode, newFileCode);
            console.log("GOT LINES ADDED: " + linesAdded);
            console.log("GOT LINES REMOVED: " + linesRemoved);
             let extraHtml = `
               <span class="lines-added">+${linesAdded}</span>
               <span class="lines-removed">-${linesRemoved}</span>
             `;              
              console.log("adding to target: #diffcontainer_" + tabUid + "_" + filenameIndex);
              $('#diffcontainer_' + tabUid + "_" + filenameIndex).find('.diff_filenametext').append(extraHtml);                
        }catch(exx){
            console.log('could not calculate lines', exx);       
        }

        let lowestLineIndex = 0;
        let diffIndex = targetId.split('_')[2];
        let diffmapContainerId = "diffmap_" + tabUid + "_" + diffIndex;
        lowestLineIndex = DIFFR.createSquigglyLinks(diffmapContainerId, origFileCode, newFileCode, tabUid, diffIndex);        
        console.log("lowest line index: " + lowestLineIndex);   
        try{
            if(lowestLineIndex > 0){
                myEditor.scrollIntoView({ line: lowestLineIndex, ch: 0 });
            }   
        }catch(exx){
            console.log("exception");
            console.log(exx);
        }
        
        let debounceTimer;
        myEditor.on("change", function() {
            clearTimeout(debounceTimer);
            debounceTimer = setTimeout(function() {
                let newFileValue = myEditor.getDoc().getValue();
                const { linesAdded, linesRemoved } = DIFFR.calculateLineChanges(origFileCode, newFileValue);
                $('#diffcontainer_' + tabUid + "_" + filenameIndex).find('.lines-added').text("+" + linesAdded);
                $('#diffcontainer_' + tabUid + "_" + filenameIndex).find('.lines-removed').text("-" + linesRemoved);
            }, 1000);
        });        
    }, 100);   
};

DIFFR.loadNewDiffs = async function(formalizedChangesArr, origFileArr, modFileArr, projectDataArr, isPreview, tabUid){
    
    let currTab = TABS.getTabByUid(tabUid);   
    let currIndex = TABS.getIndexByUid(tabUid);
    TABS.TAB_ARR[currIndex]['diff'] = new Array();
    TABS.TAB_ARR[currIndex]['diff']['formalized_changes'] = formalizedChangesArr;
    TABS.TAB_ARR[currIndex]['diff']['orig_file_arr'] = origFileArr;
    TABS.TAB_ARR[currIndex]['diff']['mod_file_arr'] = modFileArr;
    TABS.TAB_ARR[currIndex]['diff']['project_data_arr'] = projectDataArr;
    TABS.TAB_ARR[currIndex]['diff']['filename_arr'] = new Array();
    TABS.TAB_ARR[currIndex]['diff']['filename_matching_changes'] = new Array();        
    TABS.TAB_ARR[currIndex]['diff']['codemirror_mergeview_arr'] = new Array();
    TABS.TAB_ARR[currIndex]['diff']['codemirror_editor_arr'] = new Array();
    TABS.TAB_ARR[currIndex]['diff']['accepted_changes'] = new Array();
    
    //make a code mirror instance for each 
    $('#difflist_container').html('');
    $('#difflist_container').css('display', 'block'); 
    $('#diffheader').css('display', 'flex');
    let k = 0;
    for(let aKey in modFileArr){
        let myIndex = k + 1;
        let filename = aKey;
        currTab['diff']['filename_arr'].push(filename);
        
        let matchingFormalChanges = new Array();
        let isNewFile = false;
        for(let f = 0; f < formalizedChangesArr.length; f++){
            let formalChange = formalizedChangesArr[f];
            if(formalChange['file_path'] == filename){
                if(formalChange['insertion_type'] == 'create-new' || formalChange['insertion_type'] == 'create-file'){
                    console.log("isnewfile: " );
                    console.log(formalChange);                    
                    if(formalChange['is_new']){
                        isNewFile = true;                        
                    }
                }
                matchingFormalChanges.push(formalChange);
            }
        }      
        TABS.TAB_ARR[currIndex]['diff']['filename_matching_changes'][filename] = matchingFormalChanges;
        
        let newFile = modFileArr[aKey];
        
        if(!(aKey in origFileArr)){
            console.log("we going to crash trying to load non-existant file");
            continue;
        }
        
        let oldFile = origFileArr[aKey];
        //console.log("new file content: ");
        //console.log(newFile);
        //console.log("old file content: ");
        //console.log(oldFile);
        
        let ext = path.extname(filename).slice(1);
        //STUBS.gotosleep(500);
        
        let codeMode = "javascript";
        if(ext in extToCodeMirrorLang){
            codeMode = extToCodeMirrorLang[ext];
        }
        let diffIndex = k + 1;
        let diffcodeContainerId = "diffcode_" + tabUid + "_" + diffIndex;
        /*
                    <div class="filename-bar">
                        ${filename}
                    </div>        
                    <div class="diff-control-panel" id="diffcontrol_${diffIndex}">        
                        <button id="difffix_${tabUid}_${diffIndex}" class="fix_diff button is-small"><i class="ti ti-bulldozer"></i></button>
                        <button id="diffedit_${tabUid}_${diffIndex}" class="edit_diff button is-small"><i class="ti ti-edit"></i></button>        
                        <button id="diffaccept_${tabUid}_${diffIndex}" class="accept_changes button is-link">Accept Changes</button>
                    </div>
         */
        let newFileText = "";
        if(isNewFile){
            newFileText = '<span>NEW FILE: </span>';
        }
        
        let diffContainerHtml = `
            <div class="diff-container" id="diffcontainer_${tabUid}_${diffIndex}">
                <div class="diff_buttonbar">
                    <div class="filename-bar">
                        <div class="diff_collapseicon">
                            <i class="chevron-icon ti ti-chevron-down"></i>
                        </div>
                        <div class="diff_filenametext">
                          ${newFileText}  ${filename}
                        </div>
                    </div>        
                    <div class="diff-control-panel stubs_scroll-cus scroll-sm" id="diffcontrol_${diffIndex}">     
                        <button id="diffrepair_${tabUid}_${diffIndex}" class="repair_diff"><i class="ti ti-sparkles"></i></button>
                        <button id="diffdiscard_${tabUid}_${diffIndex}" class="discard_changes"><i class="ti ti-x"></i></button>        
                        <button id="diffaccept_${tabUid}_${diffIndex}" class="accept_changes button is-small">Accept Changes</button>
                        <button id="diffundo_${tabUid}_${diffIndex}" class="undo_changes button is-small" style="display:none;">Undo</button>
                        <button id="diffdrop_${tabUid}_${diffIndex}" class="dropdown_changes"><i class="ti ti-dots-vertical"></i></button>
                        <div id="dropdown_${tabUid}_${diffIndex}" class="other-dropdown">
                            <a href="#" class="reapply_formalize dropdown-item" data-tabuid="${tabUid}" data-listitem="${diffIndex}">Reapply by Formalize</a>
                            <a href="#" class="reapply_piecemeal dropdown-item" data-tabuid="${tabUid}" data-listitem="${diffIndex}">Reapply Piecemeal</a>
                            <a href="#" class="reapply_fullfile dropdown-item" data-tabuid="${tabUid}" data-listitem="${diffIndex}">Reapply Whole File</a>
                        </div>
                    </div>
                </div>                      
                <div class="diff-codeandmap">
                    <div id="diffcode_${tabUid}_${diffIndex}" class="diff-code-panel" id="diffcode_${tabUid}_${diffIndex}">
                    </div>  
                    <div class="diff-map-panel" id="diffmap_${tabUid}_${diffIndex}">                       
                    </div>
                </div>
            </div>`;    
        $('#difflist_container').append(diffContainerHtml);
        STUBS.gotosleep(100);
        
        
        //console.log("creating code editor");
        //console.log(diffcodeContainerId);
        //console.log(oldFile);
        //console.log(newFile);
        //console.log(codeMode);
        //console.log(isPreview);
        //console.log(tabUid);
        //console.log(matchingFormalChanges);
        DIFFR.createEditor(diffcodeContainerId, oldFile, newFile, codeMode, isPreview, tabUid, matchingFormalChanges);
        k++;        
    }
    DIFFR.setupHandlers(tabUid);
    const editorCount = TABS.TAB_ARR[TABS.CURRENT_INDEX]['diff']['codemirror_editor_arr'].length;
    if (editorCount > 1) {
        $('#accept_all_changes').css('display', 'inline-block');
    }
};

DIFFR.getFileDiffs = async function(originalCode, jsonChanges, justFilesLinux) {
  const modifiedCode = {};
  const newLine = "\n";
  let changesWithLinePosition = new Array();
  let c = 0;
  for (const change of jsonChanges) {
    const filePath = change['file_path'];
    const fullPath = change['full_path'];
    let contiguousLines = change['contiguous_lines'];
    let insertionType = change['insertion_type'];
    let replaceLines = change['replace_lines'];
    console.log("processing change " + c + " - " + filePath);
    console.log(change);
    
    if(arrayHasPath(justFilesLinux, filePath) && (insertionType == 'create-file' || insertionType == 'create-new')){
        //can't create file, path already exists
        insertionType = 'add-below-line';
        replaceLines = "BAD COMMAND - TRIED TO CREATE FILE WHEN ALREADY EXISTS";        
    }

    if (insertionType == 'create-file' || insertionType == 'create-new'){
      modifiedCode[filePath] = contiguousLines;
      change['line_index'] = 0;
      change['is_new'] = true;
      changesWithLinePosition.push(change);
    } else {
      // Use the path comparison function to find the correct key
      //let originalKey = Object.keys(originalCode).find(key => comparePaths(key, filePath));
      let originalKey;
      for (const key of Object.keys(originalCode)) {
        console.log(`Comparing key: ${key} with filePath: ${filePath}`);
        if (comparePaths(key, filePath)) {
          console.log(`Match found! Key: ${key}`);
          originalKey = key;
          break;
        }
      } 
      
      if (originalKey) {
        let originalCodeForFile = modifiedCode[filePath] || originalCode[originalKey];
        let replaceIndex = null;
        if (typeof replaceLines === 'string') {
            replaceLines = replaceLines.split(/\r?\n/);
        }        
        let copyReplaceLines = replaceLines.slice(); 

        while (replaceIndex === null && copyReplaceLines.some(line => line.length > 0)) {
            console.log("Attempting to find fuzzy match...");
            const lineIndex = findFuzzyMatchLine(originalCodeForFile, copyReplaceLines);

            if (lineIndex !== -1) {
                // Found a match, now calculate start and end indices
                const originalLines = originalCodeForFile.split(/\r?\n/);
                const startIndex = originalLines.slice(0, lineIndex).join('\n').length + (lineIndex > 0 ? 1 : 0);
                const endIndex = startIndex + originalLines[lineIndex].length;

                replaceIndex = {
                    lineNumber: lineIndex,
                    start: startIndex,
                    end: endIndex
                };
            } else {
                // No match found, halve each line in copyReplaceLines
                copyReplaceLines = copyReplaceLines.map(line => line.slice(0, Math.ceil(line.length / 2)));
                console.log("COULD NOT FIND THE CODE LINE - HALVING EACH LINE FOR BETTER FUZZY MATCH");
            }
        }

        if (replaceIndex === null) {
            console.log("COULD NOT FIND THE CODE LINE - USING LAST LINE AS REPLACE INDEX");
            const lastLineIndex = originalCodeForFile.split(/\r?\n/).length - 1;
            replaceIndex = {
                lineNumber: lastLineIndex,
                start: originalCodeForFile.length,
                end: originalCodeForFile.length
            };
        }
        
        if(insertionType == 'add-below-line'){
            //chatgpt is stupid and uses add-below-line for add-below-block so often... assume below the function
            let myLines;
            if (Array.isArray(replaceLines)) {
                myLines = replaceLines.flatMap(item => item.split(/\r?\n/));
            } else {
                myLines = replaceLines.split(/\r?\n/);
            }
            let myfirstLine = myLines[0].trim();
            let isMyFunction = DGRAPH.isFunctionDefinition(filePath, myfirstLine);
            if(isMyFunction){
                console.log("CHANGING TO add-below-block because first line: " + myfirstLine + " is function");
                insertionType = 'add-below-block';
            }
        }
        
        if (replaceIndex == null) {
          console.log("COULD NOT FIND THE CODE LINE - USING LAST LINE AS REPLACE INDEX");
          replaceIndex = {
            lineNumber: originalCodeForFile.split(/\r?\n/).length - 1,
            start: originalCodeForFile.length,
            end: originalCodeForFile.length
          };
          insertionType = "add-below-line";
        }

        if(insertionType == 'add-below-block'){
          console.log("IN ADD BELOW BLOCK");
          let lines;
          if (Array.isArray(replaceLines)) {
              lines = replaceLines.flatMap(item => item.split(/\r?\n/));
          } else {
              lines = replaceLines.split(/\r?\n/);
          }          
          let searchLine = lines[0];
          console.log("searching for " + searchLine);
          console.log("in filepath (which is only used to get the extension) " + filePath);    
          let theExt = path.extname(filePath).slice(1);  

          if(DGRAPH.codeExtensions.includes(theExt)){
              let cStruct = await DGRAPH.getControlStructureForLine(filePath, searchLine, originalCodeForFile);
              console.log("result");
              console.log(cStruct);
              if(cStruct && cStruct.endLine && cStruct.endLine > 0){
                  let realEndline = cStruct.endLine + 1;
                  console.log("UPDATING REPLACE INDEX ENDLINE TO END OF BLOCK " + realEndline);
                  let originalLines = originalCodeForFile.split(/\r?\n/);
                  let endLineIndex = originalLines.slice(0, realEndline).reduce((sum, line) => sum + line.length + 1, 0) - 1;            
                  replaceIndex.start = endLineIndex;
                  replaceIndex.end = endLineIndex;     
                  replaceIndex.lineNumber = realEndline;
              }else{
                  console.log("CODE FILE - NO BLOCK REPLACE FOR CODE");
              }    
          }    
          else{
              //CSS FILE JUST GET NEXT 
              let nextEndBracket = originalCodeForFile.indexOf('}', replaceIndex.start);
              if (nextEndBracket !== -1) {
                  let ndiff = nextEndBracket - replaceIndex.start;
                  replaceIndex.start = nextEndBracket + 1;
                  replaceIndex.end = nextEndBracket + 1;     
                  replaceIndex.lineNumber = replaceIndex.lineNumber + ndiff + 1;           
              }else{
                  console.log("HTML/CSS FILE - NO BLOCK REPLACE FOR STYLE");
              }
          }
        }

        change['line_index'] = replaceIndex.lineNumber;
        change['is_new'] = false;
        changesWithLinePosition.push(change);

        const previousCode = originalCodeForFile.slice(0, replaceIndex.start);
        const nextCode = originalCodeForFile.slice(replaceIndex.end);
        const adjustedContiguousLines = adjustIndentation(previousCode, contiguousLines, nextCode);

        switch (insertionType) {
          case 'add-above-line':
            modifiedCode[filePath] = previousCode + newLine + adjustedContiguousLines + newLine + originalCodeForFile.slice(replaceIndex.start);
            break;
          case 'add-below-line':
            // Find the end of the current line
            let endOfLine = originalCodeForFile.indexOf('\n', replaceIndex.end);
            if (endOfLine === -1) {
              // If there's no newline after, append to the end of the file
              endOfLine = originalCodeForFile.length;
            }
            modifiedCode[filePath] = originalCodeForFile.slice(0, endOfLine) + newLine + adjustedContiguousLines + newLine + originalCodeForFile.slice(endOfLine);
            break;
          case 'add-below-block':
              let blockEnd = originalCodeForFile.indexOf('\n', replaceIndex.end);
              if (blockEnd === -1) {
                blockEnd = originalCodeForFile.length;
              }
              modifiedCode[filePath] = originalCodeForFile.slice(0, blockEnd) + newLine + adjustedContiguousLines + newLine + originalCodeForFile.slice(blockEnd);
              break;          
          case 'delete':
            modifiedCode[filePath] = originalCodeForFile.substring(0, replaceIndex.start) + originalCodeForFile.substring(replaceIndex.end);
            break;
          case 'replace':
            modifiedCode[filePath] = previousCode + adjustedContiguousLines + nextCode;
            break;
        }
      } else {
        console.log("COULD NOT FIND ORIGINAL CODE FILE " + filePath);
      }
    }
    c++;
  };
  
  console.log("final modified code");
  console.log(modifiedCode);
  

  return [modifiedCode, changesWithLinePosition];
};

function adjustIndentation(previousCode, newCode, nextCode) {
    console.log("adjustIndentation");
    //console.log("previousCode");
    //console.log(previousCode);
  // Find the indentation of the first line with text in previousCode (from the end)
  const previousLines = previousCode.trim().split(/\r?\n/);
  let previousIndent = null;
  for (let i = previousLines.length - 1; i >= 0; i--) {
    if (previousLines[i].trim()) {
        console.log("used line " + i + " which is " + previousLines[i]);
        
      previousIndent = previousLines[i].length - previousLines[i].trimStart().length;
      break;
    }
  }
   //console.log("nextCode");
  //console.log(nextCode);
  // Find the indentation of the last line with text in nextCode (from the beginning)
  const nextLines = nextCode.split(/\r?\n/);
  let nextIndent = null;
  for (let i = 0; i < nextLines.length; i++) {
    if (nextLines[i].trim()) {
      //console.log("used line " + i + " which is " + nextLines[i]);
      nextIndent = nextLines[i].length - nextLines[i].trimStart().length;
      break;
    }
  }

  
  
  console.log("Previous indent");
  console.log(previousIndent);
  console.log("next indent");
  console.log(nextIndent);

  // If the indentations match, use that as the desired indentation
  let desiredIndent = 0;
  if (previousIndent !== null && previousIndent === nextIndent) {
    desiredIndent = previousIndent;
  }
  else if(previousIndent !== null && nextIndent !== null && previousIndent > 0 && nextIndent > 0){
      desiredIndent = Math.min(previousIndent, nextIndent);
  }
  else{
      return newCode;
  }

  // Get the lowest indentation level of the new code lines
  const newLines = newCode.split(/\r?\n/);
  const minIndent = Math.min(...newLines
    .filter(line => line.trim())
    .map(line => line.length - line.trimStart().length)
  );
  
  if (minIndent > desiredIndent) {
    return newCode;
  }  
  console.log("ADDING SPACES TO CONTIGUOUS LINES");
  console.log("Amount: " + (desiredIndent - minIndent).toString());
  console.log(newCode);
  // Adjust the indentation of each line in the new code
  const adjustedLines = newLines.map(line => {
    if (line.trim()) {
      return ' '.repeat(desiredIndent - minIndent) + line;
    } else {
      return line;
    }
  });

  // Join the adjusted lines back into a single string
  const adjustedCode = adjustedLines.join('\n');
  
  console.log("returning adjusted code: ");
  console.log(adjustedCode);

  return adjustedCode;
}


function findFuzzyMatchLine(text, searchLines) {
    const textLines = text.split(/\r?\n/);
    for (let i = 0; i < searchLines.length; i++) {
        const searchLine = searchLines[i].trim();
        const lineIndex = textLines.findIndex(line => line.trim().includes(searchLine));
        if (lineIndex !== -1) {
            return lineIndex;
        }
    }
    return -1;
}

function findFuzzyMatchIndex(text, searchTerm) {
    try{
        let lines;
        if (Array.isArray(searchTerm)) {
            lines = searchTerm.flatMap(item => item.split(/\r?\n/));
        } else {
            lines = searchTerm.split(/\r?\n/);
        }

        // Finding the start index using the first line
        startIndex = text.indexOf(lines[0].trim());
        if (startIndex === -1) {
            // If no match is found, return an indication
            return null;
        }
        
        let lineNumber = text.substring(0, startIndex).split(/\r?\n/).length - 1;        

        // Initialize end index
        let endIndex = startIndex + lines[0].length;

        // Iterate over the lines to find the end index
        for (let i = 1; i < lines.length; i++) {
            let line = lines[i];
            let lineIndex = text.indexOf(line, endIndex);
            if (lineIndex !== -1) {
                endIndex = lineIndex + line.length;
            } else {
                break; // Stop if the line is not found
            }
        }

        return { lineNumber: lineNumber, start: startIndex, end: endIndex };
    }catch(exx){
        console.log("fuzzy match error");
        console.log("entire text");
        console.log(text);
        console.log(searchTerm);
    }
}

function getLineIndex(fullText, searchTerm, startFromLine = 0) {
  const lines = fullText.split(/\r?\n/);
  
  // First, try to find an exact match (whole trimmed line)
  const exactMatchIndex = lines.slice(startFromLine).findIndex(line => line.trim() === searchTerm);
  if (exactMatchIndex !== -1) {
    return exactMatchIndex + startFromLine;
  }
  
  // If no exact match, look for a line containing the search term
  const partialMatchIndex = lines.slice(startFromLine).findIndex(line => line.includes(searchTerm));
  if (partialMatchIndex !== -1) {
    return partialMatchIndex + startFromLine;
  }
  
  // If no match found, return null
  return null;
}

function getLineAndSimilarity(fullText, searchTerm, startFromLine = 0) {
  const lines = fullText.split(/\r?\n/);
  let bestMatch = { index: -1, score: 0 };
  lines.slice(startFromLine).forEach((line, index) => {
    const trimmedLine = line.trim();
    const similarity = calculateLevenshtein(trimmedLine, searchTerm);
    
    if (similarity > bestMatch.score) {
      let functionName = extractFunctionFromLine(trimmedLine);
      if(functionName == '$' || functionName == 'querySelector' || functionName == 'addEventListener'){
          functionName = "BADFUNCTIONNAME";
      }
      
      bestMatch = { 
        index: index + startFromLine, 
        score: similarity, 
        line: trimmedLine, 
        function_name: functionName 
      };
    }
  });
  return bestMatch.index !== -1 ? bestMatch : null;
}

function allLinesAreComment(text) {
    const lines = text.split(/\r?\n/);
    let inMultiLineComment = false;

    return lines.every(line => {
        line = line.trim();
        
        // Check for empty lines
        if (line === '') return true;

        // Check for single-line comments
        if (line.startsWith('//')) return true;

        // Check for multi-line comment start
        if (line.startsWith('/*')) {
            inMultiLineComment = true;
            return true;
        }

        // Check for multi-line comment end
        if (line.endsWith('*/') && inMultiLineComment) {
            inMultiLineComment = false;
            return true;
        }

        // If we're inside a multi-line comment, continue
        if (inMultiLineComment) return true;

        // If we reach here, it's not a comment
        return false;
    });
}

function calculateLevenshtein(str1, str2) {
  const longerLength = Math.max(str1.length, str2.length);
  if (longerLength === 0) return 1.0;
  const levenshteinDistance = levenshtein(str1, str2);
  return (longerLength - levenshteinDistance) / longerLength;
}

function levenshtein(str1, str2) {
  const m = str1.length;
  const n = str2.length;
  const dp = Array.from({ length: m + 1 }, () => Array(n + 1).fill(0));

  for (let i = 0; i <= m; i++) dp[i][0] = i;
  for (let j = 0; j <= n; j++) dp[0][j] = j;

  for (let i = 1; i <= m; i++) {
    for (let j = 1; j <= n; j++) {
      if (str1[i - 1] === str2[j - 1]) {
        dp[i][j] = dp[i - 1][j - 1];
      } else {
        dp[i][j] = Math.min(
          dp[i - 1][j - 1] + 1,
          dp[i][j - 1] + 1,
          dp[i - 1][j] + 1
        );
      }
    }
  }

  return dp[m][n];
}

//should be original code starting at first line that matches new code
DIFFR.simpleCodeChanges = function(originalCode, newCode) {
  const originalLines = originalCode.split(/\r?\n/);
  const newLines = newCode.split(/\r?\n/);
  const modifiedLines = [];

  let oldIndex = 0;
  let newIndex = 0;
  let isMatching = true;
  let matchCount = 0;
  let matchBreakIndex = -1;

  // Find the starting line of the function in the original code
  let previousLinesTemp = new Array();
  let previousLines = new Array();
  let postLines = new Array();
  const funcStartLine = newLines[0].trim();
  for (let i = 0; i < originalLines.length; i++) {
      console.log("XXXXXXXXXXXXX originalline");
      console.log(originalLines[i].trim());
      console.log("and");
      console.log(funcStartLine);
      previousLinesTemp.push(originalLines[i]);
      
    if (originalLines[i].trim() == funcStartLine) {
      console.log("first line match found");
      oldIndex = i;
      previousLines = previousLinesTemp;
      console.log("oldIndex now " + i);
      break;
    }
  }

  while (newIndex < newLines.length) {
    console.log(modifiedLines.join('\n'));
    const newLine = newLines[newIndex];
    console.log("oldIndex " + oldIndex);
    console.log("newIndex " + newIndex);
    console.log("newline ");
    console.log(newLine);

    if (newLine.includes('//...') || newLine.includes('// ...')) {
      // Find the next matching line in the original code
      let matchFound = false;
      for (let i = oldIndex; i < originalLines.length; i++) {
        if ((newLines.length > (newIndex + 1)) && originalLines[i].trim() === newLines[newIndex + 1].trim()) {
          // Include all the lines between the last matched line and the current matching line
          let test = originalLines.slice(oldIndex, i);
          console.log("adding old lines: ");
          console.log(test);
          modifiedLines.push(...originalLines.slice(oldIndex, i));
          oldIndex = i;
          //newIndex++;
          matchFound = true;
          break;
        }
      }
      if (!matchFound) {
        console.log("no match in new code... adding rest new lines");
        // If no matching line is found, add the remaining lines from the new code
        modifiedLines.push(...newLines.slice(newIndex));
        break;
      }
      console.log("inserted placeholder");
    } else {
      console.log("VS");
      if (oldIndex < originalLines.length){
          console.log(originalLines[oldIndex].trim());
      }else{
          console.log("OUT OF BOUNDS");
      }      
      if (oldIndex < originalLines.length && newLine.trim() == originalLines[oldIndex].trim()) {
        console.log("real match");          
        modifiedLines.push(newLine);
        oldIndex++;
        isMatching = true;
        matchCount++;
      } 
      else if(matchCount >= 3 && originalLines[oldIndex].trim().length > 5 && newLine.indexOf(originalLines[oldIndex].trim().substring(0, 4)) !== -1){
        console.log("mostly match");
        
        modifiedLines.push(newLine);
        oldIndex++;
        isMatching = true;
        matchCount++;                          
      }
      else {                   
         console.log("no match");
         matchCount = 0;
         //if no more placeholders, advance
         let noMorePlaceholders = !newLines.slice(newIndex).some(line => (line.includes('//...') || line.includes('// ...')) );
         
         //if 3 lines in a row match from matchBreakIndex+1 to current newIndex from newLines to the originalLines oldIndex to future lines, then the 
         //oldIndex is set to be at the end of those 3 lines
         //then we can set isMatchng to true, and if more lines match after the 3 it will keep matching

         if(noMorePlaceholders){
             console.log("No more placeholders");
            for (let m = oldIndex; m < originalLines.length; m++) {
                //postLines.push(originalLines[m]);
                if (newLine.length >= 0 && newLine == originalLines[m]) {
                    console.log("noplaceholder " + newLine + " matches at " + m);
                    oldIndex = m;
                }
            }        
            console.log("postLines now");
            console.log(postLines);
         }else if(!isMatching && newIndex > (matchBreakIndex + 2)){ 
             console.log("TESTING IF OLD LINES MATCH TO NEW INDEX");
             console.log("ORIGINAL");
             //console.log(newLines[newIndex - 2].trim());
             console.log(newLines[newIndex - 1].trim());
             console.log(newLines[newIndex].trim());
             
             //get back on track to matching             
             for (let m = oldIndex; m < originalLines.length - 2; m++) {
                 console.log("VS");
                 console.log(originalLines[m].trim());
                 console.log(originalLines[m+1].trim());
                 console.log(originalLines[m+2].trim());
                 
                if (
                 newLines[newIndex - 2].trim() == originalLines[m].trim() &&
                 newLines[newIndex - 1].trim() == originalLines[m + 1].trim() &&
                 newLines[newIndex].trim() == originalLines[m + 2].trim()
               ){
                 console.log("WOW A MATCH... ok now matching again");
                 oldIndex = m + 4;
                 isMatching = true;
                 break;
               }
             }                              
             
         }

        // If the lines don't match, add the new line
        modifiedLines.push(newLine);
        if(isMatching){
            isMatching = false;
            matchBreakIndex = newIndex;
        }
        
      }
    }

    newIndex++;
  }

  // Add any remaining lines from the original code
  modifiedLines.push(...originalLines.slice(oldIndex));

  return previousLines.join('\n') + modifiedLines.join('\n') + postLines.join('\n');
};

DIFFR.removeCommentCharacters = function(code) {
  const commentPatterns = [
    /\/\/|\/\*|\*\//g,  // JavaScript, C, C++, Java, C#, Go, Rust, etc.
    /#|<!--|-->/g,      // Python, Ruby, Shell, YAML, HTML, Markdown, PHP, TOML, etc.
    /--|{-|--/g,        // Lua, Elm, SQL
    /{{!--|--}}/g,      // Handlebars (tpl)
  ];

  let cleanedCode = code.replace(/:/g, ''); // Remove colons for all languages

  commentPatterns.forEach(pattern => {
    cleanedCode = cleanedCode.replace(pattern, '');
  });

  return cleanedCode;
};




DIFFR.parseCodeChanges = function(llmMessage, existingFilenames = []) {
  const codeChanges = [];
  const lines = llmMessage.split(/\r?\n/);
  let currentFilePath = '';
  let currentCodeChanges = '';
  let inCodeBlock = false;
  let codeBlockLineCount = 0;
  const containsBackticks = llmMessage.includes('```');

  const extractFilePath = (line) => {     
    let bestMatch = arrayGetPath(existingFilenames, line);
    if (bestMatch) {
      return bestMatch;
    } 
    
    const backtickMatch = line.match(/`([^`\s]+?\.\w+)`/g);  // Matches `filename.ext` with no spaces inside backticks
    if (backtickMatch) {
      // If multiple matches, use the last one
      const lastMatch = backtickMatch[backtickMatch.length - 1];
      return lastMatch.slice(1, -1);  // Remove the backticks
    }      
    
    //Remove the 1. 2. 3. 
    const cleanLine = line.replace(/^\d+\.\s*/, '').trim();
    
    bestMatch = arrayGetPath(existingFilenames, cleanLine);
    if (bestMatch) {
      return bestMatch;
    }     
    
    //handle single quotes around filenames
    const quotedMatch = cleanLine.match(/'([^'\s]+?\.\w+)'/);
    if (quotedMatch) {
      return quotedMatch[1];  
    }    
    
    const parts = cleanLine.split(/[/\\]/);
    const lastPart = parts[parts.length - 1];
    let cleanExt = "." + cleanLine.split('.').pop();
    
    if (lastPart.includes('.') && lastPart.split('.').pop().match(/\w+/)) {
      let lSplit = cleanLine.split(' ');  
      for(let s = 0; s < lSplit.length; s++){
          let aPart = lSplit[s];
          if(aPart.includes('.')){
              let sanitizedPath = aPart.replace(/[<>:"|?*\x00-\x1F]/g, '');
              let sanitizedExt = "." + sanitizedPath.split('.').pop();
              if(STUBS.INCLUDED_FILE_TYPES.includes(sanitizedExt)){
                return sanitizedPath.trim();                
              }
          }
      }
      if(STUBS.INCLUDED_FILE_TYPES.includes(cleanExt)){
          return cleanLine.trim();
      }
    }
    return '';
  };
  const extractFilePathExact = (line) => {
    // Remove leading numbers and dots (e.g., "1. ")
    line = line.replace(/^\d+\.\s*/, '').trim();
    
    const bestMatch = arrayGetPath(existingFilenames, line);
    if (bestMatch) {
      return bestMatch;
    }   
    
    // Remove colon at the end, if present
    line = line.replace(/:$/, '');

    // Check if the line contains a file extension
    const parts = line.split('.');
    if (parts.length > 1) {
      const extension = parts[parts.length - 1];
      if (extension.length >= 2 && extension.length <= 4) {
        return line;  // Return the line as a valid file path
      }
    }

    return '';  // Not a valid file path
  };
  
    if (!containsBackticks) {
        console.log("LLM didn't listen - no backticks in file");
        let isCapturing = false;

        lines.forEach(line => {
          const filePath = extractFilePathExact(line);
          if (filePath && !isCapturing) {
            if (currentFilePath && currentCodeChanges) {
              codeChanges.push({
                file_path: currentFilePath,
                code_changes: currentCodeChanges.trim()
              });
            }
            currentFilePath = filePath;
            currentCodeChanges = '';
            isCapturing = true;
          } else if (isCapturing && line.trim() === '') {
            // End of code block when an empty line is encountered
            if (currentFilePath && currentCodeChanges) {
              codeChanges.push({
                file_path: currentFilePath,
                code_changes: currentCodeChanges.trim()
              });
            }
            isCapturing = false;
            currentCodeChanges = '';
          } else if (isCapturing) {
            currentCodeChanges += line + '\n';
          }
        });

        // Push any remaining code changes
        if (currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim()
          });
        }
    } 
    else {
        lines.forEach((line) => {
          const filePath = extractFilePath(line);
          const filePathExact = extractFilePathExact(line);
          /*
          console.log("line");
          console.log(line);
          console.log("current code path: ");
          console.log(currentFilePath);
          console.log("current changes");
          console.log(currentCodeChanges);
          if(inCodeBlock){
              console.log("In code block");
          }else{
              console.log("Not in code block");
          }
          console.log("==============");
            */
          /*
          console.log("nonexact ");
          console.log(filePath);
          console.log("exact ");
          console.log(filePathExact);
          */
          
          if (line.startsWith('```') && filePathExact){
               if (currentFilePath && currentCodeChanges) {
                 codeChanges.push({
                   file_path: currentFilePath,
                   code_changes: currentCodeChanges.trim()
                 });
               }
               currentFilePath = filePathExact;
               currentCodeChanges = '';         
               inCodeBlock = true;
          }else if (filePath && !inCodeBlock) {
            if (currentFilePath && currentCodeChanges) {
              codeChanges.push({
                file_path: currentFilePath,
                code_changes: currentCodeChanges.trim()
              });
            }
            currentFilePath = filePath;
            currentCodeChanges = '';
          } else if (line.startsWith('```')) {
              /*
            if (inCodeBlock && currentFilePath && currentCodeChanges) {
              codeChanges.push({
                file_path: currentFilePath,
                code_changes: currentCodeChanges.trim()
              });
            }              
            */
            inCodeBlock = !inCodeBlock;
            if (inCodeBlock) {
              codeBlockLineCount = 0;
            }            
            if (!inCodeBlock && currentFilePath && currentCodeChanges) {
              codeChanges.push({
                file_path: currentFilePath,
                code_changes: currentCodeChanges.trim()
              });
              currentCodeChanges = '';
            }
          } else if (inCodeBlock) {
            codeBlockLineCount++;
            if (codeBlockLineCount <= 2) {
              let noCommentLine = DIFFR.removeCommentCharacters(line);
              if(arrayHasPath(existingFilenames, noCommentLine.trim())){
                  let bestPath = arrayGetPath(existingFilenames, noCommentLine.trim());
                  currentFilePath = bestPath;
                  console.log("skipping filename line: " + line.trim() + " and updating currentFilePath to " + bestPath);                  
                  return; //skip
              }else if(codeBlockLineCount > 3 && !currentFilePath){
                  //if already a bunch of lines and we are in code, just use first filename
                  if(existingFilenames.length > 0){
                      currentFilePath = existingFilenames[0];
                  }
              }
            }
            currentCodeChanges += line + '\n';
          }
        });

        if (currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim()
          });
        }
  }
  
  return codeChanges;
};

DIFFR.removeNonmatchingCodeFromMessage = function(llmMessage, existingFilenames = [], targetFilename, targetCode) {
  const codeChanges = [];
  const lines = llmMessage.split(/\r?\n/);
  let currentFilePath = '';
  let currentCodeChanges = '';
  let inCodeBlock = false;
  let codeBlockLineCount = 0;
  const containsBackticks = llmMessage.includes('```');
  let modifiedMessage = '';

  const extractFilePath = (line) => {     
    for (let existingFile of existingFilenames) {
      if (line.includes(existingFile)) {
        return existingFile;  // Return as soon as an exact match is found
      }
    }      
    
    const backtickMatch = line.match(/`([^`\s]+?\.\w+)`/g);  // Matches `filename.ext` with no spaces inside backticks
    if (backtickMatch) {
      // If multiple matches, use the last one
      const lastMatch = backtickMatch[backtickMatch.length - 1];
      return lastMatch.slice(1, -1);  // Remove the backticks
    }      
    
    // Remove leading numbers and dots (e.g., "1. ")
    const cleanLine = line.replace(/^\d+\.\s*/, '').trim();
    
    // Handle single quotes around filenames
    const quotedMatch = cleanLine.match(/'([^'\s]+?\.\w+)'/);
    if (quotedMatch) {
      return quotedMatch[1];  
    }    
    
    const parts = cleanLine.split(/[/\\]/);
    const lastPart = parts[parts.length - 1];
    let cleanExt = "." + cleanLine.split('.').pop();
    
    if (lastPart.includes('.') && lastPart.split('.').pop().match(/\w+/)) {
      let lSplit = cleanLine.split(' ');  
      for(let s = 0; s < lSplit.length; s++){
          let aPart = lSplit[s];
          if(aPart.includes('.')){
              let sanitizedPath = aPart.replace(/[<>:"|?*\x00-\x1F]/g, '');
              let sanitizedExt = "." + sanitizedPath.split('.').pop();
              if(STUBS.INCLUDED_FILE_TYPES.includes(sanitizedExt)){
                return sanitizedPath.trim();                
              }
          }
      }
      if(STUBS.INCLUDED_FILE_TYPES.includes(cleanExt)){
          return cleanLine.trim();
      }
    }
    return '';
  };

  const extractFilePathExact = (line) => {
    // Remove leading numbers and dots (e.g., "1. ")
    line = line.replace(/^\d+\.\s*/, '').trim();
    
    for (let existingFile of existingFilenames) {
      if (line.includes(existingFile)) {
        return existingFile;  // Return as soon as an exact match is found
      }
    }     
    
    // Remove colon at the end, if present
    line = line.replace(/:$/, '');

    // Check if the line contains a file extension
    const parts = line.split('.');
    if (parts.length > 1) {
      const extension = parts[parts.length - 1];
      if (extension.length >= 2 && extension.length <= 4) {
        return line;  // Return the line as a valid file path
      }
    }

    return '';  // Not a valid file path
  };

  // Helper function to compare code blocks
  const codeContainsTargetCode = (codeContent, targetCode) => {
    const codeLines = codeContent.split(/\r?\n/).map(line => line.trim()).filter(line => line !== '');
    const targetLines = targetCode.split(/\r?\n/).map(line => line.trim()).filter(line => line !== '');

    // Find all potential starting indices
    const potentialStartIndices = codeLines.reduce((indices, line, index) => {
      if (line === targetLines[0]) {
        indices.push(index);
      }
      return indices;
    }, []);

    // Check each potential starting point
    for (let startIndex of potentialStartIndices) {
      let allLinesMatch = true;

      for (let j = 0; j < targetLines.length; j++) {
        if (startIndex + j >= codeLines.length) {
          allLinesMatch = false;
          break;
        }

        const codeLine = codeLines[startIndex + j];
        const targetLine = targetLines[j];

        if (codeLine !== targetLine) {
          allLinesMatch = false;
          break;
        }
      }

      if (allLinesMatch) {
        return true;
      }
    }

    return false;
  };

  if (!containsBackticks) {
    console.log("LLM didn't listen - no backticks in file");
    let isCapturing = false;

    lines.forEach(line => {
      const filePath = extractFilePathExact(line);
      if (filePath && !isCapturing) {
        if (currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim()
          });
        }
        currentFilePath = filePath;
        currentCodeChanges = '';
        isCapturing = true;
      } else if (isCapturing && line.trim() === '') {
        // End of code block when an empty line is encountered
        if (currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim()
          });
        }
        isCapturing = false;
        currentCodeChanges = '';
      } else if (isCapturing) {
        currentCodeChanges += line + '\n';
      }
    });

    // Push any remaining code changes
    if (currentFilePath && currentCodeChanges) {
      codeChanges.push({
        file_path: currentFilePath,
        code_changes: currentCodeChanges.trim()
      });
    }
  } else {
    lines.forEach((line, index) => {
      const filePath = extractFilePath(line);
      const filePathExact = extractFilePathExact(line);

      if (line.startsWith('```') && filePathExact) {
        if (currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim(),
            removed: (!comparePaths(currentFilePath, targetFilename))
          });
        }
        currentFilePath = filePathExact;
        currentCodeChanges = '';
        inCodeBlock = true;
        modifiedMessage += line + '\n';
      } else if (filePath && !inCodeBlock) {
        if (currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim(),
            removed: (!comparePaths(currentFilePath, targetFilename))
          });
        }
        currentFilePath = filePath;
        currentCodeChanges = '';
        modifiedMessage += line + '\n';
      } else if (line.startsWith('```')) {
        inCodeBlock = !inCodeBlock;
        if (inCodeBlock) {
          codeBlockLineCount = 0;
        }
        if (!inCodeBlock && currentFilePath && currentCodeChanges) {
          codeChanges.push({
            file_path: currentFilePath,
            code_changes: currentCodeChanges.trim(),
            removed: (!comparePaths(currentFilePath, targetFilename))
          });
          if (targetCode) {
            if (codeContainsTargetCode(currentCodeChanges, targetCode)) {
              modifiedMessage += '```\n' + targetCode.trim() + '\n```\n';
            } else {
              modifiedMessage += '```\n//code omitted because change not relevant\n```\n';            
            }
          } else {
            if (comparePaths(currentFilePath, targetFilename)) {
              modifiedMessage += currentCodeChanges + '```\n';
            } else {
              modifiedMessage += '```\n//code omitted because change not relevant\n```\n';            
            }
          }
          currentCodeChanges = '';
        } else {
          modifiedMessage += line + '\n';
        }
      } else if (inCodeBlock) {
        codeBlockLineCount++;
        if (codeBlockLineCount <= 2) {
          let noCommentLine = DIFFR.removeCommentCharacters(line);
          if (arrayHasPath(existingFilenames, noCommentLine.trim())) {
            currentFilePath = noCommentLine.trim();
            modifiedMessage += line + '\n';
            return;
          }
        }
        currentCodeChanges += line + '\n';
        if (currentFilePath === targetFilename && !targetCode) {
          modifiedMessage += line + '\n';
        }
      } else {
        modifiedMessage += line + '\n';
      }
    });

    if (currentFilePath && currentCodeChanges) {
      codeChanges.push({
        file_path: currentFilePath,
        code_changes: currentCodeChanges.trim(),
        removed: (!comparePaths(currentFilePath, targetFilename))
      });
    }
  }
  
  return {
    modifiedMessage: modifiedMessage.trim(),
    codeChanges: codeChanges
  };
};


DIFFR.createSquigglyLinks = function(diffmapContainerId, origFileCode, newFileCode, tabUid, diffIndex) {
    console.log("will add markers to: " + diffmapContainerId);
    const diffMapPanel = document.getElementById(diffmapContainerId);
    diffMapPanel.innerHTML = "";
    origFileCode = origFileCode.replace(/\r\n/g, '\n');
    newFileCode = newFileCode.replace(/\r\n/g, '\n');    
    
    const origLines = origFileCode.split(/\r?\n/);
    const newLines = newFileCode.split(/\r?\n/);
    
    
    const totalLines = newLines.length;
    console.log("doing code map total lines: " + totalLines);
    console.log("origFileCode length: " + origFileCode.length);
    console.log("newFileCode length: " + newFileCode.length);

    if (!DIFFR.dmp) {
        DIFFR.dmp = new diff_match_patch();
    }
    const diffs = DIFFR.dmp.diff_main(origFileCode, newFileCode);
    //const diffs = DIFFR.dmp.diff_main(origFileCode, newFileCode);
    console.log("newFileCode");
    console.log(newFileCode);
    console.log("origFileCode");
    console.log(origFileCode);
    DIFFR.dmp.diff_cleanupSemantic(diffs);

    let changeIndex = 0;
    let prevLineIndex = -100;
    let lowestLineIndex = Infinity;
    let currentLine = 0;

    diffs.forEach(([operation, text]) => {
        const lines = text.split(/\r?\n/);
        lines.forEach((line, idx) => {
            //console.log("ON LINE " + line);
            //console.log("operation " + operation);
            if (operation !== DIFF_EQUAL) {
                if (currentLine - prevLineIndex > 100 || changeIndex === 0) {
                    const percentage = ((currentLine + 1) / totalLines) * 100;
                    lowestLineIndex = Math.min(lowestLineIndex, currentLine);
                    
                    //console.log("creating marker at line: " + currentLine + ", percentage: " + percentage.toFixed(2));
                    $(diffMapPanel).append(`<div class="mapitem_container" id="mapitemcontainer_${tabUid}_${diffIndex}_${changeIndex}"><i data-lineindex="${currentLine}" id="mapitem_${tabUid}_${diffIndex}_${changeIndex}" class="mapitem ti ti-current-location"></i></div>`);
                    $('#mapitemcontainer_' + tabUid + "_" + diffIndex + "_" + changeIndex).css('top', percentage.toString() + "%");
                    prevLineIndex = currentLine;
                    changeIndex++;
                }
            }
            if (idx < lines.length - 1 || line.length > 0) {
                currentLine++;
            }
        });
    });

    // Add vertical line through the center
    $(diffMapPanel).append('<div class="vertical-line"></div>');
    console.log("Lowest line index: " + (lowestLineIndex === Infinity ? 0 : lowestLineIndex));
    return lowestLineIndex === Infinity ? 0 : lowestLineIndex;
};

DIFFR.findMostSimilarCode = function(baseCode, code1, code2) {
  if (!dmp) dmp = new diff_match_patch();

  // Function to calculate similarity
  function calculateSimilarity(text1, text2) {
    const diffs = dmp.diff_main(text1, text2);
    dmp.diff_cleanupSemantic(diffs);
    
    let similarityScore = 0;
    let totalLength = 0;
    
    diffs.forEach(([operation, text]) => {
      if (operation === DIFF_EQUAL) {
        similarityScore += text.length;
      }
      totalLength += text.length;
    });
    
    return similarityScore / totalLength;
  }

  const similarity1 = calculateSimilarity(baseCode, code1);
  const similarity2 = calculateSimilarity(baseCode, code2);

  if (similarity1 > similarity2) {
    return {
      mostSimilar: code1,
      similarity: similarity1,
      index: 1
    };
  } else {
    return {
      mostSimilar: code2,
      similarity: similarity2,
      index: 2
    };
  }
};


DIFFR.calculateLineChanges = function(origCode, newCode) {
  if (!DIFFR.dmp) {
    DIFFR.dmp = new diff_match_patch();
  }
  origCode = origCode.replace(/\r\n/g, '\n');
  newCode = newCode.replace(/\r\n/g, '\n');
  
  const diffs = DIFFR.dmp.diff_main(origCode, newCode);
  DIFFR.dmp.diff_cleanupSemantic(diffs);
  
  let linesAdded = 0;
  let linesRemoved = 0;
  
  diffs.forEach(([operation, text]) => {
    const lineCount = text.split(/\r?\n/).length - 1;
    if (operation === DIFF_INSERT) {
      linesAdded += lineCount;
    } else if (operation === DIFF_DELETE) {
      linesRemoved += lineCount;
    }
  });
  
  return { linesAdded, linesRemoved };
};



DIFFR.getBestLineIndex = function(originalText, searchTerm, modifiedCodeBlock) {
  if (!DIFFR.dmp) {
    DIFFR.dmp = new diff_match_patch();
  }

  const originalLines = originalText.split('\n');
  const modifiedLines = modifiedCodeBlock.split('\n');

  function calculateBlockSimilarity(block1, block2) {
    const diffs = DIFFR.dmp.diff_main(block1, block2);
    DIFFR.dmp.diff_cleanupSemantic(diffs);
    
    let matchedChars = 0;
    let totalChars = 0;
    
    diffs.forEach(([operation, text]) => {
      if (operation === 0) { // DIFF_EQUAL
        matchedChars += text.length;
      }
      totalChars += text.length;
    });
    
    return {
      similarity: matchedChars / totalChars,
      matchedChars: matchedChars
    };
  }

  let bestMatch = {
    index: null,
    similarity: 0,
    matchedChars: 0
  };
  console.log("searching for " + searchTerm);
  // Find all potential starting points
  const potentialExactIndices = originalLines.reduce((indices, line, index) => {
      //console.log("a line " + line);
    if(line.trim() == searchTerm.trim()) {
      //console.log("found one");        
      indices.push(index);
    }
    return indices;
  }, []);  
  
  const potentialNonexactIndices = originalLines.reduce((indices, line, index) => {
      //console.log("a line " + line);
    if (line.includes(searchTerm)) {
      //console.log("found one");        
      indices.push(index);
    }
    return indices;
  }, []);
  let potentialStartIndices;
  if(potentialExactIndices.length > 0){
      potentialStartIndices = potentialExactIndices;
  }else{
      potentialStartIndices = potentialNonexactIndices;
  }
  console.log("potential start indices");
  console.log(potentialStartIndices);
  
  // If there's only one potential index, return it immediately
  if (potentialStartIndices.length === 1) {
    return potentialStartIndices[0];
  }  
  

  for (let startIndex of potentialStartIndices) {
    // Extract a window of lines from the original text
    // The window size is flexible, we'll use 2 * modifiedLines.length as a maximum
    const endIndex = Math.min(startIndex + 2 * modifiedLines.length, originalLines.length);
    const originalWindow = originalLines.slice(startIndex, endIndex).join('\n');

    const { similarity, matchedChars } = calculateBlockSimilarity(originalWindow, modifiedCodeBlock);

    // We prioritize matches with more matched characters
    if (matchedChars > bestMatch.matchedChars || 
        (matchedChars === bestMatch.matchedChars && similarity > bestMatch.similarity)) {
      bestMatch = {
        index: startIndex,
        similarity: similarity,
        matchedChars: matchedChars
      };
    }
  }

  return bestMatch.index;
};

// Helper function to compute Longest Common Subsequence length
function computeLCSLength(lines1, lines2) {
    const m = lines1.length;
    const n = lines2.length;
    const L = Array(m + 1).fill(null).map(() => Array(n + 1).fill(0));

    for (let i = 0; i <= m; i++) {
        for (let j = 0; j <= n; j++) {
            if (i === 0 || j === 0) {
                L[i][j] = 0;
            } else if (lines1[i - 1].trim() === lines2[j - 1].trim()) {
                L[i][j] = L[i - 1][j - 1] + 1;
            } else {
                L[i][j] = Math.max(L[i - 1][j], L[i][j - 1]);
            }
        }
    }
    return L[m][n];
}

DIFFR.compareCodeSimilarity = function(code1, code2) {
    // Split code into lines
    const code1Lines = code1.replace(/\r\n/g, '\n').split('\n');
    const code2Lines = code2.replace(/\r\n/g, '\n').split('\n');

    // Compute the length of the Longest Common Subsequence
    const lcsLength = computeLCSLength(code1Lines, code2Lines);

    // Determine the maximum possible length (for percentage calculation)
    const maxLines = Math.max(code1Lines.length, code2Lines.length);

    // Calculate similarity percentage
    const similarityPercentage = (lcsLength / maxLines) * 100;

    return similarityPercentage; // Returns a percentage between 0 and 100
};



/*
DIFFR.findCodeBlockPosition = function(partialCode, fullCode) {
  console.log("in find code block position - partial length " + partialCode.length + " fullcode length " + fullCode.length);
  
  if(DIFFR.dmp == null){
    DIFFR.dmp = new diff_match_patch();
  }
  
  const partialLines = partialCode.split(/\r?\n/);
  const fullLines = fullCode.split(/\r?\n/);
  
  let bestMatch = {
    startLine: -1,
    endLine: -1,
    matchCount: 0
  };
  
  for (let i = 0; i < fullLines.length - partialLines.length + 1; i++) {
    let matchCount = 0;
    for (let j = 0; j < partialLines.length; j++) {
      const diffs = DIFFR.dmp.diff_main(fullLines[i + j].trim(), partialLines[j].trim());
      DIFFR.dmp.diff_cleanupSemantic(diffs);
      
      const similarity = diffs.reduce((acc, [op, text]) => {
        return op === DIFF_EQUAL ? acc + text.length : acc;
      }, 0) / Math.max(fullLines[i + j].trim().length, partialLines[j].trim().length);
      
      if (similarity > 0.8) {  // Adjust this threshold as needed
        matchCount++;
      }
    }
    
    if (matchCount > bestMatch.matchCount) {
      bestMatch = {
        startLine: i,
        endLine: i + partialLines.length - 1,
        matchCount: matchCount
      };
    }
  }
  
  return {
    startLine: bestMatch.startLine,
    endLine: bestMatch.endLine,
    similarity: bestMatch.matchCount / partialLines.length
  };
};

DIFFR.findCodeBlockPositionOLDOLD = function(partialCode, fullCode) {
  console.log("in find code block position - partial length " + partialCode.length + " fullcode length " + fullCode.length);
  
  if(DIFFR.dmp == null){
    DIFFR.dmp = new diff_match_patch();
  }
  
  const diffs = DIFFR.dmp.diff_main(fullCode, partialCode);
  DIFFR.dmp.diff_cleanupSemantic(diffs);
  
  let fullCodeIndex = 0;
  let partialCodeIndex = 0;
  let bestMatch = {
    startIndex: -1,
    endIndex: -1,
    matchLength: 0
  };
  
  let currentMatch = {
    startIndex: -1,
    endIndex: -1,
    matchLength: 0
  };
  
  for (const [operation, text] of diffs) {
    if (operation === DIFF_EQUAL) {
      if (currentMatch.startIndex === -1) {
        currentMatch.startIndex = fullCodeIndex;
      }
      currentMatch.endIndex = fullCodeIndex + text.length;
      currentMatch.matchLength += text.length;
      
      if (currentMatch.matchLength > bestMatch.matchLength) {
        bestMatch = {...currentMatch};
      }
      
      fullCodeIndex += text.length;
      partialCodeIndex += text.length;
    } else if (operation === DIFF_DELETE) {
      if (currentMatch.matchLength > 0) {
        if (currentMatch.matchLength > bestMatch.matchLength) {
          bestMatch = {...currentMatch};
        }
        currentMatch = {startIndex: -1, endIndex: -1, matchLength: 0};
      }
      fullCodeIndex += text.length;
    } else if (operation === DIFF_INSERT) {
      partialCodeIndex += text.length;
    }
  }
  
  // Convert indices to line numbers
  const fullLines = fullCode.split(/\r?\n/);
  let lineStart = 0;
  let startLine = 0;
  let endLine = fullLines.length - 1;
  
  for (let i = 0; i < fullLines.length; i++) {
    if (lineStart + fullLines[i].length >= bestMatch.startIndex) {
      startLine = i;
      break;
    }
    lineStart += fullLines[i].length + 1; // +1 for the newline character
  }
  
  for (let i = startLine; i < fullLines.length; i++) {
    if (lineStart + fullLines[i].length >= bestMatch.endIndex) {
      endLine = i;
      break;
    }
    lineStart += fullLines[i].length + 1;
  }
  
  return {
    startLine: startLine,
    endLine: endLine,
    similarity: bestMatch.matchLength / partialCode.length
  };
};


DIFFR.findCodeBlockPositionOLD = function(partialCode, fullCode) {
  console.log("in find code block position - partial length " + partialCode.length + " fullcode length " + fullCode.length);
  if(DIFFR.dmp == null){
      DIFFR.dmp = new diff_match_patch();
  }

  // Split the codes into lines
  const partialLines = partialCode.split(/\r?\n/);
  const fullLines = fullCode.split(/\r?\n/);

  let bestMatch = {
    startLine: -1,
    endLine: -1,
    similarity: 0
  };

  // Slide a window the size of partial code through the full code
  for (let i = 0; i <= fullLines.length - partialLines.length; i++) {
    const windowCode = fullLines.slice(i, i + partialLines.length).join('\n');
    const diffs = DIFFR.dmp.diff_main(partialCode, windowCode);
    DIFFR.dmp.diff_cleanupSemantic(diffs);

    let similarity = 0;
    let totalLength = 0;

    diffs.forEach(([operation, text]) => {
      if (operation === DIFF_EQUAL) {
        similarity += text.length;
      }
      totalLength += text.length;
    });

    const similarityScore = similarity / totalLength;

    if (similarityScore > bestMatch.similarity) {
      bestMatch = {
        startLine: i,
        endLine: i + partialLines.length - 1,
        similarity: similarityScore
      };
    }
  }
  console.log("Best match AFTER SLIDING WINDOW");
  console.log(bestMatch);
  

  // If the best match isn't very good, try to expand it
  if (bestMatch.similarity < 0.8) {
      console.log("not good enough match");
    let expandedStart = bestMatch.startLine;
    let expandedEnd = bestMatch.endLine;

    // Expand upwards
    while (expandedStart > 0) {
      const expandedCode = fullLines.slice(expandedStart - 1, expandedEnd + 1).join('\n');
      const diffs = DIFFR.dmp.diff_main(partialCode, expandedCode);
      DIFFR.dmp.diff_cleanupSemantic(diffs);

      let newSimilarity = diffs.reduce((sum, [op, text]) => op === DIFF_EQUAL ? sum + text.length : sum, 0) / expandedCode.length;

      if (newSimilarity > bestMatch.similarity) {
        bestMatch.similarity = newSimilarity;
        expandedStart--;
      } else {
        break;
      }
    }
    console.log("Best match expand upwards");
    console.log(bestMatch);
    // Expand downwards
    while (expandedEnd < fullLines.length - 1) {
      const expandedCode = fullLines.slice(expandedStart, expandedEnd + 2).join('\n');
      const diffs = DIFFR.dmp.diff_main(partialCode, expandedCode);
      DIFFR.dmp.diff_cleanupSemantic(diffs);

      let newSimilarity = diffs.reduce((sum, [op, text]) => op === DIFF_EQUAL ? sum + text.length : sum, 0) / expandedCode.length;

      if (newSimilarity > bestMatch.similarity) {
        bestMatch.similarity = newSimilarity;
        expandedEnd++;
      } else {
        break;
      }
    }
    console.log("Best match expand downwards");
    console.log(bestMatch);
    

    bestMatch.startLine = expandedStart;
    bestMatch.endLine = expandedEnd;
  }

  return bestMatch;
};
*/

if (!process.type) {
    module.exports = DIFFR;
}