const rightContent = document.getElementById('dragright-content');
const mainContent = document.getElementById('dragmain-content');
const resizer = document.getElementById('dragresizer');
let initialBottomHeight;
let initialTopHeight;

resizer.addEventListener('mousedown', function (e) {
    e.preventDefault();
    document.addEventListener('mousemove', resize);
    document.addEventListener('mouseup', stopResize);
});

/*
function resize(e) {
    const containerWidth = rightContent.parentElement.clientWidth;
    const newRightWidth = (containerWidth - e.clientX) / containerWidth * 100;
    
    if (newRightWidth >= 35 && newRightWidth <= 65) {
        rightContent.style.width = newRightWidth + '%';
        mainContent.style.width = (100 - newRightWidth) + '%';
    }
}
*/
function resize(e) {
    const containerWidth = rightContent.parentElement.clientWidth;
    const newRightWidth = containerWidth - e.clientX;
    
    if (newRightWidth >= containerWidth * 0.35 && newRightWidth <= containerWidth * 0.65) {
        rightContent.style.width = newRightWidth + 'px';
        mainContent.style.width = (containerWidth - newRightWidth) + 'px';
    }
}

function setInitialWidths() {
    const containerWidth = rightContent.parentElement.clientWidth;
    const initialRightWidth = 60; 
    rightContent.style.width = initialRightWidth + '%';
    mainContent.style.width = (100 - initialRightWidth) + '%';
}

// Call this function when the page loads
window.addEventListener('load', setInitialWidths);

function stopResize() {
    document.removeEventListener('mousemove', resize);
    document.removeEventListener('mouseup', stopResize);
}

const bottomContent = document.getElementById('dragbottom-content');
const topContent = document.getElementById('dragtop-content');
const resizerHorizontal = document.getElementById('dragresizer-horizontal');

resizerHorizontal.addEventListener('mousedown', function (e) {
    e.preventDefault();
    document.addEventListener('mousemove', resizeHorizontal);
    document.addEventListener('mouseup', stopResizeHorizontal);
});

function resizeHorizontal(e) {
    const containerHeight = mainContent.clientHeight;
    const newBottomHeight = containerHeight - e.clientY;
    
    if (newBottomHeight >= containerHeight * 0.15 && newBottomHeight <= containerHeight * 0.85) {
        bottomContent.style.height = newBottomHeight + 'px';
        topContent.style.height = (containerHeight - newBottomHeight) + 'px';
        
        // Set the textarea height to match the bottom content height
        let textarea = document.getElementById('#chatgpt-request');
        textarea.style.height = (bottomContent.clientHeight - 20) + 'px';            
    }
}

function stopResizeHorizontal() {
    document.removeEventListener('mousemove', resizeHorizontal);
    document.removeEventListener('mouseup', stopResizeHorizontal);
}
