//embeddings are in main.js because can't get to work in renderer.js
var EMBED = EMBED || {};

//we should only rebuild if has_changes (new file desc, refetched deps and dep groups etc)
EMBED.projectReadyArray = {};
EMBED.hasAllDescriptions = false;
EMBED.alwaysGetGroupsGraph = true;



EMBED.buildReadyArray = async function() {
    let {allProjects, allProjectPaths} = SFILE.getAllProjects();
    console.log("buildReadyArr");
    console.log(allProjects);
    console.log(allProjectPaths);

    for (let a = 0; a < allProjects.length; a++) {
        let projectName = allProjects[a];
        let projectPath = allProjectPaths[a];
        console.log(`Processing project: ${projectName}`);
        await processProject(projectName, projectPath);
    }

    console.log("Project Ready Array afterwards: ");
    console.log(EMBED.projectReadyArray);
    
    console.log("FILE CACHE AFTER");
    printCacheKeys();
    
};

async function processProject(projectName, projectPath) {
    return new Promise(async (resolve, reject) => {
        try {
            let skipEmbeddings = true;
            console.log("Checking embeddings for " + projectName);
            console.log("Checking embeddings path " + projectPath);
            $('#stubprogress_' + projectName).html("generating embeddings");
            $(`#project-syncing-${projectName}`).css('display', 'block');

            EMBED.projectReadyArray[projectName] = {
                ready: false,
                has_changes: true
            };

            let projEmbedding = await dexieDB.getEmbeddingsFromDexie(projectName);
            if (projEmbedding.length > 0) {
                console.log("projectname " + projectName + " embedding found with docs: ");
                let embedDocs = projEmbedding.map(embedRecord => embedRecord['filename']);
                console.log(embedDocs);
                const currentDate = new Date();
                const threeDaysAgo = new Date(currentDate.getTime() - 3 * 24 * 60 * 60 * 1000);
                const isOutdated = projEmbedding.some(embedding => new Date(embedding.update_date) < threeDaysAgo);

                if (isOutdated) {
                    console.log(`Embeddings for project ${projectName} are outdated. Regenerating...`);
                    skipEmbeddings = false;
                } else {
                    console.log(`Embeddings for project ${projectName} are up to date.`);
                }

                let projNameArr = [projectName];
                let projectFileData = await SFILE.getAvailableFilesForGPT(projNameArr, STUBS.stubsData);    
                EMBED.projectReadyArray[projectName]['projectPath'] = projectPath;
                let finalOriginalPaths = projectFileData['files'].map(shortPath => path.join(".", projectPath, shortPath));
                let finalShortPaths = projectFileData['files'].map(filePath => 
                    path.normalize(filePath.replace(projectPath, '')).replace(/\\/g, '/')
                );      

                for(let e = 0; e < finalShortPaths.length; e++){
                    let aPath = finalShortPaths[e];
                    let hasMatch = embedDocs.some(embedDoc => {
                        let comparisonResult = comparePaths(aPath, embedDoc);
                        return comparisonResult;
                    });            

                    if(!hasMatch){
                        console.log("MATCH NOT FOUND " + aPath);
                        skipEmbeddings = false;
                    }                
                }
            } else {
                console.log("no embeddings");
                skipEmbeddings = false;
            }
            console.log("Final decision to skip embedding:", skipEmbeddings);

            if (!skipEmbeddings) {
                console.log("CREATING EMBED AGAIN: " + projectName);
                let projectDesc = "Electron node.js application that allows you to request code completion tasks from LLMs, and provides an interface to approve those code changes.";    
                let success = await EMBED.embeddingsReadyOrCreate(projectName, projectDesc, projectPath);     

                if (success === true) {
                    console.log("Saving embeddings for " + projectName);
                    let documents = await EMBED.getDocumentsArray(projectName);
                    let onlyFilepaths = documents.map(doc => doc['filename']);
                    console.log("document array");
                    console.log(documents);
                    let embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
                    await dexieDB.saveEmbeddingsToDexie(projectName, embeddings, onlyFilepaths);    

                    console.log("SAVED THE EMBEDDINGS FOR " + projectName);            
                } else {
                    console.log("Chose not to have embeddings, or had error creating them");
                }
            } else {
                console.log("USE DB EMBED: " + projectName);
                EMBED.projectReadyArray[projectName]['ready'] = true;
            }
            $(`#project-syncing-${projectName}`).css('display', 'none');

            // Resolve the promise after all operations are complete
            resolve();
        } catch (error) {
            console.error(`Error processing project ${projectName}:`, error);
            reject(error);
        }
    });
}

EMBED.buildReadyArray = async function(){    
    //fill with each project that is listed in SFILE
    //and if it has embeddings, we can replace the first step
    
    let {allProjects, allProjectPaths} = SFILE.getAllProjects();  
    console.log("buildReadyArr");
    console.log(allProjects);
    console.log(allProjectPaths);
    
    let pReadyArr = {};
    for(let a = 0; a < allProjects.length; a++){
        let skipEmbeddings = true;
        let projectName = allProjects[a];
        let projectPath = allProjectPaths[a];
        console.log("Checking embeddings for " + projectName);
        console.log("Checking embeddings path " + projectPath);
        $('#stubprogress_' + projectName).html("generating embeddings");
        $(`#project-syncing-${projectName}`).css('display', 'block');
        //we should only rebuild if has_changes (new file desc, refetched deps and dep groups etc)
        EMBED.projectReadyArray[projectName] = {
            ready: false,
            has_changes: true
        };
        let projEmbedding = await dexieDB.getEmbeddingsFromDexie(projectName);
        if(projEmbedding.length > 0){
            //console.log(projEmbedding);
            console.log("projectname " + projectName + " embedding found with docs: ");
            let embedDocs = projEmbedding.map(embedRecord => embedRecord['filename']);
            console.log(embedDocs);
            // Check the update_date of each embedding
            const currentDate = new Date();
            const threeDaysAgo = new Date(currentDate.getTime() - 3 * 24 * 60 * 60 * 1000);
            const isOutdated = projEmbedding.some(embedding => new Date(embedding.update_date) < threeDaysAgo);

            if (isOutdated) {
                console.log(`Embeddings for project ${projectName} are outdated. Regenerating...`);
                skipEmbeddings = false;
            } else {
                console.log(`Embeddings for project ${projectName} are up to date.`);
            }
            
            //COMPARE embed docs to STUBS.stubsdata
            let projNameArr = [projectName];
            let projectFileData = await SFILE.getAvailableFilesForGPT(projNameArr, STUBS.stubsData);    
            EMBED.projectReadyArray[projectName]['projectPath'] = projectPath;
            //console.log("project path " + checkProjectPath);
            let finalOriginalPaths = projectFileData['files'].map(shortPath => path.join(".", projectPath, shortPath));
            let finalShortPaths = projectFileData['files'].map(filePath => 
                path.normalize(filePath.replace(projectPath, '')).replace(/\\/g, '/')
            );      
            
            for(let e = 0; e < finalShortPaths.length; e++){
                let aPath = finalShortPaths[e];
                //console.log("Checking path:", aPath);  // Log the current path being checked
                let hasMatch = embedDocs.some(embedDoc => {
                    let comparisonResult = comparePaths(aPath, embedDoc);
                    //console.log("Comparing path with embedDoc:", { aPath, embedDoc, comparisonResult });  // Log the comparison between paths
                    return comparisonResult;
                });            
                
                if(!hasMatch){
                    console.log("MATCH NOT FOUND " + aPath);
                    skipEmbeddings = false;
                }                
            }
        }else{
            console.log("no embeddings");
            skipEmbeddings = false;
        }
        console.log("Final decision to skip embedding:", skipEmbeddings);
        
        if(!skipEmbeddings){
            console.log("CREATING EMBED AGAIN: " + projectName);
            let projectDesc = "Electron node.js application that allows you to request code completion tasks from LLMs, and provides an interface to approve those code changes.";    
            let success = await EMBED.embeddingsReadyOrCreate(projectName, projectDesc, projectPath);     
            
            let saveThem = false;
            if(success === false){
                //alert("Show Dialog to Prune");
            }
            else if(success === -1){
                
            }else{
                saveThem = true;
            }
            
            if(saveThem){
                console.log("Saving embeddings for " + projectName);
                let documents = await EMBED.getDocumentsArray(projectName);
                let onlyFilepaths = new Array();
                for(let f = 0; f < documents.length; f++){
                    onlyFilepaths.push(documents[f]['filename']);
                }
                console.log("document array");
                console.log(documents);
                let embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
                await dexieDB.saveEmbeddingsToDexie(projectName, embeddings, onlyFilepaths);    

                console.log("SAVED THE EMBEDDINGS FOR " + projectName);            
            }else{
                console.log("Chose not to have embeddings, or had error creating them");
            }
        }else{
            console.log("USE DB EMBED: " + projectName);
            EMBED.projectReadyArray[projectName]['ready'] = true;
        }
        $(`#project-syncing-${projectName}`).css('display', 'none');

    }    
    console.log("Project Ready Array afterwards: ");
    console.log(EMBED.projectReadyArray);
};


EMBED.getDocumentsArray = async function(projectName){
    let docs = new Array();
    let projectPath = EMBED.projectReadyArray[projectName].projectPath;
    let finalOriginalPaths = EMBED.projectReadyArray[projectName].finalOriginalPaths;
    let finalShortPaths = EMBED.projectReadyArray[projectName].finalShortPaths;
    let existingDependencies = EMBED.projectReadyArray[projectName].existingDependencies;
    let existingDescriptions = EMBED.projectReadyArray[projectName].existingDescriptions;
    console.log("IN getDocumentArray with dependencies");
    console.log(existingDependencies);
    console.log("descriptions ");
    console.log(existingDescriptions);   
    
    for(let x = 0; x < finalOriginalPaths.length; x++){

        let fPath = finalOriginalPaths[x];
        if (STUBS.platform === 'darwin' && !fPath.startsWith('/')) {
            fPath = '/' + fPath;
            finalOriginalPaths[x] = fPath;
            //console.log("Adjusted path for macOS: " + fPath);
        }               
        let sPath = finalShortPaths[x];
        //console.log("PATH: ");
        //console.log(sPath);
        let theDescription = "";
        let depArr = new Array();
        let codeContent = readFileWithCache(fPath);
        let md5 = crypto.createHash('md5').update(codeContent).digest('hex');

        let foundDesc = false;
        for(let m = 0; m < existingDescriptions.length; m++){
            let myPath = existingDescriptions[m].file_path;
            if(!myPath){
                continue;
            }
            //console.log("comparing " );
            //console.log(myPath);
            //console.log(" to " );
            //console.log(sPath);
            
            
            if(comparePaths(myPath, sPath)){
                foundDesc = true;
                theDescription = existingDescriptions[m].description;
                //console.log("SETTING DESCRIPTION TO ");
                //console.log(theDescription);                
            }else{
                //console.log("NOOOOOO");
            }
        }
        let foundDepArr = false;
        for(let d = 0; d < existingDependencies.length; d++){
            //has full path
            let shortDepPath = path.normalize(existingDependencies[d].filepath.replace(projectPath, '')).replace(/\\/g, '/');
            //console.log("short dep path");
            //console.log(shortDepPath);
            //console.log("comparing " );
            //console.log(shortDepPath);
            //console.log(" to " );
            //console.log(sPath);            
            
            if(comparePaths(shortDepPath, sPath)){
                foundDepArr = true;
                depArr = existingDependencies[d].mergedLines;
                //console.log("SETTING DEPENDENCY ARRAY TO (MERGED LINES)");
                //console.log(depArr);
            }else{
                //console.log("NOO222222222");
            }                                                
        }
        if(!foundDesc){
            //console.log("DESCRIPTIONS - DID NOT FIND " + sPath);
        }
        if(!foundDepArr){
            //console.log("DEPENDENCIES - DID NOT FIND " + sPath);
        }


        let theCode = "";
        let newDoc = {filename: sPath,
            code: codeContent, 
            description: theDescription,
            dependencies: depArr,
            md5: md5
        };
        docs.push(newDoc);
        //`${doc.filename}\n${doc.description}\n${doc.dependencies.join("\n")}`;
    }

    return docs;
};


EMBED.generateDependencies = async function(projectName, finalOriginalPaths, projectPath){


    let doesItWork = await DGRAPH.getDependenciesForProject(finalOriginalPaths, projectPath);

    let dGraphArr = doesItWork[0];
    let dependencyGroups = doesItWork[1];
    console.log("graph count" + dGraphArr.length);


    console.log("saving graph");
    await dexieDB.saveDependencyGraph(projectName, dGraphArr);
    console.log("saving group");        
    await dexieDB.saveDependencyGroups(projectName, dependencyGroups);    
    console.log("generated dependencies");

    return doesItWork;
};

EMBED.embeddingsReadyOrCreate = async function(projectName, projectDesc, projectPath){
    let projectNameArr = [projectName];
    let projectFileData = await SFILE.getAvailableFilesForGPT(projectNameArr, STUBS.stubsData, false);    
        
    EMBED.projectReadyArray[projectName]['projectPath'] = projectPath;

    let finalOriginalPaths = projectFileData['files'].map(shortPath => path.join(".", projectPath, shortPath));
    let finalShortPaths = projectFileData['files'].map(filePath => 
        path.normalize(filePath.replace(projectPath, '')).replace(/\\/g, '/')
    );            
    
    if(finalOriginalPaths.length > STUBS.LARGE_PROJECT_FILE_AMOUNT){
        console.log("More than " + STUBS.LARGE_PROJECT_FILE_AMOUNT + " files");
        console.log(finalOriginalPaths);
        return false;
    }
    console.log("REDOING EMBEDDINGSSSSSSSSSSSSSS");
    console.log("project name " + projectName);
    console.log("project path " + projectPath);
    console.log("Total embeddings files");
    console.log(finalOriginalPaths.length);
    console.log(finalOriginalPaths);
    
    EMBED.projectReadyArray[projectName]['finalOriginalPaths'] = finalOriginalPaths;
    EMBED.projectReadyArray[projectName]['finalShortPaths'] = finalShortPaths;

    let theFilesText = projectFileData['files_text'];
    let theFilesTextLinux = projectFileData['files_text_linux'];
    console.log('getting dependency groups');
    let depGroups = await dexieDB.getDependencyGroups(projectName);
    let dGraphArr = await dexieDB.getDependencyGraph(projectName);
    if(!depGroups || depGroups.length <= 0 || EMBED.alwaysGetGroupsGraph){
        console.log("dont exist need dependencies for");
        console.log(projectName);
        
        //this does not call LLM - I group files by dependencies now
        let retDep = await EMBED.generateDependencies(projectName, finalOriginalPaths, projectPath);
        dGraphArr = retDep[0];
        depGroups = retDep[1];
        console.log("ok generated dependencies and groups, but not exiting");
        console.log(retDep);           
    }else{
        //check the the count to match the Stubs file data
        //check the date of the dependencies, update if it's been more than 2 days?        
    }

    let existingDescriptions = await dexieDB.getProjectFileDescriptions(projectName);
    EMBED.projectReadyArray[projectName]['existingDescriptions'] = existingDescriptions;
    
    console.log("existing descriptions");
    console.log(existingDescriptions);

    let existingDependencies = await DGRAPH.getDependencyGraphArray(dGraphArr);
    EMBED.projectReadyArray[projectName]['existingDependencies'] = existingDependencies;
    console.log("existing dependencies");
    console.log(existingDependencies);
    
    if(depGroups.length <= 0){
        console.log("No dependency groups");
        return -1;
    }

    EMBED.hasAllDescriptions = true;
    for(let d = 0; d < depGroups.length; d++){
        let groupOriginalPaths = depGroups[d];
        if(!groupOriginalPaths){
            console.log("bad dependency group");
            console.log(groupOriginalPaths);
            continue;
        }
        
        console.log(groupOriginalPaths);
        // Shuffle groupOriginalPaths using Fisher-Yates algorithm
        for (let i = groupOriginalPaths.length - 1; i > 0; i--) {
          const j = Math.floor(Math.random() * (i + 1));
          [groupOriginalPaths[i], groupOriginalPaths[j]] = [groupOriginalPaths[j], groupOriginalPaths[i]];
        }            

        let groupShortPaths = groupOriginalPaths.map(filePath => 
            path.normalize(filePath.replace(projectPath, '')).replace(/\\/g, '/')
        );             

        console.log("want files");
        console.log(groupShortPaths);     

        // Check if all groupOriginalPaths exist in existingDescriptions
        const allPathsExist = groupShortPaths.every(filePath => {
          //console.log(`Checking if all paths include: ${filePath}`);

            const normalizedFilePath = filePath.startsWith('/') ? filePath.slice(1) : filePath;

            // Perform the check and store the result in a variable
            const existsInDescriptions = existingDescriptions.some(desc => {
              //console.log(`Comparing: ${desc.file_path} to ${normalizedFilePath}`);
              return (desc.file_path === filePath || desc.file_path === normalizedFilePath);
            });

          // Log the result of the 'some' check for this particular 'filePath'
          //console.log(`Result for ${filePath}: ${existsInDescriptions ? 'Exists' : 'Does not exist'}`);

          // Return the result for use in the 'every' check
          return existsInDescriptions;
        });

        if (allPathsExist) {
          console.log("All file paths exist in group " + d + ". Skipping this group.");
          continue; // Continue to the next iteration of the loop
        }else{
            console.log("at least one path doesn't exist in");
            console.log(groupShortPaths);      
            
            //REMOVE REMOVE REMOVE 
            //return false;
        }            


        let groupFullFileText = "";
        for(let x = 0; x < groupOriginalPaths.length; x++){
            let fPath = groupOriginalPaths[x];
            let sPath = groupShortPaths[x];
            
            let codeContent;
            if (groupOriginalPaths.length > 1500) {
                // If the file has over 1500 lines, get the stub file instead
                codeContent = await SFILE.getStubFileContent(projectName, sPath);
                if (!codeContent) {
                    console.error(`Stub file not found for ${sPath}. Skipping this file.`);
                    continue;
                }
            } else {
                // Otherwise, read the full file content
                codeContent = readFileWithCache(fPath);
            }
            
            groupFullFileText += `FILE: ${sPath}\n${codeContent}\n\n`;
        }
        let fileDescriptions = await CHATGPT.requestFileDescriptions(projectName, projectDesc, groupFullFileText);    

        console.log("File Descriptions");
        console.log(fileDescriptions);

        //this array has items that contain "file" and "description" keys         
        let responseArr = fileDescriptions['response'];

        await dexieDB.saveFileDescriptions(projectName, responseArr);   

        console.log("saved dexie db ");
        console.log(responseArr);
        EMBED.hasAllDescriptions = false;        
        break;            

    }
    
    EMBED.projectReadyArray[projectName]['ready'] = true;

    console.log("EVERYTHING DONE");    
    return true;
};
