var TABS = TABS || {};

TABS.CURRENT_INDEX = 0;
TABS.CURRENT_UID = "";
TABS.TAB_ARR = new Array();

//when doing new workflwo add this to TAB_DATA
//when close new tab, just remove it
//all elements in UI have uid_whatever, so we know what tab we're working on 

TABS.ADD_NEW_TAB = function(){
    
    //for local testing
    
    let checkedProjects = [];
    let checkedProjectPaths;
    let checkedProjectDescs;
    let checkedProjectRules;
    if(typeof SFILE !== 'undefined'){
        ({checkedProjects, checkedProjectPaths, checkedProjectDescs, checkedProjectRules} = SFILE.getCheckedProjects());
    }   

    
    console.log("checked projects");
    console.log(checkedProjects);
     
    let tabUID = generateUID();
    let currentLength = TABS.TAB_ARR.length;
    let tabObject = {
        task_text: "",
        task_type: "task",
        task_sent: false, 
        llm_provider: CHATGPT.LLM_PROVIDER,
        llm_responses : new Array(), 
        llm_relevanttext : new Array(),
        messages: new Array(),
        checked_projects: checkedProjects,
        checked_project_paths: checkedProjectPaths,        
        checked_project_descs: checkedProjectDescs,
        checked_project_rules: checkedProjectRules,
        code_blocks: new Array(),
        uid: tabUID,
        diff: new Array(),
        has_image: false,
        context_images: new Array(),
        image_description: "",
        modified_context: new Array(),
        has_ui: true,
        use_schema: false,
        schema_text: "",      
        use_documents: false,
        document_text: "",
        documents: [],        
        file_data: null,
        just_files_linux: [], 
        more_tasks : [],
        more_responses : [],
        link: "",
        tribute_values: [],
        force_stop_task: false,
        running: false,
        referenced_projects: [],
        use_projects: false,
        reference_project_text: "",
        use_stubs: true
    };
    TABS.TAB_ARR.push(tabObject);
    
    let chatgptResponseContainer = fs.readFileSync(path.join(STUBS.appPath, 'views','chat_response_container.html'), 'utf-8');
    let renderedContainer = Mustache.render(chatgptResponseContainer, {tabUID: tabUID});
    $('#all_response_containers').append(renderedContainer);
    
    return currentLength;
};

TABS.CREATE_FIRST_TAB = function(){
    //NEED TO CREATE THE FIRST TAB
    TABS.ADD_NEW_TAB();
    setTimeout(function(){
        $('#tasktab_0').data('uid', TABS.TAB_ARR[0]['uid']);
        $('#tasktab_0').find('.delete-tab').data('uid', TABS.TAB_ARR[0]['uid']);
        $('#tasktab_0').attr('id', "tasktab_" + TABS.TAB_ARR[0]['uid']);        
    }, 50);
};

TABS.loadTabByIndex = function(tabIndex){
    console.log("loading tab by index" + tabIndex);
    let currentTab = TABS.TAB_ARR[tabIndex];
    TABS.loadTabByUid(currentTab['uid']);    
};

TABS.getTabByUid = function(uid){
    console.log("GETTING TAB UID: " + uid);
    for(let x = 0; x < TABS.TAB_ARR.length; x++){
        if(TABS.TAB_ARR[x]['uid'] == uid){
            return TABS.TAB_ARR[x];
        }
    }    
    throw new Error('Tried to get tab that no longer exists');
};

TABS.loadTabByUid = function(uid){
    console.log("loading tab by uid: " + uid);
    console.log("tabs array");
    console.log(TABS.TAB_ARR);
    let found = false;
    let loadTab = null;
    let loadIndex = -1;
    for(let x = 0; x < TABS.TAB_ARR.length; x++){
        console.log(TABS.TAB_ARR[x]['uid'] + " VS " + uid);
        if(TABS.TAB_ARR[x]['uid'].toString().trim() === uid.toString().trim()) {
            loadTab = TABS.TAB_ARR[x];
            loadIndex = x;
            found = true;
            break;
        }        
    }
    if(!found){
        console.log("Could not load tab by uid");
        return;
    }
    let currTab = loadTab;
    //load the task, the llm provider button and the project directory checkboxes
    $('#chatgpt-request').val(loadTab.task_text);


    let modelName = STUI.getModelNameFromProvider(loadTab.llm_provider);
    // load the llm provider button
    $('#llm_provider').html(modelName);

    // load the project directory checkboxes
    if(typeof SFILE !== 'undefined'){
        SFILE.loadCheckedProjects(loadTab.checked_projects);
    }
    console.log("hiding all response containers");
    // hide all response containers
    $('.chatgpt-response-panel').css('display', 'none');
    $('.user_response_container').css('display', 'none');
    $('.project-context-files').css('display', 'none');

    // show the right one with the right uid
    $('#chatgptresponsepanel_' + uid).css('display', 'block');
    $('#contextfiles_stubs_' + uid).css('display', 'block');
    
    if(loadTab.task_sent){
        //gray box with task
        $('#replace_chatgpt_request').css('display', 'block');
        $('#chatgpt-request-container').css('display', 'none');
        $('#replace_chatgpt_request').html(loadTab.task_text);
        //actually lets not show this until they press button again
        $('#userresponsecontainer_' + uid).css('display', 'none');
        $('#diffheader').css('display', 'flex');
        
        // Enable buttons when task is sent
        $('#stop_button').prop('disabled', false);
        $('#debug_request_button').prop('disabled', false);
        $('#followup_button').prop('disabled', false);
    }else{
        //empty out field
        $('#replace_chatgpt_request').css('display', 'none');
        $('#chatgpt-request-container').css('display', 'flex');
        $('#chatgpt-request').val(loadTab.task_text);        
        $('#userresponsecontainer_' + uid).css('display', 'none'); 
        $('#diffheader').css('display', 'none');
        
        // Disable buttons when task is not sent
        $('#stop_button').prop('disabled', true);
        $('#debug_request_button').prop('disabled', true);
        $('#followup_button').prop('disabled', true);
    }
    
    $('#difflist_container').find('.diff-container').each(function(){
        let idSplit = this.id.split('_');
        let diffUid = idSplit[1];
        if(diffUid == uid){
            $(this).css('display', 'block');
        }else{
            $(this).css('display', 'none');            
        }
    });
  
    // Clear existing images in the image_attachments div
    const imageContainer = document.getElementById('image_attachments');
    imageContainer.innerHTML = '';

    // Load images for the current tab
    let currentTab = TABS.getTabByUid(uid);
    if (currentTab.has_image) {
        currentTab.context_images.forEach(imageData => {
            let imgCanvas = document.createElement('canvas');
            let ctx = imgCanvas.getContext('2d');
            let img = new Image();
            img.onload = () => {
                const aspectRatio = img.width / img.height;
                let width = 100;
                let height = 100;

                if (img.width > img.height) {
                  height = 100 / aspectRatio;
                } else {
                  width = 100 * aspectRatio;
                }

                imgCanvas.width = width;
                imgCanvas.height = height;
                ctx.drawImage(img, 0, 0, width, height);
                imageContainer.appendChild(imgCanvas);
            };
            img.src = `data:image/jpeg;base64,${imageData}`;
        });
    }
    TABS.CURRENT_INDEX = loadIndex;
    TABS.CURRENT_UID = uid;
    
    if (loadTab.use_schema) {
        $('#pick_database_tables').addClass('highlight');
    } else {
        $('#pick_database_tables').removeClass('highlight');
    }

    if (loadTab.use_documents) {
        $('#add_embeddings_context').addClass('highlight');
    } else {
        $('#add_embeddings_context').removeClass('highlight');
    }    
    
    // Update the tab's use_stubs property based on the hidden input value
    TABS.TAB_ARR[TABS.CURRENT_INDEX].use_stubs = ($('#stubs_on_switch').val() === '1');
    
    return loadIndex;
};
// Add this new function
TABS.saveCurrentTabText = function() {
    let currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
    currentTab.task_text = $('#chatgpt-request').val();
};

TABS.getCurrentUid = function(){
    if(TABS.CURRENT_INDEX >= TABS.TAB_ARR.length){
        alert("Tab index wrong, major error");        
    }
    
    let currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
    return currentTab['uid'];
};


TABS.getIndexByUid = function(uid){
    for(let x = 0; x < TABS.TAB_ARR.length; x++){
        if(TABS.TAB_ARR[x]['uid'] == uid){
            return x;
        }
    }    
    throw new Error('Tried to get tab that no longer exists: ' + uid);
};

TABS.deleteTabByIndex = function(tabIndex) {
    if (tabIndex >= 0 && tabIndex < TABS.TAB_ARR.length) {
        let deletedTab = TABS.TAB_ARR.splice(tabIndex, 1)[0];
        $('#tasktab_' + deletedTab.uid).remove();
        $('#chatgptresponsepanel_' + deletedTab.uid).remove();
        $('#contextfiles_stubs_' + deletedTab.uid).remove(); // Add this line
        $('#userresponsecontainer_' + deletedTab.uid).remove(); // Add this line
                
        if (TABS.TAB_ARR.length === 0) {
            // If no tabs left, create a new one
            let newTabIndex = TABS.ADD_NEW_TAB();
            TABS.loadTabByIndex(newTabIndex);
        } else if (TABS.CURRENT_INDEX >= TABS.TAB_ARR.length) {
            // If deleted last tab, select the new last tab
            TABS.CURRENT_INDEX = TABS.TAB_ARR.length - 1;
            TABS.loadTabByIndex(TABS.CURRENT_INDEX);
        } else {
            // Otherwise, load the tab at the current index
            TABS.loadTabByIndex(TABS.CURRENT_INDEX);
        }
    }
};

TABS.toggleDocuments = function(docNames) {
    let currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
    if ($('#add_embeddings_context').hasClass('highlight')) {
        // Remove embeddings
        currentTab.documents = [];
        currentTab.use_documents = false;
        $('#add_embeddings_context').removeClass('highlight');
    } else {
        // Add embeddings
        currentTab.documents = docNames;
        currentTab.use_documents = true;        
        $('#add_embeddings_context').addClass('highlight');
    }
};

TABS.CURRENT_TASK = "";


if (!process.type) {
    module.exports = TABS;
}