// js/terminal/terminal_renderer.js
const { Terminal } = require('@xterm/xterm');
const { FitAddon } = require('@xterm/addon-fit');
const { ipcRenderer } = require('electron');

const term = new Terminal();
const fitAddon = new FitAddon();
term.loadAddon(fitAddon);

term.open(document.getElementById('terminal'));
fitAddon.fit();

// Notify main process to start the PTY
ipcRenderer.send('pty-start');

// Handle window resize
window.onresize = () => {
  fitAddon.fit();
  ipcRenderer.send('pty-resize', { cols: term.cols, rows: term.rows });
};

term.onResize(({ cols, rows }) => {
  ipcRenderer.send('pty-resize', { cols, rows });
});

// Receive data from the PTY
ipcRenderer.on('pty-data', (event, data) => {
  term.write(data);
});

// Send user input to the PTY
term.onData(data => {
  ipcRenderer.send('pty-input', data);
});
