var COST = COST || {};

COST.models = [
  {
    name: 'haiku',
    inputCost: 0.25,
    outputCost: 1.25
  },
  {
    name: 'sonnet',
    inputCost: 3,
    outputCost: 15
  },
  {
    name: 'opus',
    inputCost: 15,
    outputCost: 75
  },
  {
    name: 'o1-preview',
    inputCost: 15,
    outputCost: 60
  },
  {
    name: 'o1-mini',
    inputCost: 3,
    outputCost: 12
  },  
  {
    name: 'gpt-4o',
    inputCost: 5,
    outputCost: 15
  },
  {
    name: 'gpt-4-turbo',
    inputCost: 10,
    outputCost: 30
  },
  {
    name: 'flash',
    inputCost: 0.35,
    outputCost: 1.05
  },
  {
    name: 'gemini-1.5',
    inputCost: 3.5,
    outputCost: 10.5
  },
  {
    name: 'codestral',
    inputCost: 4,
    outputCost: 12
  },
  {
    name: 'llama3-8b-8192',
    inputCost: 0.05,
    outputCost: 0.08,
    context: 8192
  },
  {
    name: 'llama3-70b-8192',
    inputCost: 0.59,
    outputCost: 0.79,
    context: 8192
  },
  {
    name: 'llama-3.1-8b-instant',
    inputCost: 0.59,
    outputCost: 0.79,
    context: 8192
  },
  {
    name: 'llama-3.1-70b-versatile',
    inputCost: 0.59,
    outputCost: 0.79,
    context: 8192
  },
  {
    name: 'llama-3.1-405b-reasoning',
    inputCost: 0.59,
    outputCost: 0.79,
    context: 8192
  },
  {
    name: 'mixtral-8x7b-32768',
    inputCost: 0.24,
    outputCost: 0.24,
    context: 32768
  }
];

COST.getTokenCost = function(fullModel, inputTokens, outputTokens){
    let model;
    if(fullModel.startsWith('http')){
        model = {
            name: 'gpt-4o',
            inputCost: 5,
            outputCost: 15
          };
    }else{
        model = COST.models.find(m => 
            fullModel === m.name || fullModel.includes(m.name)
        );
    }
    if (!model) {
        model = {
            name: 'unknown',
            inputCost: 5,
            outputCost: 15
          };        
        throw new Error(`Model ${fullModel} not found`);
    }
    const inputCost = (model.inputCost * inputTokens) / 1000000;
    const outputCost = (model.outputCost * outputTokens) / 1000000;
    return inputCost + outputCost;
};


COST.estimateTokens = function(text) {
    const charCount = text.length;
    const estimatedTokens = Math.ceil(charCount / 3.25);
    return estimatedTokens;
};