var SIMG = SIMG || {};
SIMG.attachedImages = [];
SIMG.screenshots = [];
SIMG.cropper = null;

$(document).ready(function () {
    $('body').on('click', '#pick_screenshot_window', function(){
        console.log("capturing all windows");
        if($('#modal_image_upload').length > 0){
            $('#modal_image_upload').remove();
        }        
        //captureAllWindows();
        let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_image_upload.html'), 'utf-8');
        let imageUploadModal = Mustache.render(modalHtml, {is_edit: false});
        $('body').append(imageUploadModal);    
        setTimeout(function(){
            MicroModal.show('modal_image_upload',
            {
              debugMode: true,
              disableScroll: true,
              onShow: function (modal) {  },
              onClose: function (modal) {  },
              awaitCloseAnimation: true
            });
        }, 100);        
    });
    
    
    $('body').on('click', '#modal_images_cancel', function() {
        MicroModal.close('modal_image_upload');
    });    

    $('body').on('click', '#upload_image', function(){
       const input = document.createElement('input');
       input.type = 'file';
       input.accept = 'image/*';
       input.onchange = (event) => {
         const file = event.target.files[0];
         const reader = new FileReader();
            reader.onload = () => {
              const base64Image = reader.result.split(',')[1];

              // Check if the uploaded image is a PNG
              if (file.type === 'image/png') {
                // Create an image element to load the PNG
                let img = new Image();
                
                img.onload = () => {
                  // Create a canvas element to draw the image
                  let canvas = document.createElement('canvas');
                  canvas.width = img.width;
                  canvas.height = img.height;
                  let ctx = canvas.getContext('2d');
                  ctx.drawImage(img, 0, 0);

                  // Convert the canvas to JPG and get the base64 data
                  const jpgBase64 = canvas.toDataURL('image/jpeg').split(',')[1];

                  // Store the JPG base64 data in the current tab
                  let currTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
                  currTab['context_images'].push(jpgBase64);    
                  currTab['has_image'] = true;

                  canvas = document.createElement('canvas');
                  canvas.width = 100;
                  canvas.height = 100;
                  ctx = canvas.getContext('2d');

                  let img2 = new Image();
                  img2.onload = () => {
                    const aspectRatio = img2.width / img2.height;
                    let width = 100;
                    let height = 100;

                    if (img2.width > img2.height) {
                      height = 100 / aspectRatio;
                    } else {
                      width = 100 * aspectRatio;
                    }

                    ctx.drawImage(img2, 0, 0, width, height);

                    $('#image_attachments').append(canvas);
                  };
                  img2.src = `data:image/jpeg;base64,${jpgBase64}`;
                };
                
                img.src = `data:image/png;base64,${base64Image}`;
                
              } else {
                // Store the base64Image directly for non-PNG images
                let currTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
                currTab['context_images'].push(base64Image);    
                currTab['has_image'] = true;

                const canvas = document.createElement('canvas');
                canvas.width = 100;
                canvas.height = 100;
                const ctx = canvas.getContext('2d');

                const img = new Image();
                img.src = `data:image/jpeg;base64,${base64Image}`;

                img.onload = () => {
                  const aspectRatio = img.width / img.height;
                  let width = 100;
                  let height = 100;

                  if (img.width > img.height) {
                    height = 100 / aspectRatio;
                  } else {
                    width = 100 * aspectRatio;
                  }

                  ctx.drawImage(img, 0, 0, width, height);

                  $('#image_attachments').append(canvas);
                };
              }
            };
         reader.readAsDataURL(file);
       };
       input.click();
    });  
    
    $('body').on('change', '#modal_image_upload input[type="file"]', function(event) {
        const file = event.target.files[0];
        const reader = new FileReader();
        reader.onload = () => {
            const base64Image = reader.result.split(',')[1];
            processImage(file, base64Image);
        };
        reader.readAsDataURL(file);
    });

    $('body').on('dragover', '.stubs_modal__image-upload-area', function(event) {
        event.preventDefault();
        event.stopPropagation();
        $(this).addClass('dragover');
    });

    $('body').on('dragleave', '.stubs_modal__image-upload-area', function(event) {
        event.preventDefault();
        event.stopPropagation();
        $(this).removeClass('dragover');
    });

    $('body').on('drop', '.stubs_modal__image-upload-area', function(event) {
        event.preventDefault();
        event.stopPropagation();
        $(this).removeClass('dragover');
        const files = event.originalEvent.dataTransfer.files;
        for (let i = 0; i < files.length; i++) {
            const file = files[i];
            const reader = new FileReader();
            reader.onload = () => {
                const base64Image = reader.result.split(',')[1];
                processImage(file, base64Image);
            };
            reader.readAsDataURL(file);
        }
    });

    $('body').on('click', '#modal_images_attach', function() {
        let currTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
        currTab['context_images'] = currTab['context_images'].concat(SIMG.attachedImages);
        if(SIMG.attachedImages.length > 0){
            currTab['has_image'] = true;
        }        
        SIMG.attachedImages = [];
        $('#attached_images').empty();
        MicroModal.close('modal_image_upload');
        
         //clear list
         $('#image_attachments').empty();
         
        console.log("after image modal context images now");
        console.log(currTab['context_images']);  
        // Append the attached images to the #image_attachments div
        currTab['context_images'].forEach(imageData => {
            let imgCanvas = document.createElement('canvas');
            let ctx = imgCanvas.getContext('2d');
            let img = new Image();
            img.onload = () => {
                const aspectRatio = img.width / img.height;
                let width = 100;
                let height = 100;

                if (img.width > img.height) {
                    height = 100 / aspectRatio;
                } else {
                    width = 100 * aspectRatio;
                }

                imgCanvas.width = width;
                imgCanvas.height = height;
                ctx.drawImage(img, 0, 0, width, height);
                $('#image_attachments').append(imgCanvas);
            };
            img.src = `data:image/jpeg;base64,${imageData}`;
        });

    });

    $('body').on('click', '.thumbnail', function() {
      const imageUrl = $(this).find('img').attr('src');
      const imageIndex = parseInt($(this).find('img').first().data('index'));
      console.log("index is " + imageIndex);
      const fullImage = SIMG.screenshots[imageIndex].fullimage;
      console.log("full iamge");
      console.log(fullImage);
      
      // Destroy the existing cropper instance if it exists
      if (SIMG.cropper != null) {
         SIMG.cropper.destroy();
      }
        
      $('#cropper_image').attr('src', fullImage);
      $('.thumbgrid-container').hide();
      $('.cropper_container').show();
      
        // Initialize Cropper on the image
        SIMG.cropper = new Cropper(document.getElementById('cropper_image'), {
          aspectRatio: NaN, // Remove the aspect ratio to allow free cropping
          viewMode: 1, // Set the view mode to fit the image within the container
          // Add more options as needed
        });      

        // Set the cropper wrapper dimensions
        $('.cropper_wrapper').css({
          width: '600px',
          height: '400px'
        }); 
  
      // Set the cropper container width to match the image width
      // $('.cropper_container').width($('#cropper_image').width());      
      
    });

    $('body').on('click', '#img-attach-backlink', function(e) {
      e.preventDefault();
      $('.cropper_container').hide();
      $('.thumbgrid-container').show();
    });

    $('body').on('click', '#attach_cropped', function() {
      // Get the cropped image data as base64 JPEG
      const croppedImageData = SIMG.cropper.getCroppedCanvas().toDataURL('image/jpeg');

      // Remove the "data:image/jpeg;base64," prefix to get only the base64 data
      const base64Image = croppedImageData.split(',')[1];

      // Process the cropped image data and add it to the attached images
      processCroppedImage(base64Image)
        .then(() => {
          $('.cropper_container').hide();
          $('.thumbgrid-container').show();

          // Destroy the Cropper instance
          SIMG.cropper.destroy();
        });
    });           
});

function processCroppedImage(base64Image) {
  return new Promise((resolve, reject) => {
    SIMG.attachedImages.push(base64Image);
    addThumbnail(base64Image);
    resolve();
  });
}

function processImage(file, base64Image) {
    return new Promise((resolve, reject) => {
        if (file.type === 'image/png') {
            let img = new Image();
            img.onload = () => {
                let canvas = document.createElement('canvas');
                canvas.width = img.width;
                canvas.height = img.height;
                let ctx = canvas.getContext('2d');
                ctx.drawImage(img, 0, 0);
                const jpgBase64 = canvas.toDataURL('image/jpeg').split(',')[1];
                SIMG.attachedImages.push(jpgBase64);
                addThumbnail(jpgBase64);
                resolve();
            };
            img.src = `data:image/png;base64,${base64Image}`;
        } else {
            SIMG.attachedImages.push(base64Image);
            addThumbnail(base64Image);
            resolve();
        }
    });
}

function addThumbnail(base64Image) {
    const canvas = document.createElement('canvas');
    canvas.width = 100;
    canvas.height = 100;
    const ctx = canvas.getContext('2d');
    const img = new Image();
    img.src = `data:image/jpeg;base64,${base64Image}`;
    img.onload = () => {
        const aspectRatio = img.width / img.height;
        let width = 100;
        let height = 100;
        if (img.width > img.height) {
            height = 100 / aspectRatio;
        } else {
            width = 100 * aspectRatio;
        }
        ctx.drawImage(img, 0, 0, width, height);
        $('#attached_images').append(canvas);
        $('#atttached_images_label').hide();
    };
}

SIMG.loadScreenshots = function(screenshots){
  $('.thumbgrid-container').empty();
  
  SIMG.screenshots = screenshots;
  
  const thumbnailGrid = $('<div class="thumbnail-grid stubs_scroll-cus"></div>');
  
  let index = 0;
  // Iterate over screenshots and create thumbnail elements
  screenshots.forEach(screenshot => {
    const thumbnailElement = $(`
      <div class="thumbnail">
        <img data-index="${index}" src="${screenshot.screenshot}" alt="${screenshot.title}">
        <span class="thumbnail-title">${screenshot.title}</span>
      </div>
    `);
    thumbnailGrid.append(thumbnailElement);
    index++;
  });
  
  // Append thumbnail grid to the panel-screen element
  $('.thumbgrid-container').append(thumbnailGrid);    
};