var PINFO = PINFO || {};

//step 1
PINFO.ProjectName = "";
PINFO.ProjectSlug = "";
PINFO.ProjectDesc = "";
PINFO.ProjectRules = "";
PINFO.ProjectPath = "";
//step 2
PINFO.StubIgnoreFile = "";
//step 3
PINFO.DocumentFiles = false;

STUBS.ADDED_LINKS = new Array();

function loadSettingsModal(showWarning){
    
    if ($('#modal_settings').length > 0) {
        $('#modal_settings').remove();
    }    
    let settingsModalBody = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_settings.html'), 'utf-8');
    let allAvailModelsArrays = CHATGPT.getAvailableProviderModels();
    
    let modelNames = allAvailModelsArrays[0];
    let modelLabels = allAvailModelsArrays[1];
    let allAvailModels = new Array();
    let availModelsExcepto1 = new Array();
    for(let m = 0; m < modelNames.length; m++){
        allAvailModels.push({ 'name': modelLabels[m], 'value' : modelNames[m] });
        if(modelNames[m].indexOf('o1') < 0){
            availModelsExcepto1.push({ 'name': modelLabels[m], 'value' : modelNames[m] });
        }
    }    
  
    storage.get('stubs_settings', function(error, stubsSettings) {
        if (error) throw error;

        let settingsModal = Mustache.render(settingsModalBody, {
            openai_key: CHATGPT.OPENAI_KEY, 
            anthropic_key: CHATGPT.ANTHROPIC_KEY, 
            gemini_key: CHATGPT.GEMINI_KEY,
            groq_key: CHATGPT.GROQ_KEY, 
            mistral_key: CHATGPT.MISTRAL_KEY, 
            show_warning: showWarning,
            llm_request_relevant_files_options: allAvailModels,
            llm_request_relevant_stub_lines_options: allAvailModels,
            llm_do_new_programming_task_options: availModelsExcepto1,
            llm_formalize_code_changes_options: allAvailModels,
            llm_prune_unlikely_project_files_options: allAvailModels       
        });

        $('body').append(settingsModal);


        setTimeout(function () {
            // Set the select options based on the loaded stubs settings
            // Set the select options based on the loaded stubs settings, if available
            if (stubsSettings) {
                refreshLLMSelectorPanel(stubsSettings);                                             
            }            
            MicroModal.show('modal_settings',
                {
                    debugMode: true,
                    disableScroll: true,
                    onShow: function (modal) { 
                        tooltip_tool();
                        setupTippyCustomEndpoint();    
                        refreshCustomApiUrlsTable();
                    },
                    onClose: function (modal) { },
                    awaitCloseAnimation: true               
                });
        }, 100);    
    });

   
}
function refreshLLMSelectorPanel(stubsSettings){
    
    let allAvailModelsArrays = CHATGPT.getAvailableProviderModels();
    
    let modelNames = allAvailModelsArrays[0];
    let modelLabels = allAvailModelsArrays[1];
    let allAvailModels = new Array();
    let availModelsExcepto1 = new Array();
    for(let m = 0; m < modelNames.length; m++){
        allAvailModels.push({ 'name': modelLabels[m], 'value' : modelNames[m] });
        if(modelNames[m].indexOf('o1') < 0){
            availModelsExcepto1.push({ 'name': modelLabels[m], 'value' : modelNames[m] });
        }
    }
    
    // Fill the options with the available options in the dropdowns
    const dropdowns = [
        'llm_request_relevant_files',
        'llm_request_relevant_stub_lines',
        
        'llm_formalize_code_changes',
        'llm_prune_unlikely_project_files'
    ];
    const dropdowns2 = [
        'llm_do_new_programming_task'
    ];

    dropdowns.forEach(dropdown => {
        const select = $(`#${dropdown}`);
        select.empty(); // Clear existing options
        select.append('<option value="recommended">Recommended</option>');
        allAvailModels.forEach(model => {
            select.append(`<option value="${model.value}">${model.name}</option>`);
        });
    });
    
    dropdowns2.forEach(dropdown => {
        const select = $(`#${dropdown}`);
        select.empty(); // Clear existing options
        select.append('<option value="recommended">Recommended</option>');
        availModelsExcepto1.forEach(model => {
            select.append(`<option value="${model.value}">${model.name}</option>`);
        });
    });    
    
    
    if(stubsSettings.llm_request_relevant_files){
        $('#llm_request_relevant_files').val(stubsSettings.llm_request_relevant_files);
    }else{
        $('#llm_request_relevant_files').val("recommended");
    } 
    if(stubsSettings.llm_request_relevant_stub_lines){
        $('#llm_request_relevant_stub_lines').val(stubsSettings.llm_request_relevant_stub_lines);
    }else{
        $('#llm_request_relevant_stub_lines').val("recommended");
    }

    if(stubsSettings.llm_do_new_programming_task){
        $('#llm_do_new_programming_task').val(stubsSettings.llm_do_new_programming_task);
    }else{
        $('#llm_do_new_programming_task').val("recommended");
    }

    if(stubsSettings.llm_formalize_code_changes){
        $('#llm_formalize_code_changes').val(stubsSettings.llm_formalize_code_changes);
    }else{
        $('#llm_formalize_code_changes').val("recommended");
    }

    if(stubsSettings.llm_prune_unlikely_project_files){
        $('#llm_prune_unlikely_project_files').val(stubsSettings.llm_prune_unlikely_project_files);
    }else{
        $('#llm_prune_unlikely_project_files').val("recommended");
    }
    if(typeof(stubsSettings.codemirror_theme) !== 'undefined'){
        $('#codemirror_theme').val(stubsSettings.codemirror_theme);
    }
    if(typeof(stubsSettings.apply_changes_by) !== 'undefined'){
         $('#apply_changes_by').val(stubsSettings.apply_changes_by);
    }       
}
function loadReferenceProjectsModal() {
  if ($('#modal_reference_projects').length > 0) {
    $('#modal_reference_projects').remove();
  }

  const { checkedProjects } = SFILE.getCheckedProjects();
  const allProjects = STUBS.ALL_PROJECT_ARR.filter(project => !checkedProjects.includes(project.project_slug));

  let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views', 'modal_reference_projects.html'), 'utf-8');
  let data = {
    projects: allProjects.map(project => ({
      name: project.name,
      slug: project.project_slug
    }))
  };

  let referenceProjectsModal = Mustache.render(modalHtml, data);
  $('body').append(referenceProjectsModal);

  setTimeout(function() {
    MicroModal.show('modal_reference_projects', {
      debugMode: true,
      disableScroll: true,
      onShow: function(modal) {},
      onClose: function(modal) {},
      awaitCloseAnimation: true
    });
  }, 100);
}


$(document).ready(function () {
    // Close modal when cancel button or close button is clicked
    $('body').on('click', '#modal_debug_cancel, #modal_debug .stubs_modal__close', function () {
        MicroModal.close('modal_debug');
    });

    
    $('body').on('click', '#menu-settings', async function (event) {
        event.preventDefault();

        // Request settings from main process
        let showWarning = false;
        if(CHATGPT.OPENAI_KEY == '' && CHATGPT.ANTHROPIC_KEY == '' && CHATGPT.GEMINI_KEY == ''){
            //shouldn't have gotten here?
            showWarning = true;
        }
        loadSettingsModal(showWarning);

    });
    
    $('body').on('click', '#modal_settings_cancel,#force_close_settings_modal', function (e) {
        if ($('#stubs_modal_warning').length > 0) { // Check if the warning exists
            e.preventDefault();
            e.stopPropagation();
            if(this.id == 'force_close_settings_modal' && $('.key-warning-message').css('display') == 'block'){
                alert("API KEY REQUIRED - CLOSING APPLICATION");
                ipcRenderer.send('close-application');        
            }
            $('.key-warning-message').css('display', 'block');
        } else {
            MicroModal.close('modal_settings');
        }
    });
    
    $('body').on('click', '#show_planner', async function (event) {
        event.preventDefault();
        const { checkedProjects, checkedProjectPaths } = SFILE.getCheckedProjects();
        if(checkedProjects.length <= 0){
            alert("Please select one of your projects in the left sidebar");
            return;
        }

        let projectFileData = await SFILE.getAvailableFilesForGPT(checkedProjects, STUBS.stubsData);
        let justFilesLinux = projectFileData['files_linux'];

        // Open the realtime window and send the project data
        ipcRenderer.invoke('open-realtime-window', {
            projectFiles: justFilesLinux,
            projectName: checkedProjects[0]
        });
    });
            /*
    $('body').on('click', '#modal_planner_cancel, #modal_planner .stubs_modal__close', function () {
        MicroModal.close('modal_planner');
    });
  */
    $('body').on('click', '.modal_settings_project__sidebar li', function (e) {
        e.preventDefault();
        const panel = $(this).data('panel');
        $('.modal_settings_project__sidebar li').removeClass('active');
        $(this).addClass('active');
        $('.modal_settings_content .step').hide();
        $(`.modal_settings_content .panel-${panel}`).show();
    });

    $('body').on('click', '.edit-project', function (event) {
      event.preventDefault();
      const projectSlug = $(this).data('project-slug');

      storage.get('all_projects', function(error, data) {
        if (error) throw error;

        let all_projects = data.all_projects || [];
        const project = all_projects.find(p => p.project_slug === projectSlug);

        if (project) {
          if($('#modal_addedit_project').length > 0){
            $('#modal_addedit_project').remove();
          }
          let projectModalBody = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_addedit_project.html'), 'utf-8');
          let editProjectModal = Mustache.render(projectModalBody, {is_edit: true});

          $('body').append(editProjectModal);

          // Populate form fields with project data
          $('#project_name').val(project.name);
          $('#project_folder').val(project.folder);
          $('#project_description').val(project.description);
          $('#llm_rules').val(project.llm_rules);
          $('#document_files').prop('checked', project.document_files);
          
          PINFO.ProjectName = project.name;
          PINFO.ProjectPath = project.folder;
          PINFO.ProjectDesc = project.description;
          PINFO.ProjectRules = project.document_files;
          PINFO.ProjectSlug = PINFO.ProjectName.replace(/[^a-zA-Z0-9]/g, '-').replace(/--+/g, '-').toLowerCase();
          loadProjectStubIgnore(project.folder);
          
          setTimeout(function(){
            MicroModal.show('modal_addedit_project', {
              debugMode: true,
              disableScroll: true,
              onShow: function (modal) {
                $('#modal_addedit_submit').text('Save Project');
                $('#modal_addedit_delete').show();
              },
              onClose: function (modal) {},
              awaitCloseAnimation: true
            });
            setupTippyPrune();
          }, 100);
        }
      });
  	});

    $('body').on('click', '#modal_addedit_delete', function (e) {
      e.preventDefault();
      e.stopPropagation();

      if (confirm('Are you sure you want to delete this project?')) {
        const projectSlug = PINFO.ProjectSlug;
        console.log("deleting project slug");
        console.log(projectSlug);

        storage.get('all_projects', function(error, data) {
          if (error) throw error;

          let all_projects = data.all_projects || [];
        console.log("allprojects before");
        console.log(all_projects);
          
        const updatedProjects = all_projects.filter(project => project.project_slug !== projectSlug);

        console.log("after");
        console.log(updatedProjects);
        // Remove the project slug from EMBED.projectReadyArray
        delete EMBED.projectReadyArray[projectSlug];
        const { checkedProjects, checkedProjectPaths } = SFILE.getCheckedProjects();
        let tabUid = TABS.getCurrentUid();
        let tabIndex = TABS.getIndexByUid(tabUid); 
        TABS.TAB_ARR[tabIndex]['checked_projects'] = checkedProjects;
        TABS.TAB_ARR[tabIndex]['checked_project_paths'] = checkedProjectPaths;        

          storage.set('all_projects', { all_projects: updatedProjects }, function(error) {
            if (error) throw error;
            console.log('Project deleted successfully');
            MicroModal.close('modal_addedit_project');            
            STUBS.loadSettings(); 
          });
        });
        
      }
    });
    
    
    $('body').on('click', '#add_reference_project', function() {
      loadReferenceProjectsModal();
    });

    $('body').on('click', '#select_reference_project', function() {
      let checkedProjects = $('.reference-projects-list input[type="checkbox"]:checked').map(function() {
          return $(this).val();
      }).get();

      let currentUid = TABS.getCurrentUid();
      let tabIndex = TABS.getIndexByUid(currentUid);

      if (checkedProjects.length > 0) {
          TABS.TAB_ARR[tabIndex]['use_projects'] = true;
          TABS.TAB_ARR[tabIndex]['referenced_projects'] = checkedProjects;
          $('#add_embeddings_context').addClass('highlight');
      } else {
          TABS.TAB_ARR[tabIndex]['use_projects'] = false;
          TABS.TAB_ARR[tabIndex]['referenced_projects'] = [];
          $('#add_embeddings_context').removeClass('highlight');
      }

      console.log("Updated use_projects:", TABS.TAB_ARR[tabIndex]['use_projects']);
      console.log("Updated referenced_projects:", TABS.TAB_ARR[tabIndex]['referenced_projects']);

      MicroModal.close('modal_reference_projects');
    });
  
    $('body').on('click', '#alter_database_context', function (e) {
      e.stopPropagation();
      $('#database_context_dropdown').toggle();
    });

    // Close the dropdown when clicking outside
    $(document).on('click', function (e) {
      if (!$(e.target).closest('#alter_database_context').length) {
        $('#database_context_dropdown').hide();
      }
    });
    
	$('body').on('click', '#modal_settings_submit', async function (e) {
      e.preventDefault();
      e.stopPropagation();
      console.log("Saving Settings");
      let openaiKey = $('#openai_key').val();
      let geminiKey = $('#gemini_key').val();
      let anthropicKey = $('#anthropic_key').val();
      let groqKey = $('#groq_key').val();
      let mistralKey = $('#mistral_key').val(); // Add this line to get the Mistral API key

      let hasAkey = '';

      if (openaiKey !== '') {
          ipcRenderer.invoke('save-api-credentials', {
              name: 'openai',
              key: openaiKey
          });
          hasAkey = true;
      }

      if (geminiKey !== '') {
          ipcRenderer.invoke('save-api-credentials', {
              name: 'gemini',
              key: geminiKey
          });
          hasAkey = true;            
      }

      if (anthropicKey !== '') {
          ipcRenderer.invoke('save-api-credentials', {
              name: 'anthropic',
              key: anthropicKey
          });
          hasAkey = true;            
      }
      if (groqKey !== '') { // Add this block
          ipcRenderer.invoke('save-api-credentials', {
              name: 'groq',
              key: groqKey
          });
          hasAkey = true;            
      }
      if (mistralKey !== '') { // Add this block to save the Mistral API key
          ipcRenderer.invoke('save-api-credentials', {
              name: 'mistral',
              key: mistralKey
          });
          hasAkey = true;            
      }
      if(STUBS.CUSTOM_API_URLS.length > 0){
          hasAkey = true;
      }


      if(!hasAkey){
          console.log("no key");
          $('.key-warning-message').css('display', 'block');     
      }else{
          CHATGPT.OPENAI_KEY = openaiKey;
          CHATGPT.GEMINI_KEY = geminiKey;
          CHATGPT.ANTHROPIC_KEY = anthropicKey;
          CHATGPT.GROQ_KEY = groqKey; // Add this line         
          CHATGPT.GROQ_KEY = groqKey; // Add this line         
          CHATGPT.MISTRAL_KEY = mistralKey; // Add this line to set the Mistral API key
          MicroModal.close('modal_settings');            
      }
      let llmRequestRelevantFiles = $('#llm_request_relevant_files').val();
      let llmRequestRelevantStubLines = $('#llm_request_relevant_stub_lines').val();
      let llmDoNewProgrammingTask = $('#llm_do_new_programming_task').val();
      let llmFormalizeCodeChanges = $('#llm_formalize_code_changes').val();
      let llmPruneUnlikelyProjectFiles = $('#llm_prune_unlikely_project_files').val();
      let codemirrorTheme = $('#codemirror_theme').val();
      let applyChangesBy = $('#apply_changes_by').val();

      let stubsSettings = {
          llm_request_relevant_files: llmRequestRelevantFiles,
          llm_request_relevant_stub_lines: llmRequestRelevantStubLines,
          llm_do_new_programming_task: llmDoNewProgrammingTask,
          llm_formalize_code_changes: llmFormalizeCodeChanges,
          llm_prune_unlikely_project_files: llmPruneUnlikelyProjectFiles,
          codemirror_theme: codemirrorTheme,
          apply_changes_by: applyChangesBy          
      };      

      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();
      stubsSettings.default_projects = checkedProjects;
      stubsSettings.custom_api_urls = STUBS.CUSTOM_API_URLS;
      
      storage.set('stubs_settings', stubsSettings, function(error) {
          CHATGPT.updateAvailableProviders();
          CHATGPT.getAvailableProviderModels();     
          //do not load default projects but overwrite user array of desired LLMS
          STUBS.loadCurrentLLMs(false);      
          if (error) throw error;
          console.log('LLM THEME Stubs settings saved successfully');
      });     
  });

    
  	$('body').on('click', '.external-link', function (event) {
        let theLink = "";
        if(this.id == 'anthropic_link'){
            theLink = 'https://console.anthropic.com/account/keys';
        }

        if(this.id == 'openai_link'){
            theLink = 'https://platform.openai.com/settings/organization/general';
        }
        
        if(this.id == 'gemini_link'){
            theLink = 'https://makersuite.google.com/app/apikey';
        }
        
        if(this.id == 'groq_link'){
            theLink = 'https://console.groq.com/keys';
        }     
        
        if(this.id == 'get_pro_version'){
            theLink = 'https://stubs.dev/pricing';
        }
        
        if(this.id == 'changelog'){
            theLink = 'https://stubs.dev/changelog';
        }
        console.log("the link is " + theLink);
             
        if(theLink != ''){
            //call shell in main process
            ipcRenderer.send('open-external-link', theLink);
        }
        
    });
    
  	$('body').on('click', '#add_project,#alt_addproject,#menu-add-project', function (event) {
   		storage.get('all_projects', function(error, data) {
          if (error) throw error;

          let all_projects = data.all_projects || [];

          if (all_projects.length >= 4) {
            alert("Maximum projects added. Multiple projects are allowed to allow others as reference but it's not recommended to have more than a few at a time. You can edit and remove a project to add a different one.");
            return;
          }

          if($('#modal_addedit_project').length > 0){
              $('#modal_addedit_project').remove();
          }
          let projectModalBody = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_addedit_project.html'), 'utf-8');
          let addProjectModal = Mustache.render(projectModalBody, {is_edit: false});

          $('body').append(addProjectModal);      

          setTimeout(function(){
              //add project
              MicroModal.show('modal_addedit_project',
              {
                debugMode: true,
                disableScroll: true,
                onShow: function (modal) {  },
                onClose: function (modal) {  },
                awaitCloseAnimation: true
              });      
              setupTippyPrune();
          }, 100);
      });
  });
  
    $('body').on('click', '#modal_addedit_submit', function (e) {
        e.preventDefault();
        e.stopPropagation();
        PINFO.ProjectName = $('#project_name').val();
        PINFO.ProjectDesc = $('#project_description').val();
        PINFO.ProjectRules = $('#llm_rules').val();
        PINFO.ProjectPath = $('#project_folder').val();                
        if (!PINFO.ProjectName || !PINFO.ProjectPath || !PINFO.ProjectDesc) {
            alert('Please fill in all required fields.');
            return;
        }
        if (!fs.existsSync(PINFO.ProjectPath)) {
            alert('Invalid project folder. Please select a valid directory.');
            return;
        }               
        PINFO.ProjectSlug = PINFO.ProjectName.replace(/[^a-zA-Z0-9]/g, '-').replace(/--+/g, '-').toLowerCase();     

        storage.get('all_projects', function(error, data) {
            if (error) throw error;

            let all_projects = data.all_projects || [];
            
            PINFO.DocumentFiles = $('#document_files').is(':checked');
            
            let editVal = $('#modal_addedit_project').data('isedit');
            console.log("edit val is");
            console.log(editVal);
            let isEdit = (editVal.toString() == 'true');
            
            if (isEdit) {
                console.log("is edit");
                let projectIndex = all_projects.findIndex(project => project.folder === PINFO.ProjectPath);
                if (projectIndex !== -1) {
                    all_projects[projectIndex] = {
                        name: PINFO.ProjectName,
                        project_slug: PINFO.ProjectSlug,
                        folder: PINFO.ProjectPath,
                        description: PINFO.ProjectDesc,
                        llm_rules: PINFO.ProjectRules,
                        document_files: PINFO.DocumentFiles,
                        selected_db_connection: all_projects[projectIndex].selected_db_connection,
                        selected_db_schema: all_projects[projectIndex].selected_db_schema
                    };
                }
            } 
            else {
                console.log("is NOT edit");
                if (!all_projects.some(project => project.folder === PINFO.ProjectPath)) {
                    all_projects.push({
                        name: PINFO.ProjectName,
                        project_slug: PINFO.ProjectSlug,
                        folder: PINFO.ProjectPath,
                        description: PINFO.ProjectDesc,
                        llm_rules: PINFO.ProjectRules,
                        document_files: PINFO.DocumentFiles,
                        selected_db_connection: "",
                        selected_db_schema: ""
                    });
                    STUBS.projectArr.push({
                        name: PINFO.ProjectName,
                        folder: PINFO.ProjectPath,
                        project_slug: PINFO.ProjectSlug,
                        description: PINFO.ProjectDesc
                    });               
                    SFILE.createProjectCheckboxes(STUBS.projectArr);
                    
                    STUBS.STUBS_LOADED = false;
                    doStubCreation(function(){
                        doEmbeddingsCheck();    
                        STUI.refreshTributeDropdown([PINFO.ProjectSlug]);
                        STUBS.STUBS_LOADED = true;
                    });
                    
                } else {
                    alert('A project with this folder already exists.');
                    return;
                }
            }
            

            // Write the .stubignore file in the project directory
            const stubIgnoreContent = $('#default-stub-ignore').val();
            const stubIgnorePath = path.join(PINFO.ProjectPath, '.stubignore');
            try {
              fs.writeFileSync(stubIgnorePath, stubIgnoreContent);
              console.log('Successfully created .stubignore file');
            } catch (error) {
              if (error.code === 'EACCES') {
                // Handle permissions error
                console.error('Permission denied. Unable to write .stubignore file.');
                alert('Error: Permission denied. Unable to write .stubignore file in the selected project directory. Please ensure you have write permissions for the directory.');
              } else {
                // Handle other errors
                console.error('Error creating .stubignore file:', error);
                alert('An error occurred while creating the .stubignore file. Please check the console for more details.');
              }
            }            
            
            // Save the updated all_projects to storage
            storage.set('all_projects', { all_projects: all_projects }, function(error) {
                if (error) {
                    alert("Unable to save project data to user data directory storage: " + STUBS.userDataPath);
                    throw error;
                }
            });
            
            const { checkedProjects, checkedProjectPaths } = SFILE.getCheckedProjects();
            let tabUid = TABS.getCurrentUid();
            let tabIndex = TABS.getIndexByUid(tabUid); 
            TABS.TAB_ARR[tabIndex]['checked_projects'] = checkedProjects;
            TABS.TAB_ARR[tabIndex]['checked_project_paths'] = checkedProjectPaths;  
            
            
            MicroModal.close('modal_addedit_project');
        });

    });    
  
    $('body').on('click', '#modal_addedit_next', function (e) {
        e.preventDefault();
        e.stopPropagation();
        let currentStep = $('#modal_addedit_project .stubs_modal-sidebar li.active').data('step');
        console.log("In next with currentStep: " + currentStep);
        if (currentStep == 1) {
            PINFO.ProjectName = $('#project_name').val();
            PINFO.ProjectDesc = $('#project_description').val();
            PINFO.ProjectRules = $('#llm_rules').val();
            PINFO.ProjectPath = $('#project_folder').val();                
            if (!PINFO.ProjectName || !PINFO.ProjectPath || !PINFO.ProjectDesc) {
                alert('Please fill in all required fields.');
                return;
            }
            if (!fs.existsSync(PINFO.ProjectPath)) {
                alert('Invalid project folder. Please select a valid directory.');
                return;
            }               
            PINFO.ProjectSlug = PINFO.ProjectName.replace(/[^a-zA-Z0-9]/g, '-').replace(/--+/g, '-').toLowerCase();  
            //load the directory tree for project HERE
            const projectTreeContainer = document.getElementById('project-tree-container');
            loadProjectStubIgnore(PINFO.ProjectPath);            
            setTimeout(function(){
                let currentStubFile = $('#default-stub-ignore').val();
                createProjectRoots(projectTreeContainer, PINFO.ProjectName, PINFO.ProjectPath, currentStubFile);
                setTimeout(function(){
                    updateProjectTree();                
                }, 200);                
            }, 100);
        } 
        else if(currentStep == 2){
            //do validation for Step 2 
            $('#modal_addedit_next').hide();
            $('#modal_addedit_submit').show();      
        }
        
        if(currentStep > 0) {
            $('#modal_addedit_prev').show();
        }
        if(currentStep == 2){
            console.log("Showing submit button");
            $('#modal_addedit_submit').show();
            $('#modal_addedit_next').hide();            
        }
        
        if (currentStep < 3) {
            $('#modal_addedit_project .stubs_modal-sidebar li.active').removeClass('active').next().addClass('active');
            $('.modal_addedit_project__content .step.step-' + currentStep).hide().next().show();
        }
    });

    $('body').on('click', '#modal_addedit_prev', function (e) {
        e.preventDefault();
        e.stopPropagation();

        const currentStep = $('#modal_addedit_project .stubs_modal-sidebar li.active').data('step');

        if (currentStep > 1) {
            $('#modal_addedit_project .stubs_modal-sidebar li.active').removeClass('active').prev().addClass('active');
            $('.modal_addedit_project__content .step.step-' + currentStep).hide().prev().show();

            if (currentStep === 3) {
                $('#modal_addedit_submit').hide();
                $('#modal_addedit_next').show();
            }

            if (currentStep === 2) {
                $('#modal_addedit_prev').hide();
            }
        }
    });  
    $('body').on('blur', '#default-stub-ignore', function() {
        updateProjectTree();
    });

    $('body').on('keypress', '#default-stub-ignore', function(e) {
        if (e.which === 13) {
            updateProjectTree();
        }
    });
  
    $('body').on('click', '#modal_addedit_project .stubs_modal-sidebar li', function (e) {
      e.preventDefault();
      const isEditModal = $('#modal_addedit_project').data('isedit');
      if (isEditModal) {
        const step = $(this).data('step');
        console.log("editing the modal step " + step);        
        $('#modal_addedit_project .stubs_modal-sidebar li').removeClass('active');
        $(this).addClass('active');
        $('.modal_addedit_project__content .step').hide();
        $(`.modal_addedit_project__content .step-${step}`).show();
        if(step == 2){
            console.log("loading project tree");
            loadProjectStubIgnore(PINFO.ProjectPath);
            setTimeout(function(){
                updateProjectTree();                
            }, 100);
        }
        if(step == 3){
            
        }
      }
      
      
      
    });
  
    $('body').on('click', '.modal_image_upload__sidebar li', function (e) {
      e.preventDefault();
      const panel = $(this).data('panel');
      $('.modal_image_upload__sidebar li').removeClass('active');
      $(this).addClass('active');
      $('.modal_image_upload__content .panel').hide();
      $(`.modal_image_upload__content .panel-${panel}`).show();
      if (panel === 'screen') {
        captureAllWindows();
      }      
    });
    
    $('body').on('click', '.remove-connection', async function() {
        const connectionName = $(this).data('connection');
        if (confirm(`Are you sure you want to delete the connection "${connectionName}"?`)) {
            try {
                await ipcRenderer.invoke('delete-connection', connectionName);
                refreshExistingConnectionsList();
            } catch (error) {
                console.error('Error deleting connection:', error);
                alert('Failed to delete connection. Please try again.');
            }
        }
    });    

    $('body').on('click', '#pick_database_tables,#select_attached_schemas,#add_new_database', async function(){
        if($('#modal_database_connection').length > 0){
            $('#modal_database_connection').remove();
        }       
        var me = this;
      
        let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();  
        let currentTabUid = TABS.getCurrentUid();
        let currentTabData = TABS.TAB_ARR[TABS.getIndexByUid(currentTabUid)];        
        let data = await getStorageData('all_projects');
        console.log("allprojdata");
        console.log(data);
        
        // Get all the saved connections
        const connections = await ipcRenderer.invoke('get-connections');
        console.log("connections");
        console.log(connections);        
        let all_projects = data.all_projects || [];
        
       

        const projectWithSchema = all_projects.find(project => 
            checkedProjects.includes(project.project_slug) && project.selected_db_schema
        );
        console.log("projectWithSchema: " );
        console.log(projectWithSchema);

        if (projectWithSchema && this.id != 'select_attached_schemas' && this.id != "add_new_database") {
            if ($('#pick_database_tables').hasClass('highlight')) {
                TABS.TAB_ARR[TABS.CURRENT_INDEX]['use_schema'] = false;
                $('#pick_database_tables').removeClass('highlight');
            } else {
                let selectedConnection = null;
                let schemaText = "";
                for(let aConn in connections){
                    if(projectWithSchema['selected_db_connection'] == connections[aConn]['name']){
                        selectedConnection = connections[aConn];
                        break; // We only need the first connection                        
                    }
                }

                if (selectedConnection) {
                    console.log("selected connection: ", selectedConnection);
                    // Initialize the database with the selected connection
                    if (selectedConnection.type === 'mysql') {
                        await mysqlConn.initDatabase(selectedConnection);
                        console.log("mysql - getting table structure for schema " + projectWithSchema.selected_db_schema);
                        schemaText += await mysqlConn.getTableStructure(projectWithSchema.selected_db_schema);
                    } else if (selectedConnection.type === 'postgresql') {
                        await UPOSTGRES.initDatabase(selectedConnection);
                        console.log("postgres - getting table structure for schema " + projectWithSchema.selected_db_schema);                        
                        schemaText += await UPOSTGRES.getTableStructure(projectWithSchema.selected_db_schema);
                    }

                    console.log("schema text");
                    console.log(schemaText);
                    TABS.TAB_ARR[TABS.CURRENT_INDEX]['schema_text'] = schemaText;
                    TABS.TAB_ARR[TABS.CURRENT_INDEX]['use_schema'] = true;
                    $('#pick_database_tables').addClass('highlight');
                }
            }
            return;
        }




        if (this.id != "add_new_database" && connections && Object.keys(connections).length > 0) {
            const schemaTableMap = {};

            for (const connectionName in connections) {
                const connection = connections[connectionName];
                let schemas, tables;

                if (connection.type === 'mysql') {
                    await mysqlConn.initDatabase(connection);
                    schemas = await mysqlConn.getSchemas();
                } else if (connection.type === 'postgresql') {
                    await UPOSTGRES.initDatabase(connection);
                    schemas = await UPOSTGRES.getSchemas();
                }

                for (const schema of schemas) {
                    if (schema === 'information_schema') continue;

                    if (connection.type === 'mysql') {
                        tables = await mysqlConn.getTables(schema);
                    } else if (connection.type === 'postgresql') {
                        tables = await UPOSTGRES.getTables(schema);
                    }

                    schemaTableMap[`${connectionName}:${schema}`] = {
                        connection: connectionName,
                        tables: tables
                    };
                }
            }

            // Render the modal with schemas and tables
            let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_select_schemas.html'), 'utf-8');
            let data = {
                schemas: Object.entries(schemaTableMap).map(([key, value]) => ({
                    name: key,
                    connection: value.connection,
                    tables: value.tables
                }))
            };
            let databaseTablesModal = Mustache.render(modalHtml, data);
            $('body').append(databaseTablesModal);    
            // Display current projects
            $('#current_projects').text(checkedProjects.join(', '));
            storage.get('all_projects', function(error, data) {
                if (error) throw error;

                let all_projects = data.all_projects || [];

                all_projects.forEach(project => {
                    if (checkedProjects.includes(project.project_slug) && project.selected_db_schema) {
                        $(`.schema-checkbox[value="${project.selected_db_schema}"]`).prop('checked', true);
                    }
                });
            });



            setTimeout(function(){
                MicroModal.show('modal_database_tables',
                {
                  debugMode: true,
                  disableScroll: true,
                  onShow: function (modal) {  },
                  onClose: function (modal) {  },
                  awaitCloseAnimation: true
                });
            }, 100);
        } else {
            if(this.id != "add_new_database"){
                console.log("No databaseeeeeeeee connections");
            }
            //If no database connections created, then open to create one
            let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_database_connection.html'), 'utf-8');
            let databaseConnectionModal = Mustache.render(modalHtml, {is_edit: false});
            $('body').append(databaseConnectionModal);    
            setTimeout(function(){
                MicroModal.show('modal_database_connection',
                {
                  debugMode: true,
                  disableScroll: true,
                  onShow: function (modal) { refreshExistingConnectionsList(); },
                  onClose: function (modal) {  },
                  awaitCloseAnimation: true
                });
            }, 100);
        }
    });
    
  $('body').on('click', '#modal_db_cancel', function(){
      MicroModal.close('modal_database_connection');
  });
  
  $('body').on('click', '#modal_addedit_cancel', function(){
      MicroModal.close('modal_addedit_project');
  });

  $('body').on('click', '#modal_db_connect', async function(){
      let connectionName = $('#connection_name').val();
	let connectionType = $('#connection_type').val();
    let host = $('#db_host').val();
    let port = $('#db_port').val();
    let username = $('#db_username').val(); 
    let password = $('#db_password').val();
    let defaultSchema = $('#default_schema').val();

    try {
        let isValid;
        let connectionConfig = {
            host: host,
            port: port,
            user: username,
            password: password,
            database: defaultSchema
        };

        if (connectionType === "mysql") {
            isValid = await mysqlConn.testConnection(connectionConfig);
        } else if (connectionType === "postgresql") {
            isValid = await UPOSTGRES.testConnection(connectionConfig);
        } else {
            alert("This database type is not supported yet.");
            return;
        }

        if (isValid) {
            let connectionDetails = {
                name: connectionName,
                host: host,
                port: port,
                user: username,
                password: password,
                type: connectionType,
                database: defaultSchema
            };
          
            let saved = await ipcRenderer.invoke('save-connection', connectionDetails);

            if (saved) {
                console.log('Connection details saved successfully');
                MicroModal.close('modal_database_connection');
                refreshExistingConnectionsList();
            } else {
                alert('Failed to save connection details. Please try again.');
            }              
        } else {
            alert('Failed to connect to the database. Please check your connection details.');
        }
    } catch (error) {
        console.error('Error testing database connection:', error);
        alert('An error occurred while testing the database connection. Please try again.');
    }
  });
  
  $('body').on('click', '#modal_db_tables_cancel', function(){
      MicroModal.close('modal_database_tables');
  });

  $('body').on('click', '#modal_db_schema_select', async function(){
    let selectedSchemaFull = $('.schema-checkbox:checked').val();
    let selectedConnection = $('.schema-checkbox:checked').data('connection');

    
    let selectedSchema = selectedSchemaFull.split(':')[1];
    console.log('Selected schema:', selectedSchema);
    console.log('Selected connection:', selectedConnection);

    // Get the currently checked project
    let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();
    let currentProject = checkedProjects[0];

    try {
        await updateProjectData(currentProject, {
            selected_db_schema: selectedSchema,
            selected_db_connection: selectedConnection
        });
        console.log('Project data updated successfully');
    } catch (error) {
        console.error('Error updating project data:', error);
    }

      MicroModal.close('modal_database_tables');
  });
  
  
  $('body').on('click', '#debug_request_button', async function(){
        //alert("loading modal222");
        let tabUid = TABS.getCurrentUid();
        let tabIndex = TABS.getIndexByUid(tabUid);      
        //let allRequests = await mysqlLogger.getAllRequestsByUid(tabUid);
        let allRequests = await dexieDB.getAllRequestsByUid(tabUid);
        console.log("allRequests is");
        console.log(allRequests);
        
        if(!allRequests || allRequests.length <= 0){
            //let latestTask = await mysqlLogger.getLatestResponseByRequestType('do_new_programming_task');
            let latestTask = await dexieDB.getLatestResponseByRequestType('do_new_programming_task');
            console.log(latestTask);
            let theUid = latestTask.uid;
            
            console.log("using latest uid");
            console.log(theUid);
            allRequests = await mysqlLogger.getAllRequestsByUid(theUid);
            
            console.log("requests");
            console.log(allRequests);
        }
        
        
        let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_debug_prompts.html'), 'utf-8');
        let debugPromptsModal = Mustache.render(modalHtml);
        $('body').append(debugPromptsModal);            

        // Clear existing prompts
        $('#debug_prompts_container').empty();
        let LLM_REQUEST_TYPES = [
               { value: 'do_new_programming_task', display: 'Do New Programming Task' },
               { value: 'ask_codebase_question', display: 'Ask Codebase Question' },
               { value: 'do_additional_programming_task', display: 'Do Additional Programming Task' },
               { value: 'request_relevant_files', display: 'Request Relevant Files' },
               { value: 'request_relevant_stub_lines', display: 'Request Relevant Stub Lines' },
               { value: 'formalize_code_changes', display: 'Formalize Code Changes' },
               { value: 'prune_unlikely_project_files', display: 'Prune Unlikely Project Files' }
           ];      
        // Loop through each request and add a textarea with the full_prompt
        for(let i = 0; i < allRequests.length; i++) {
            let fullPrompt = allRequests[i].full_prompt;
            let assistantMessage = allRequests[i].assistant_message;
            let requestType = allRequests[i].request_type;

            // Find the display name for the request type
            let requestTypeObj = LLM_REQUEST_TYPES.find(type => type.value === requestType);
            let displayName = requestTypeObj ? requestTypeObj.display : requestType;     
            
            // Escape the text and wrap it in <pre> tags
            let escapedFullPrompt = $('<div/>').text(fullPrompt).html();
            let escapedAssistantMessage = $('<div/>').text(assistantMessage).html();
            let preFormattedFullPrompt = `${escapedFullPrompt}`;
            let preFormattedAssistantMessage = `${escapedAssistantMessage}`;

            $('#debug_prompts_container').append(`
                <div id="pdebug_${i}" class="prompt_debug">
                    <div class="prompt-debug-header">
                        <div>${displayName}</div>
                        <div>
                            <a class="toggle-prompt active" data-target="full_prompt_${i}"><i class="ti ti-message"></i></a>
                            <a class="toggle-prompt" data-target="assistant_message_${i}"><i class="ti ti-robot"></i></a>          
                            <a class="copydebug stubs_btn stubs_btn_outline-primary stubs_btn-sm" data-debug-id="${i}">Copy</a>
                        </div>
                    </div>
                    <textarea id="full_prompt_${i}" class="pdebug_text full_prompt_textarea" rows="3">${preFormattedFullPrompt}</textarea>
                    <textarea id="assistant_message_${i}" class="pdebug_text assistant_message_textarea" rows="3" style="display: none;">${preFormattedAssistantMessage}</textarea>
                </div>
            `);
        }        

        // Show the modal
        MicroModal.show('modal_debug_prompts', {
            debugMode: true,
            disableScroll: true,
            onShow: function (modal) { },
            onClose: function (modal) { },
            awaitCloseAnimation: true
        });
    });
    
    $('body').on('click', '#modal_debug_prompts_cancel', function () {
        MicroModal.close('modal_debug_prompts');
    });        

      // Add event listener for toggle-prompt links
    $('body').on('click', '.toggle-prompt', function() {
        const targetId = $(this).data('target');
        const $target = $(`#${targetId}`);
        const $sibling = $target.siblings('textarea');

        $target.toggle();
        $sibling.toggle();
        $(this).toggleClass('active');
        $(this).siblings('.toggle-prompt').removeClass('active');

        $target.attr('data-visible', $target.is(':visible'));
        $sibling.attr('data-visible', $sibling.is(':visible'));
    });

    $('body').on('click', '.delete-custom-api-url', function() {
        const index = $(this).data('index');
        STUBS.CUSTOM_API_URLS.splice(index, 1);

        // Update stubs_settings
        storage.get('stubs_settings', function(error, stubsSettings) {
            if (error) throw error;

            stubsSettings.custom_api_urls = STUBS.CUSTOM_API_URLS;

            storage.set('stubs_settings', stubsSettings, function(error) {
                if (error) throw error;
                console.log('Custom API URLs updated');
                refreshCustomApiUrlsTable();
                refreshLLMSelectorPanel(stubsSettings);
            });
        });
    });

    $('body').on('click', '.copydebug', function() {
        const debugId = $(this).data('debug-id');
        const $activeLink = $(`#pdebug_${debugId} .toggle-prompt.active`);
        const targetId = $activeLink.data('target');
        console.log("TARGETID: " + targetId);
        const $visibleTextarea = $(`#${targetId}`);
        
        if ($visibleTextarea.length) {
            const textToCopy = $visibleTextarea.val();

            // Create a temporary textarea element to hold the text
            const $temp = $("<textarea>");
            $("body").append($temp);
            $temp.val(textToCopy).select();

            // Copy the text
            document.execCommand("copy");

            // Remove the temporary element
            $temp.remove();
        } else {
            alert("Error: textarea could not be copied?");
        }
    });
    
    $('body').on('click', '#export_debug_prompts', function () {
        let allText = '';
        let tabUid = TABS.getCurrentUid();
        $('#debug_prompts_container .prompt_debug').each(function (index) {
            const requestType = $(this).find('.prompt-debug-header div:first').text();
            const fullPrompt = $(this).find('.full_prompt_textarea').val();
            const assistantMessage = $(this).find('.assistant_message_textarea').val();

            allText += `Request Type: ${requestType}\n`;
            allText += `Full Prompt:\n${fullPrompt}\n\n`;
            allText += `Assistant Message:\n${assistantMessage}\n\n`;
        });

        // Create a blob with the text data
        const blob = new Blob([allText], { type: 'text/plain' });
        const url = URL.createObjectURL(blob);

        // Create a temporary link element
        const a = document.createElement('a');
        a.href = url;
        a.download = `debug_prompts_${tabUid}.txt`;
        document.body.appendChild(a);
        a.click();

        // Clean up
        document.body.removeChild(a);
        URL.revokeObjectURL(url);
    });
  $('body').on('click', '#manage_embeddings', function(){
      loadManageDocumentsModal();
  });
  $('body').on('click', '#add_embeddings_context', function() {
      const { checkedProjects } = SFILE.getCheckedProjects();
      if (checkedProjects.length === 0) {
          alert("Please select a project first.");
          return;
      }
      const projectName = checkedProjects[0];
      console.log("getting documents for " + projectName);
      
      dexieDB.getDocuments(projectName).then(documents => {
          console.log(documents);
          if (documents.length > 0) {
              //highlight the icon and put embedding names in "active_embeddings" on project
            // Highlight the icon and put embedding names in "documentation_embeddings" on the current tab
            console.log(documents);
            const docNames = documents.map(d => d.name);

            console.log("toggle documents");
            TABS.toggleDocuments(docNames);              
          } else {
              loadManageDocumentsModal();
          }
      });
  });
    
    //this is for me to debug stub files
    $('body').on('click', '#menu-stubfiles', async function (event) {
      if($('#modal_stubfiles').length > 0){
        $('#modal_stubfiles').remove();
      }       

      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();  
      let currentProject = checkedProjects[0];

      let stubFiles = await dexieDB.getStubFilesFromDexie(currentProject);

      let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views','modal_stubfiles.html'), 'utf-8');
      let data = {
        project_name: currentProject,
        stub_files: stubFiles.map(file => ({
          filename: file.filename,
          file_path: file.file_path
        }))
      };
      let stubFilesModal = Mustache.render(modalHtml, data);
      $('body').append(stubFilesModal);    

      setTimeout(function(){
        MicroModal.show('modal_stubfiles',
        {
          debugMode: true, 
          disableScroll: true,
          onShow: function (modal) {  },
          onClose: function (modal) {  },
          awaitCloseAnimation: true
        });
      }, 100);
    });
    
    $('body').on('change', '.embedding-active-switch', async function() {
      const embeddingName = $(this).data('name');
      const isActive = $(this).is(':checked');
      const { checkedProjects } = SFILE.getCheckedProjects();
      const projectName = checkedProjects[0];

      await dexieDB.toggleEmbeddingActive(projectName, embeddingName, isActive);
    });    

    $('body').on('click', '.stub-file-path', async function() {
      let filePath = $(this).data('filepath');
      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();  
      let projectName = checkedProjects[0];
      
      console.log("getting stub files for " + projectName + " and " + filePath);

      let stubFile = await dexieDB.getStubFileByPath(projectName, filePath);
      console.log(stubFile);
      if (stubFile && stubFile.stub_file) {
        $('#stub-file-content').text(stubFile.stub_file);
      } else {
        $('#stub-file-content').text('No stub file content available.');
      }
    });    

    $('body').on('click', '#modal_prune_files', function () {
       //the handler is in 
       //setupTippyPrune();;       
    }); 
    $('body').on('click', '#alter_embeddings_context', function(e){
        e.stopPropagation();
        $('#embeddings_context_dropdown').toggle();
    });

    $(document).on('click', function(e){
        if(!$(e.target).closest('#alter_embeddings_context').length) {
            $('#embeddings_context_dropdown').hide();
        }
    });  

    $('body').on('click', '#add_document', async function() {
      const docName = $('#documents_name').val().trim();
      const linkUrl = $('#link_url').val().trim();
      const crawlType = $('#crawl_type').val();

      if (!docName || !linkUrl) {
        alert('Please enter both Document Name and Link URL');
        return;
      }

      const { checkedProjects } = SFILE.getCheckedProjects();
      if (checkedProjects.length === 0) {
        alert('Please select a project first.');
        return;
      }
      const projectName = checkedProjects[0];

      // Save the document with initial status
      await dexieDB.saveDocument(
        projectName,
        docName,
        linkUrl,
        linkUrl,
        null, // vectorData is null initially
        'Pending', // Initial status
        crawlType
      );

      // Refresh the documents table
      refreshDocumentsTable();

      // Clear input fields
      $('#documents_name').val('');
      $('#link_url').val('');

      // Start the scraping/crawling process (you'll need to implement this)
      console.log(`Starting ${crawlType} job for URL: ${linkUrl}`);
      
      //recrawl-btn
      
      
    });
    
    $('body').on('click', '.recrawl-btn', function(){
        const documentName = $(this).data('name');
        const { checkedProjects } = SFILE.getCheckedProjects();
        const projectName = checkedProjects[0];

        if (!STUBS.USER_TOKEN) {
            alert("You must login to use the scraper/crawler");
            return;
        }

        dexieDB.getDocumentByName(projectName, documentName)
            .then(document => {
                if (document) {
                    let retResponse = ipcRenderer.invoke('handle-scrape-crawl', documentName, document.original_url, document.crawl_type, STUBS.USER_TOKEN);
                    return retResponse;
                } else {
                    throw new Error('Document not found');
                }
            })
            .then(response => {
                console.log('Scrape/Crawl response:', response);

                if (response.success) {
                    return dexieDB.updateDocument(projectName, documentName, {
                        url: response.url || document.url,
                        document_name: response.document_name || document.document_name,
                        vector_data: response.vector_data,
                        status: 'Completed',
                        update_date: new Date(),
                        markdown: response.markdown
                    });
                } else {
                    console.error('Error in scrape/crawl:', response.error);
                    return dexieDB.updateDocument(projectName, documentName, {
                        status: 'Failed',
                        update_date: new Date()
                    });
                }
            })
            .then(() => {
                refreshDocumentsTable();
            })
            .catch(error => {
                console.error('Error in recrawl process:', error);
            });
    });

    $('body').on('click', '#modal_manage_documents_submit', function() {
        const { checkedProjects } = SFILE.getCheckedProjects();
        if (checkedProjects.length === 0) {
            alert("Please select a project first.");
            return;
        }
        const projectName = checkedProjects[0];

        dexieDB.getDocuments(projectName).then(documents => {
            if (documents.length > 0) {
                const docNames = documents.map(d => d.name);
                TABS.toggleDocuments(docNames);
            }
            MicroModal.close('modal_manage_documents');
        });
    });
    
    
    
    
});
  


function refreshCustomApiUrlsTable() {
    const tableBody = $('#custom-api-urls-table tbody');
    tableBody.empty();

    if (STUBS.CUSTOM_API_URLS && STUBS.CUSTOM_API_URLS.length > 0) {
        $('.custom-api-urls-section').css('display', 'block');    
        $('#custom-api-urls-empty').css('display', 'none');    
        STUBS.CUSTOM_API_URLS.forEach((url, index) => {
            const [apiUrl, modelName, apiKey] = url.split('|');
            const row = `
                <tr>
                    <td>${apiUrl}</td>
                    <td>${modelName || 'N/A'}</td>
                    <td><button class="delete-custom-api-url" data-index="${index}"><i class="ti ti-x"></button></td>
                </tr>
            `;
            tableBody.append(row);
        });
    }else{
        $('.custom-api-urls-section').css('display', 'none');
        $('#custom-api-urls-empty').css('display', 'block'); 
    }
}

function setupTippyCustomEndpoint() {
    const customEndpointButton = document.getElementById('custom_openai_endpoint_button');
    if(customEndpointButton){
        // Open a small popup
        tippy(customEndpointButton, {
            content: `
                <div style="width: 450px;padding: .5rem;">
                    <div class="stubs_apiform_container">
                        <label for="openai_key">URL: </label>
                        <input class="stubs_form_input" id="custom_openai_endpoint_url" type="text" placeholder="e.g. http://localhost:1234/v1/">
                    </div>
                    <div class="stubs_apiform_container">
                        <label for="openai_key">Model Name: </label>
                        <input class="stubs_form_input" id="custom_openai_model_name" type="text" placeholder="">
                    </div>
                    <div class="stubs_apiform_container">
                        <label for="openai_key">API Key: <span style="font-weight: 400; font-size: 12px;"><i>(if no key needed put 'none')</i></span> </label>
                        <input class="stubs_form_input" id="custom_openai_api_key" type="password" placeholder="">
                    </div>
                    <br>
                    <div class="tippy_prune_button_container">
                     <label class="custom-api-chk-container">
                        <input type="checkbox" id="use_for_all_steps">
                        <span class="custom-api-chk"></span>
                        <div style="margin: 0 28px;"> Use for all steps </div>
                    </label>
                        <button id="add_custom_openai_endpoint" class="stubs_btn stubs_btn-primary stubs_btn-sm"><i class="ti ti-device-floppy"></i> Add Endpoint</button>
                    </div>
                </div>            
            `,
            interactive: true,
            trigger: 'click',
            allowHTML: true,
            placement: 'bottom',
            onShow(instance) {
                setTimeout(function(){
                    const addButton = document.getElementById('add_custom_openai_endpoint');
                    $('#add_custom_openai_endpoint').off('click');
                    $('#add_custom_openai_endpoint').on('click', function(){
                        const urlInput = document.getElementById('custom_openai_endpoint_url');
                        const modelNameInput = document.getElementById('custom_openai_model_name');
                        const apiKeyInput = document.getElementById('custom_openai_api_key');
                        
                        const urlValue = urlInput.value.trim();
                        const modelName = modelNameInput.value.trim();
                        const apiKey = apiKeyInput.value.trim();
                        
                        if(urlValue == ''){
                            alert("Please enter a URL");
                            return;
                        }
                        
                        const customEndpoint = `${urlValue}|${modelName}|${apiKey}`;
                        console.log("Adding custom endpoint: " + customEndpoint);

                        // Add the custom API URL to stubs_settings
                        storage.get('stubs_settings', function(error, stubsSettings) {
                            if (error) throw error;

                            if (!stubsSettings.custom_api_urls) {
                                stubsSettings.custom_api_urls = [];
                            }
                            stubsSettings.custom_api_urls.push(customEndpoint);
                                                        
                            const useForAllSteps = $('#use_for_all_steps').is(':checked');

                            if (useForAllSteps) {
                                STUBS.userOverrideLLMs = {
                                    'request_relevant_files': customEndpoint,
                                    'request_relevant_line_numbers': customEndpoint,
                                    'request_relevant_stub_lines': customEndpoint,
                                    'do_new_programming_task': customEndpoint,
                                    'do_additional_programming_task': customEndpoint,
                                    'formalize_code_changes': customEndpoint,
                                    'request_file_descriptions': customEndpoint,
                                    'prune_unlikely_project_files': customEndpoint,
                                    'single_file_full_change': customEndpoint
                                };
                            }                             
                            refreshLLMSelectorPanel(stubsSettings);

                            storage.set('stubs_settings', stubsSettings, function(error) {
                                if (error) throw error;                               
                                if(typeof(stubsSettings.custom_api_urls) !== 'undefined'){
                                    STUBS.CUSTOM_API_URLS = stubsSettings.custom_api_urls;           
                                }     
                                refreshCustomApiUrlsTable();
                                console.log('Custom OpenAI endpoint URLs updated to');
                                console.log(STUBS.CUSTOM_API_URLS);
                                refreshLLMSelectorPanel(stubsSettings);
                            });
                        });

                        // Clear the input fields
                        urlInput.value = '';
                        modelNameInput.value = '';
                        apiKeyInput.value = '';

                        instance.hide();
                    });
                }, 100);
            }
        });
    }
};

function setupTippyPrune() {
  const pruneButton = document.getElementById('modal_prune_files');
  if (pruneButton) {
    tippy(pruneButton, {
      content: `
        <div>
          <p>Less files to sift through for context mean better results, so it's recommended you have less than 100 files.</p>
          <label>Current File Amount: <span id="prune_current_amount_value"></span> Files</label>
          <label for="prune_file_amount">Desired File Amount: <span id="prune_file_amount_value"></span> Files</label>
          <input type="range" id="prune_file_amount" min="10" max="20" value="20">
          <br>
          <label for="prune_info">Any specific things to keep: (optional)</label><br>
          <textarea id="prune_info" rows="4"></textarea>
          <br>
            <div class="tippy_prune_button_container">
                <button class="stubs_btn stubs_btn_outline-primary float-right" id="prune_button">Prune</button>
            </div>
        </div>
      `,
      interactive: true,
      trigger: 'click',
      allowHTML: true,
      placement: 'bottom',
      onShow(instance) {
        setTimeout(function(){
            const totalFiles = SFILE.STUB_COUNT;
            let maxFiles = 20;
            if (totalFiles > 300) maxFiles = 200;
            else if (totalFiles > 200) maxFiles = 150;
            else if (totalFiles > 150) maxFiles = 100;
            else if (totalFiles > 100) maxFiles = 70;
            else if (totalFiles > 70) maxFiles = 50;        

            if($('#prune_file_amount').length > 0 && $('#prune_file_amount_value').length > 0){

                $('#prune_file_amount').attr('max', maxFiles);
                $('#prune_file_amount').val(maxFiles);
                $('#prune_file_amount_value').text(maxFiles);
                $('#prune_current_amount_value').text(totalFiles);

                $('#prune_file_amount').on('input', function(){
                    $('#prune_file_amount_value').text(this.value);
                });
            }else{
                //alert("no prune_file_amount");
            }

            if($('#prune_button').length > 0){
                $('#prune_button').on('click', async function(){
                    const fileAmount = $('#prune_file_amount').val();
                    const pruneExtraText = $('prune_info').val();

                    console.log("TRYING TO PRUNE TO " + fileAmount + " FROM ORIGINAL " + SFILE.STUB_COUNT);
                    // Perform the pruning logic here using fileAmount and pruneInfo

                    let selectedProjects = [PINFO.ProjectSlug];
                    let selectedProjectPaths = [PINFO.ProjectPath];
                   /*
                      PINFO.ProjectName = project.name;
                      PINFO.ProjectPath = project.folder;
                      PINFO.ProjectDesc = project.description;
                      PINFO.ProjectRules = project.document_files;
                      PINFO.ProjectSlug = PINFO.ProjectName.replace(/[^a-zA-Z0-9]/g, '-').replace(/--+/g, '-').toLowerCase();
                      loadProjectStubIgnore(project.folder);                                
                    */
                   
                    //THERE IS NO PROJECT STUB DATA FOR NEW PROJECTS
                    //let projectFileData = await SFILE.getAvailableFilesForGPT(selectedProjects, STUBS.stubsData);    
                    //let theFilesText = projectFileData['files_text'];
                    //let theFilesTextLinux = projectFileData['files_text_linux'];
                    //let justFilesLinux = projectFileData['files_linux'];
                    //let justProjectNames = projectFileData['just_project_names'];              

                    //filesListText, totalAmount, excludeAmount, tabUid

                      try {
                          //filesListText, totalAmount, excludeAmount, tabUid
                        let totalAmount = SFILE.STUB_CURRENT_FILES;
                        //let totalAmount = SFILE.STUB_COUNT;
                        let excludeAmount = SFILE.STUB_COUNT - fileAmount;
                        let tabUid = TABS.getCurrentUid();
                        let tabIndex = TABS.getIndexByUid(tabUid);
                        let existingIgnore = $('#default-stub-ignore').val();
                        console.log("SENDING TAB: " + tabUid);
                        console.log("Tab index " + tabIndex);
                        console.log("SENDING THE FILE ARRAY ");
                        console.log(SFILE.STUB_CURRENT_FILES);
                        
                        if(totalAmount <= 5 || SFILE.STUB_CURRENT_FILES < 5){
                            alert("Not enough files?  Or error loading files?");
                            return;
                        }
                        
                        // Block the modal
                        $.blockUI({ message: 'Please Wait<br>Requesting Rules for .stubignore', baseZ: 29999011,
                            css: { 
                                border: 'none', 
                                padding: '15px', 
                                backgroundColor: '#6f24f1', 
                                '-webkit-border-radius': '10px', 
                                '-moz-border-radius': '10px', 
                                opacity: .5, 
                                'font-size': '28px',
                                color: '#fff' 
                            },
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.2, 
                                cursor:          'wait' 
                            }, 
                        });                         
                        
                        //ignoreFile, filesListText, totalAmount, targetAmount, excludeAmount, pruneInfo, tabUid
                        let pruneResponse = await CHATGPT.pruneUnlikelyProjectFiles(existingIgnore, SFILE.STUB_CURRENT_FILES, totalAmount, fileAmount, excludeAmount, pruneExtraText, tabUid);
                        let assistantRules = pruneResponse['response'];
                        console.log("GOT BACK ARRAY OF NEW RULES");
                        

                        let newRules = assistantRules;
                        console.log(newRules);
                        
                        let allRules = newRules.join('\n');

                        // Update the .stubignore textarea with the new rules
                        let existingStubIgnore = $('#default-stub-ignore').val();
                        let newStubIgnore = existingStubIgnore + '\n' + allRules;
                        $('#default-stub-ignore').val(newStubIgnore);
                        $.unblockUI(); 
                        
                      } catch (error) {
                        console.error('Error pruning files:', error);
                        $.unblockUI(); 
                      }
                      
                      updateProjectTree();

                      // Update the current file amount display
                      $('#prune_current_amount_value').text(SFILE.STUB_COUNT);

                      // Remove the prune button
                      $('#modal_prune_files').css('display', 'none');              

                      instance.hide();
                  });          
            }else{
                //alert("no prune button");
            }
        }, 100);
        
      }
    });
  }
}

function updateProjectData(projectSlug, updateData) {
    return new Promise((resolve, reject) => {
        storage.get('all_projects', function(error, data) {
            if (error) {
                reject(error);
                return;
            }

            let all_projects = data.all_projects || [];
            let projectIndex = all_projects.findIndex(project => project.project_slug === projectSlug);

            if (projectIndex !== -1) {
                Object.assign(all_projects[projectIndex], updateData);
                storage.set('all_projects', { all_projects }, function(error) {
                    if (error) {
                        reject(error);
                    } else {
                        resolve();
                    }
                });
            } else {
                console.log("project not found " + projectSlug);
                resolve();
            }
        });
    });
}

function loadDefaultStubIgnore() {
    let stubIgnorePath = path.join(STUBS.appPath, '.defaultstubignore');
    if (fs.existsSync(stubIgnorePath)) {
        fs.readFile(stubIgnorePath, 'utf-8', (err, data) => {
            if (err) {
                console.error(err);
                return;
            }
            document.getElementById('default-stub-ignore').value = data;
        });
    }else{
           let dumbDefault = `*.ini
*.yml
*.txt
*.zip
.env
.env.*
*.min.js
*.min.css
.git
.git/
package-lock.json
node_modules
node_modules/`;
        document.getElementById('default-stub-ignore').value = dumbDefault;
    }
}

function loadProjectStubIgnore(folderPath) {
  const stubIgnorePath = path.join(folderPath, '.stubignore');
  if (fs.existsSync(stubIgnorePath)) {
    const stubIgnoreContent = fs.readFileSync(stubIgnorePath, 'utf-8');
    $('#default-stub-ignore').val(stubIgnoreContent);
  } else {
    loadDefaultStubIgnore();
  }
}

function refreshExistingConnectionsList() {
    ipcRenderer.invoke('get-connections').then(connections => {
        let existingDatabasesList = $('#existing_connections_list');
        existingDatabasesList.empty();

        if (Object.keys(connections).length > 0) {
            $('#existing_connections_container').show();
            for (const connectionName in connections) {
                existingDatabasesList.append(`
                    <div class="connection-item">
                        <span class="connection-name">${connectionName}</span>
                        <button class="remove-connection" data-connection="${connectionName}">Delete</button>
                    </div>
                `);
            }
        } else {
            $('#existing_connections_container').hide();
        }
    });
}

function loadManageDocumentsModal() {
    if ($('#modal_manage_documents').length > 0) {
        $('#modal_manage_documents').remove();
    }

    const { checkedProjects } = SFILE.getCheckedProjects();
    if (checkedProjects.length === 0) {
        alert("Please select a project first.");
        return;
    }

    const projectName = checkedProjects[0];

    let modalHtml = fs.readFileSync(path.join(STUBS.appPath, 'views', 'modal_manage_documents.html'), 'utf-8');
    let manageEmbeddingsModal = Mustache.render(modalHtml);
    $('body').append(manageEmbeddingsModal);

    setTimeout(function() {
        MicroModal.show('modal_manage_documents', {
            debugMode: true,
            disableScroll: true,
            onShow: function(modal) { 
                refreshDocumentsTable();
            },
            onClose: function(modal) { },
            awaitCloseAnimation: true
        });
    }, 100);
}

function refreshDocumentsTable() {
  const { checkedProjects } = SFILE.getCheckedProjects();
  const projectName = checkedProjects[0];

  dexieDB.getDocuments(projectName).then(documents => {
    const tableBody = $('#documents_table_body');
    tableBody.empty();

    if (documents.length > 0) {      
      $('#existing_documents_container').css('display', 'block');
      $('#existing_documents_empty').css('display', 'none');

      documents.forEach(document => {
        const row = `
          <tr>
            <td class="doc_name">${document.document_name}</td>
            <td class="original_url">${document.original_url}</td>
            <td>${document.crawl_type}</td>
            <td>${document.status}
              <br>
              <button data-name="${document.document_name}" class='recrawl-btn stubs_btn stubs_btn-sm'>Recrawl</button>
            </td>
            <td>
              <div class="switch-container">
                <input type="checkbox" class="document-switch" id="switch-${document.id}" data-name="${document.document_name}" ${document.active ? 'checked' : ''}>
                <label for="switch-${document.id}"></label>
              </div>
            </td>
            <td>
              <button class="delete-document-btn stubs_btn stubs_btn-danger stubs_btn-sm" data-name="${document.document_name}">
                <i class="ti ti-trash"></i>
              </button>
            </td>
          </tr>
        `;
        tableBody.append(row);
      });

      // Initialize switches
      $('.document-switch').each(function() {
        new DG.OnOffSwitch({
          el: this,
          height: 20,
          trackColorOn: '#ededed',
          trackColorOff: '#ededed',
          trackBorderColor: '#ededed',
          textColorOff: '#CCC',
          textColorOn: '#411256',
          listener: function(name, checked) {
            const documentName = $(this.el).data('name');
            dexieDB.setEmbeddingActive(projectName, documentName, checked);
          }
        });
      });

      // Add event listener for delete buttons
      $('.delete-document-btn').on('click', function() {
        const documentName = $(this).data('name');
        if (confirm(`Are you sure you want to delete the document "${documentName}"?`)) {
          dexieDB.deleteDocument(projectName, documentName).then(() => {
            refreshDocumentsTable();
          });
        }
      });
    } else {
      $('#existing_documents_container').css('display', 'none');
      $('#existing_documents_empty').css('display', 'block');
    }
  });
}

function updateProjectTree() {
  const projectTreeContainer = document.getElementById('project-tree-container');
  projectTreeContainer.innerHTML = ''; // Clear existing tree
  createProjectRoots(projectTreeContainer, PINFO.ProjectName, PINFO.ProjectPath);
  setTimeout(function(){
    $('#project-tree-count').html("Total Stub Files: " + SFILE.STUB_COUNT);    
    console.log("THE FILE ARRAY");
    console.log(SFILE.STUB_CURRENT_FILES);
  }, 500);
}


