const fs = require('fs-extra');
const path = require('path');
const Parser = require('web-tree-sitter');
const ini = require('ini');
var STUBS = STUBS || {};
const CHATGPT = require('./js/chatgpt.js');
const DIFFR = require('./js/codemirror_diff.js');
const SFILE = require('./js/directories.js');
const TABS = require('./js/tabmanager.js');

// Load the config file
const configPath = path.join(__dirname, '.config.ini');
const config = ini.parse(fs.readFileSync(configPath, 'utf-8'));
const apiKeys = config.apikeys;


let savelocation = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\stubfile.txt";

let testProject = "stubs";
let testProjectArr = [testProject];
let testProjectPath = "C:\\wamp\\www\\\stubs\\stubs-ai-assistant";
let testProjectPathArr = [testProjectPath];
let testDesc = "";

STUBS.stubsDataPath = path.join(__dirname, 'stub_data.json');
if (fs.existsSync(STUBS.stubsDataPath)) {
    console.log("file exists");
    STUBS.stubsData = JSON.parse(fs.readFileSync(STUBS.stubsDataPath)); 
    
}else{
    console.log("file does not exist");
}

let tabUid = "testuid";
let testTask = `Add a delete tab feature.`;

let tabObject = {
    task_text: testTask,
    task_type: "task",
    task_sent: false, 
    llm_provider: CHATGPT.LLM_PROVIDER,
    llm_responses : new Array(),                
    checked_projects: ['stubs'],
    code_blocks: new Array(),
    uid: tabUid,
    has_ui: false
};
TABS.TAB_ARR.push(tabObject);

CHATGPT.setTabs(TABS);
//TABS.ADD_NEW_TAB();
/*
SFILE.getAvailableFilesForGPT(testProjectArr, STUBS.stubsData)
    .then(theData => {
        console.log(theData);
        let theFilesText = theData['files_text'];
        
        console.log("files text:" );
        console.log(theFilesText);
        
        console.log("apikeys");
        console.log(apiKeys);
        CHATGPT.init(apiKeys);
        CHATGPT.requestRelevantFiles(testTask, theFilesText)
          .then(moreData => {
              console.log("file response: ");
              console.log(moreData);                
          }).catch(error => {
              console.error("An error occurred:", error);
          });
    })
    .catch(error => {
        console.error("An error occurred:", error);
    });
*/

let projectName = testProject;
const stubbleDir = './stubble';
const projectStubblePath = path.join(stubbleDir, projectName);


var tooManyLines = function(theType, inputString, maxLines) {
    const lines = inputString.split('\n');
    if (lines.length > maxLines) {
        
        console.log("TOO MANY LINES============================" + theType);
        console.log("TOO MANY LINES============================" + theType);
        console.log("TOO MANY LINES============================" + theType);
        console.log("TOO MANY LINES============================" + theType);     
        
        //reduce the lines???
    }

    // Convert the array back into a string
    return lines.join('\n');
};

async function testRelevantLines(projectArr){
    let allFilesResult = await SFILE.getAvailableFilesForGPT(projectArr, STUBS.stubsData);
    let filesList = allFilesResult['files_text'];
    //console.log("filesList");
    //console.log(filesList);
    
    let finalFiles = [
        'js\\options\\dexie_loader.js',
        'js\\options\\options_page.js'
      ];    
    
    let finalStubblePaths = finalFiles.map(shortPath => 
        path.normalize(path.join(".", "stubble", projectName, shortPath))
    );
    let finalShortPaths = finalFiles.map(shortPath => 
        path.normalize(path.join(".", shortPath))
    );    
    let finalOriginalPaths = finalFiles.map(shortPath => path.join(".", testProjectPath, shortPath));
    //console.log("final stubble paths");
    //console.log(finalStubblePaths);
    let stubFilesResult = await SFILE.getStubFilesCombined(finalStubblePaths, finalShortPaths);
    //console.log("combined");
    //console.log(stubFilesResult);
    
    tooManyLines("file list", filesList, 500);
    tooManyLines("stub files", stubFilesResult, 1500);    
    CHATGPT.init(apiKeys);
    CHATGPT.requestRelevantLineNumbers(testTask, filesList, stubFilesResult, tabUid)
      .then(moreData => {
          console.log("requestRelevantLineNumbers response: ");
          console.log(moreData);                
      }).catch(error => {
          console.error("An error occurred:", error);
      });
    
}

//testRelevantLines(testProjectArr);
/*
let fileTestJson = "./logs/request_relevant_files_2023-11-07_30-03.txt";
let fileData = fs.readFileSync(fileTestJson, 'utf-8');  
CHATGPT.init(apiKeys);
let lineNumberArr = CHATGPT.parseLineNumberJson(fileData);
if(lineNumberArr.length <= 0){
    console.log("Invalid JSON line number response: " + fileData);            
}else{
    let finalContextLines = CHATGPT.parseLineNumbers(lineNumberArr, projectName, STUBS.stubsData)
      .then(finalContextData => {
          console.log("parseLineNumbers response: ");
          console.log(finalContextData['all_relevant_text']);  
          console.log("line count: " + finalContextData['line_count']);
          console.log("char count: " + finalContextData['char_count']);
          
      }).catch(error => {
          console.error("parseLineNumbers error occurred:", error);
      });;
    //console.log("Final Context Lines");
    //console.log(finalContextLines);
}
*/

var testFullWorkflow = async function(myProjectArr, myProjectPathArr, myTask, shouldClear){
    console.log("testing full workflow");
    var gotosleep = function(ms) {
        return new Promise(resolve => {
            setTimeout(() => {
                if(shouldClear){
                    console.clear();
                }
                resolve();
            }, ms);
        });
    };
    //INIT HERE BECAUSE WE DONT HAVE apiKeys VARIABLE IN COMMAND LINE VERSIOn
    CHATGPT.LLM_PROVIDER = "anthropic";
    CHATGPT.initAnthropic(apiKeys);
    
    //CHATGPT.LLM_PROVIDER = "chatgpt";
    //CHATGPT.init(apiKeys);
    
    
    let projectFileData = await SFILE.getAvailableFilesForGPT(myProjectArr, STUBS.stubsData);
    let theFilesText = projectFileData['files_text'];
    console.log("=====================");
    console.log("STEP 1");
    console.log("files text:" );
    console.log(theFilesText);
    await gotosleep(2000); 
    
    let relevantFilesData = await CHATGPT.requestRelevantFiles(myTask, theFilesText, tabUid);
    console.log("Got back relevant files data");
    console.log(relevantFilesData);
    await gotosleep(5000);
    let stubFilesArr = relevantFilesData['response'];
    
    console.log("=====================");
    console.log("STEP 2");
    console.log("final stub file list");
    console.log(stubFilesArr);
    await gotosleep(2000);       
    
    if(stubFilesArr.length <= 0){
        console.log("bad stub files");
        return;
    }
    if(stubFilesArr.length > 3){
        stubFilesArr = stubFilesArr.slice(0, 3);
    }
    
    
    //stub file list needs to have which project it's from
    //ugh
    let CHANGE_MY_PROJECT_NAME = myProjectArr[0];
    let CHANGE_MY_PROJECT_PATH = myProjectPathArr[0];
    
    let finalStubblePaths = stubFilesArr.map(shortPath => 
        path.normalize(path.join(".", "stubble", CHANGE_MY_PROJECT_NAME, shortPath))
    );
    let finalShortPaths = stubFilesArr.map(shortPath => 
        path.normalize(path.join(".", shortPath))
    );    
    let finalOriginalPaths = stubFilesArr.map(shortPath => path.join(".", CHANGE_MY_PROJECT_PATH, shortPath));    
    let stubFilesResult = await SFILE.getStubFilesCombined(finalStubblePaths, finalShortPaths);    
    console.log("sending stub files result");
    console.log(stubFilesResult);    
    if(stubFilesResult.length <= 0){
        console.log("bad stub files result");
        return;
    }
    
    await gotosleep(3000);   
    
    tooManyLines("file list", theFilesText, 500);
    tooManyLines("stub files", stubFilesResult, 1500);    
    CHATGPT.init(apiKeys);
    let stublineNumberResponse = await CHATGPT.requestRelevantStubLines(myTask, theFilesText, stubFilesResult, tabUid);
    let stublineNumberArr = stublineNumberResponse['response'];
    
    
    let lineNumberArr = stublineNumberArr;    
    
    console.log("lineNumberArr");
    console.log(lineNumberArr);
    await gotosleep(3000);
    
    
    let fileRefText = await CHATGPT.parseLineNumbers(lineNumberArr, CHANGE_MY_PROJECT_NAME, STUBS.stubsData);
    console.log("Final context data");    
    console.log(fileRefText);
    await gotosleep(2000);
  
    
    let allRelevantText = fileRefText['all_relevant_text'];
    console.log("sending this and waiting 15 sec: " );
    console.log(allRelevantText);
    await gotosleep(20000);
    console.log("doing programming task now");
    let completeTaskResponse = await CHATGPT.doNewProgrammingTask(myTask, allRelevantText, false, CHANGE_MY_PROJECT_NAME, "");
    console.log("assistant message");
    console.log(completeTaskResponse['response']);    
    
};
testFullWorkflow(testProjectArr, testProjectPathArr, testTask);

var testFormalizeChanges = async function(){
    
    var gotosleep = function(ms) {
        return new Promise(resolve => {
            setTimeout(() => {
                console.clear();
                resolve();
            }, ms);
        });
    };
    let theTask = `I want to make it so the menu bar with File Settings Help highlight when you hover over it.  
    Then clicking File shows acthe menu with Add New Project, instead of it being shown by hovering.`;
    let logFolder = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\logs\\";
    let logFile = 'do_new_programming_task_2023-11-25_07-34-27.txt';
    let logPath = logFolder + logFile;
    let bossInstructionData = fs.readFileSync(logPath, 'utf-8'); 
    let relevantCodeFiles = `<<<<< css\styles.css <<<<<<
//198 lines hidden
}
.chatgpt-request-banner{
    width: 100%;
    display: flex;
    justify-content: space-between;
}

  .chatgpt-response-container {

    display: flex;
    position:relative;
    /* flex-flow: column; */
    flex-direction: column;
    height: 100%;
    padding: 15px;
  }


  #chatgpt-response {
    /* flex:1 1 auto; */
    flex-grow:1;
    align-self:auto;
  }



.file-checkbox {
  position: relative;
}

.checkbox-overlay {
  position: absolute;
  top: 0;
  left: 0;
  width: 300px;
  height: 1.2em;
  cursor: pointer;
}

.tree-item-container {
  position: relative;
}

.tree-item-container > input[type=checkbox] {
  margin-right: 5px;
}

.textarea{
    font-family: 'Work Sans', Arial, Verdana;
}

.directory > ul {
  padding-left: 20px;
  list-style-type: none;
}
.tree-item{
    cursor: pointer;
}

.folder-icon::before {
  content: '\f749';
  font-family: 'tabler-icons';
  margin-left: -15px;
  margin-right: 5px;
}

.file-icon::before {
  content: '\eaa4';
  font-family: 'tabler-icons';
  margin-left: -15px;
  margin-right: 5px;
}

.filealert-icon::before {
  content: '\ede6';
  font-family: 'tabler-icons';
  margin-left: -15px;
  margin-right: 5px;
}



.project-icon::before {
  content: '\f57e';
  font-family: 'tabler-icons';
  margin-left: -15px;
  margin-right: 5px;
}

.expanded > ul {
  display: block;
}

ul.collapsed {
  display: none !important;
}


#file-menu {
    background-color: #EDF0FA;
    display: flex;
    align-items: center;
    padding: 5px 10px;
}

#file-menu ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  display: flex;
}

#file-menu li {
  margin-right: 20px;
}

.file-menu-item {
  position: relative;
  cursor: pointer;
  display: flex;
  align-items: center;
}

.file-dropdown {
  display: none;
  position: absolute;
  left: 0;
  top: 100%;
  background-color: #fff;
  border: 1px solid #ccc;
  padding: 5px 0;
  z-index: 10;
}

.file-dropdown a {
  display: block;
  padding: 5px 10px;
  text-decoration: none;
  color: #333;
  font-size: 14px;
  width: 200px;
}

.file-dropdown a:hover {
  background-color: #ccc;
}

.file-menu-item:hover .file-dropdown {
  display: block;
}

.project-name {
    font-weight: bold;
    margin-top: 10px;
}

.progress-bar {
    height: 20px;
    background-color: #3498db;
    transition: width 0.3s;
    border: 1px solid #ddd;
    border-radius: 5px;
}
/****************** CSS Loader **************************/



.loader_container {
  margin-top:250px;
  align-items: center;
  display: flex;
  justify-content: center;
}

.loader  {
  animation: rotate 1s infinite;
  height: 50px;
  width: 50px;
}

.loader:before,
.loader:after {
  border-radius: 50%;
  content: '';
  display: block;
  height: 20px;
  width: 20px;
}
.loader:before {
  animation: ball1 1s infinite;
  background-color: #cb2025;
  box-shadow: 30px 0 0 #f8b334;
  margin-bottom: 10px;
}
.loader:after {
  animation: ball2 1s infinite;
  background-color: #00a096;
  box-shadow: 30px 0 0 #97bf0d;
}

@keyframes rotate {
  0% {
    -webkit-transform: rotate(0deg) scale(0.8);
    -moz-transform: rotate(0deg) scale(0.8);
  }
  50% {
    -webkit-transform: rotate(360deg) scale(1.2);
    -moz-transform: rotate(360deg) scale(1.2);
  }
  100% {
    -webkit-transform: rotate(720deg) scale(0.8);
    -moz-transform: rotate(720deg) scale(0.8);
  }
}

@keyframes ball1 {
  0% {
    box-shadow: 30px 0 0 #f8b334;
  }
  50% {
    box-shadow: 0 0 0 #f8b334;
    margin-bottom: 0;
    -webkit-transform: translate(15px,15px);
    -moz-transform: translate(15px, 15px);
  }
  100% {
    box-shadow: 30px 0 0 #f8b334;
    margin-bottom: 10px;
  }
}

@keyframes ball2 {
  0% {
    box-shadow: 30px 0 0 #97bf0d;
  }
  50% {
    box-shadow: 0 0 0 #97bf0d;
    margin-top: -20px;
    -webkit-transform: translate(15px,15px);
    -moz-transform: translate(15px, 15px);
  }
  100% {
    box-shadow: 30px 0 0 #97bf0d;
    margin-top: 0;
  }
}

<<<<< ui_handlers.js <<<<<<
let fileBeingRead = "bytreesitter";
let testingStuff = "deletethis";
var STUI = STUI || {};

$(document).ready(function () {

  $('body').on('click', '.tree-item.directory', function (event) {
    event.stopPropagation();

    const listItem = $(this);
    const projectName = listItem.data('projectName');
    const fullPath = listItem.data('fullPath');

    listItem.toggleClass('expanded');

    if (listItem.hasClass('expanded')) {
      createDirectoryTree(projectName, listItem[0], fullPath);
    } else {
      listItem.children('ul').remove();
    }
  });

  $('#send_button').on('click', function(){
      let chatArea = document.getElementById('chatgpt-request');
      let myTask = chatArea.value;
      // Add your custom logic to handle the submitted text content
      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();

      console.log("Projects, paths, task");
      console.log(checkedProjects);
      console.log(checkedProjectPaths);
      console.log(myTask);
      fullNewTask(checkedProjects, checkedProjectPaths, myTask);
  });

  $('body').on('click', '.tree-item .checkbox-overlay', function (event) {
    console.log("CHECKBOX CLICK");
    event.stopPropagation();

    const listItem = $(this).parent();
    const checkbox = listItem.find('input[type="checkbox"]');
    const projectName = listItem.data('projectName');
    const fullPath = listItem.data('fullPath');

    console.log("projectName " + projectName);
    console.log("fullPath " + fullPath);

    const fileData = getFileData(projectName, fullPath);

    if (fileData.selection_state === 0) {
      fileData.selection_state = 1;
      checkbox.prop('indeterminate', true);
      checkbox.prop('checked', false);
    } else if (fileData.selection_state === 1) {
      fileData.selection_state = 2;
      checkbox.prop('indeterminate', false);
      checkbox.prop('checked', true);
    } else {
      fileData.selection_state = 0;
      checkbox.prop('indeterminate', false);
      checkbox.prop('checked', false);
    }

    saveFileData();
    CHATGPT.estimateFileTokens($('#chatgpt-request').val());
  });

  $('body').on('click', '#test_write_files', function (event) {
      console.log("testing write files");
      copyCheckedFilesToStubble();
  });

  $('body').on('click', '#test_button', function(){
      alert("testing Chatgpt");
      CHATGPT.testChatGPT();
  });

  $('body').on('click', '#add_project', function (event) {
      CHATGPT.prepareFileText();
  });

  $('body').on('click', '#add_response,#respond_button', function(){
       let userResponse = $('#user_response').val();
       CHATGPT.updateProgrammingTask(userResponse);
  });

  const $textarea = $('#chatgpt-request');

  const calculateNewHeight = ($element) => {
    const originalHeight = $element.height();
    $element.height('auto');
    const newHeight = $element[0].scrollHeight;
    $element.height(originalHeight);
    return newHeight;
  };

  const adjustTextareaHeight = () => {
    const newHeight = calculateNewHeight($textarea);
    $textarea.height(newHeight);
  };

  $textarea.on('input', adjustTextareaHeight);

    $('#chatgpt-request').on('keydown', (e) => {
        if (e.key === 'Enter') {
          if (e.shiftKey) {
            // Insert a newline character if Shift is held down
            //e.target.value += '';
          } else {
            e.preventDefault();
            $('#send_button').trigger('click');
          }
        }
    });

    $('body').on('click', '#gpt_version', function(){
        if(CHATGPT.model_version == "gpt-4"){
            CHATGPT.model_version = "gpt-3.5-turbo";
            $(this).html("GPT 3.5 TURBO");
        }
        else if(CHATGPT.model_version == 'gpt-3.5-turbo'){
//183 lines hidden

<<<<< index.html <<<<<<
<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <title>Stubs AI Commander</title>
    <link rel="stylesheet" href="css/bulma.css" />
    <link rel="stylesheet" href="css/styles.css" />
    <link rel="stylesheet" href="css/textarea.css" />
    <link rel="stylesheet" href="css/diff-panel.css" />
    <link rel="stylesheet" href="css/fonts.css" />
    <link rel="stylesheet" href="css/tabler-icons.min.css" />
    <link rel="stylesheet" href="jslib/highlight.min.css" />
    <link rel="stylesheet" href="jslib/highlight.monokai-sublime.css" />
    <link rel="stylesheet" href="jslib/tribute.css">
    <!------ codemirror ------->
    <link rel="stylesheet" href="jslib/codemirror.min.css">
    <link rel="stylesheet" href="jslib/addon/hint/show-hint.css">
    <link rel="stylesheet" href="jslib/addon/merge/merge.css">
    <link rel="stylesheet" href="jslib/theme/monokai.css">
    <link rel="stylesheet" href="jslib/theme/duotone-light.css">
    <link rel="stylesheet" href="jslib/theme/duotone-dark.css">
  </head>
  <body>
    <div id="title-bar">
      <div id="title">Stubs AI Commander</div>
      <div id="title-bar-btns">
        <button id="min-btn">-</button>
        <button id="max-btn">+</button>
        <button id="close-btn">x</button>
      </div>
    </div>
    <div id="file-menu">
      <ul>
        <li>
          <div class="file-menu-item">
            File
            <div class="file-dropdown">
              <a href="#" id="menu-add-project">Add New Project</a>
            </div>
          </div>
        </li>
        <li>
          <div class="file-menu-item">Settings</div>
            <div class="file-dropdown">
              <a href="#" id="menu-editor">Editor</a>
              <a href="#" id="menu-stubs">Stubs</a>
              <a href="#" id="menu-devtools">Toggle Devtools</a>

            </div>
        </li>
        <li>
          <div class="file-menu-item">Help</div>
            <div class="file-dropdown">
              <a href="#" id="menu-about">About</a>
              <a href="#" id="menu-tutorial">Tutorial</a>
            </div>
        </li>
      </ul>
    </div>
    <div id="context-menu" class="context-menu">
      <ul>
        <li id="toggle-stub">Toggle stub</li>
      </ul>
    </div>
    <div class="stubscontainer">
      <div class="left-panel">
        <div class="left-panel-rows">
            <div id="directory-tree-controls">
                <div class="button-panel">
                    <!--
                    <div>
                        <a id="uncheck_all" class="button is-black button-badge is-small">Uncheck All</a>
                    </div>
                    -->
                    <div class="next-button">
                        <a id="add_project" class="button is-black button-badge is-small">Add Project</a>
                    </div>
                </div>
            </div>
            <div id="progress-container">
                <!-- Progress bars will be dynamically added here -->
            </div>
            <div id="directory-tree"></div>
            <div></div>
        </div>
        <br><br><br>
      </div>
      <div class="middle-panel">
        <div id="chatgpt-response-container">
            <div class="button-panel">
                <div>
                    <a id="test_button" class="button is-dark is-small">copy</a>
                </div>
            </div>
            <!--
            <div class="new-request-button">
                <div class="max-tokens-container">
                  <label>Response Tokens:</label>
                  <input type="range" min="1000" max="6000" value="3000" class="slider" id="max_tokens_slider">
                  <span id="max_tokens_label">3000</span>
                </div>
                <span>Estimate Tokens: <span id="token_estimate"></span></span>

                <a id="accept_all_changes" class="button is-info">Accept All Changes</a>
                <a id="add_response" class="button is-info">Add Response</a>

            </div>
            -->
            <div id="chatgpt-response"></div>
            <div>
                <br><br><br><br><br>
            </div>
        </div>
//110 lines hidden
`;
    console.log("boss instructions");
    console.log(bossInstructionData);
    CHATGPT.init(apiKeys);
    
    let formalizeTaskResponse = await CHATGPT.formalizeCodeChanges(theTask, relevantCodeFiles, bossInstructionData);
    
    let formalChangeArr = formalizeTaskResponse['response'];
    console.log("=====================");
    console.log("STEP 5");      
    console.log("formalize change array: ");
    console.log(formalChangeArr);

   
};
//console.log("printing relevant files:");
//let relevantCodeFiles = `<<<<< css\\styles.css <<<<<<  \n//198 lines hidden\n}\n\n\n.chatgpt-request-banner{\n    width: 100%;\n    display: flex;\n    justify-content: space-between;\n}\n\n  .chatgpt-response-container {\n\n    display: flex;\n    position:relative;\n    /* flex-flow: column; */ \n    flex-direction: column;  \n    height: 100%;\n    padding: 15px;\n  }\n\n\n  #chatgpt-response { \n    /* flex:1 1 auto; */\n    flex-grow:1;\n    align-self:auto;\n  }\n\n\n\n.file-checkbox {\n  position: relative;\n}\n\n.checkbox-overlay {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 300px;\n  height: 1.2em;\n  cursor: pointer;\n}\n\n.tree-item-container {\n  position: relative;\n}\n\n.tree-item-container > input[type=checkbox] {\n  margin-right: 5px;\n}\n\n.textarea{\n    font-family: 'Work Sans', Arial, Verdana;\n}\n\n.directory > ul {\n  padding-left: 20px;\n  list-style-type: none;\n}\n.tree-item{\n    cursor: pointer;\n}\n\n.folder-icon::before {\n  content: '\\f749';\n  font-family: 'tabler-icons';\n  margin-left: -15px;\n  margin-right: 5px;\n}\n\n.file-icon::before {\n  content: '\\eaa4';\n  font-family: 'tabler-icons';\n  margin-left: -15px;  \n  margin-right: 5px;\n}\n\n.filealert-icon::before {\n  content: '\\ede6';\n  font-family: 'tabler-icons';\n  margin-left: -15px;  \n  margin-right: 5px;\n}\n\n\n\n.project-icon::before {\n  content: '\\f57e';\n  font-family: 'tabler-icons';\n  margin-left: -15px;  \n  margin-right: 5px;\n}\n\n.expanded > ul {\n  display: block;\n}\n\nul.collapsed {\n  display: none !important;\n}\n\n\n#file-menu {\n    background-color: #EDF0FA;\n    display: flex;\n    align-items: center;\n    padding: 5px 10px;\n}\n\n#file-menu ul {\n  list-style-type: none;\n  margin: 0;\n  padding: 0;\n  display: flex;\n}\n\n#file-menu li {\n  margin-right: 20px;\n}\n\n.file-menu-item {\n  position: relative;\n  cursor: pointer;\n  display: flex;\n  align-items: center;\n}\n\n.file-dropdown {\n  display: none;\n  position: absolute;\n  left: 0;\n  top: 100%;\n  background-color: #fff;\n  border: 1px solid #ccc;\n  padding: 5px 0;\n  z-index: 10;\n}\n\n.file-dropdown a {\n  display: block;\n  padding: 5px 10px;\n  text-decoration: none;\n  color: #333;\n  font-size: 14px;\n  width: 200px;\n}\n\n.file-dropdown a:hover {\n  background-color: #ccc;\n}\n\n.file-menu-item:hover .file-dropdown {\n  display: block;\n}\n\n.project-name {\n    font-weight: bold;\n    margin-top: 10px;\n}\n\n.progress-bar {\n    height: 20px;\n    background-color: #3498db;\n    transition: width 0.3s;\n    border: 1px solid #ddd;\n    border-radius: 5px;\n}\n/****************** CSS Loader **************************/\n\n\n\n.loader_container {\n  margin-top:250px;\n  align-items: center;\n  display: flex;\n  justify-content: center;  \n}\n\n.loader  {\n  animation: rotate 1s infinite;  \n  height: 50px;\n  width: 50px;\n}\n\n.loader:before,\n.loader:after {   \n  border-radius: 50%;\n  content: '';\n  display: block;\n  height: 20px;  \n  width: 20px;\n}\n.loader:before {\n  animation: ball1 1s infinite;  \n  background-color: #cb2025;\n  box-shadow: 30px 0 0 #f8b334;\n  margin-bottom: 10px;\n}\n.loader:after {\n  animation: ball2 1s infinite; \n  background-color: #00a096;\n  box-shadow: 30px 0 0 #97bf0d;\n}\n\n@keyframes rotate {\n  0% { \n    -webkit-transform: rotate(0deg) scale(0.8); \n    -moz-transform: rotate(0deg) scale(0.8);\n  }\n  50% { \n    -webkit-transform: rotate(360deg) scale(1.2); \n    -moz-transform: rotate(360deg) scale(1.2);\n  }\n  100% { \n    -webkit-transform: rotate(720deg) scale(0.8); \n    -moz-transform: rotate(720deg) scale(0.8);\n  }\n}\n\n@keyframes ball1 {\n  0% {\n    box-shadow: 30px 0 0 #f8b334;\n  }\n  50% {\n    box-shadow: 0 0 0 #f8b334;\n    margin-bottom: 0;\n    -webkit-transform: translate(15px,15px);\n    -moz-transform: translate(15px, 15px);\n  }\n  100% {\n    box-shadow: 30px 0 0 #f8b334;\n    margin-bottom: 10px;\n  }\n}\n\n@keyframes ball2 {\n  0% {\n    box-shadow: 30px 0 0 #97bf0d;\n  }\n  50% {\n    box-shadow: 0 0 0 #97bf0d;\n    margin-top: -20px;\n    -webkit-transform: translate(15px,15px);\n    -moz-transform: translate(15px, 15px);\n  }\n  100% {\n    box-shadow: 30px 0 0 #97bf0d;\n    margin-top: 0;\n  }\n}\n\n<<<<< ui_handlers.js <<<<<<  \nlet fileBeingRead = \"bytreesitter\";\nlet testingStuff = \"deletethis\";\nvar STUI = STUI || {};\n\n$(document).ready(function () {\n\n  $('body').on('click', '.tree-item.directory', function (event) {\n    event.stopPropagation();\n\n    const listItem = $(this);\n    const projectName = listItem.data('projectName');\n    const fullPath = listItem.data('fullPath');\n\n    listItem.toggleClass('expanded');\n\n    if (listItem.hasClass('expanded')) {\n      createDirectoryTree(projectName, listItem[0], fullPath);\n    } else {\n      listItem.children('ul').remove();\n    }\n  }); \n\n  $('#send_button').on('click', function(){\n      let chatArea = document.getElementById('chatgpt-request');\n      let myTask = chatArea.value;\n      // Add your custom logic to handle the submitted text content\n      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();\n      \n      console.log(\"Projects, paths, task\");\n      console.log(checkedProjects);\n      console.log(checkedProjectPaths);\n      console.log(myTask);\n      fullNewTask(checkedProjects, checkedProjectPaths, myTask);  \n  });  \n  \n  $('body').on('click', '.tree-item .checkbox-overlay', function (event) {\n    console.log(\"CHECKBOX CLICK\");\n    event.stopPropagation();\n\n    const listItem = $(this).parent();\n    const checkbox = listItem.find('input[type=\"checkbox\"]');\n    const projectName = listItem.data('projectName');\n    const fullPath = listItem.data('fullPath');\n    \n    console.log(\"projectName \" + projectName);\n    console.log(\"fullPath \" + fullPath);\n    \n    const fileData = getFileData(projectName, fullPath);\n\n    if (fileData.selection_state === 0) {\n      fileData.selection_state = 1;\n      checkbox.prop('indeterminate', true);\n      checkbox.prop('checked', false);\n    } else if (fileData.selection_state === 1) {\n      fileData.selection_state = 2;\n      checkbox.prop('indeterminate', false);\n      checkbox.prop('checked', true);\n    } else {\n      fileData.selection_state = 0;\n      checkbox.prop('indeterminate', false);\n      checkbox.prop('checked', false);\n    }\n\n    saveFileData();\n    CHATGPT.estimateFileTokens($('#chatgpt-request').val());\n  });\n  \n  $('body').on('click', '#test_write_files', function (event) {\n      console.log(\"testing write files\");\n      copyCheckedFilesToStubble();\n  });\n  \n  $('body').on('click', '#test_button', function(){\n      alert(\"testing Chatgpt\");\n      CHATGPT.testChatGPT();\n  });\n  \n  $('body').on('click', '#add_project', function (event) {\n      CHATGPT.prepareFileText();\n  }); \n  \n  $('body').on('click', '#add_response,#respond_button', function(){\n       let userResponse = $('#user_response').val();\n       CHATGPT.updateProgrammingTask(userResponse);    \n  });\n\n  const $textarea = $('#chatgpt-request');\n\n  const calculateNewHeight = ($element) => {\n    const originalHeight = $element.height();\n    $element.height('auto');\n    const newHeight = $element[0].scrollHeight;\n    $element.height(originalHeight);\n    return newHeight;\n  };\n\n  const adjustTextareaHeight = () => {\n    const newHeight = calculateNewHeight($textarea);\n    $textarea.height(newHeight);\n  };\n\n  $textarea.on('input', adjustTextareaHeight);\n\n    $('#chatgpt-request').on('keydown', (e) => {\n        if (e.key === 'Enter') {\n          if (e.shiftKey) {\n            // Insert a newline character if Shift is held down\n            //e.target.value += '\\n';\n          } else {\n            e.preventDefault();\n            $('#send_button').trigger('click');\n          }\n        }\n    });    \n    \n    $('body').on('click', '#gpt_version', function(){\n        if(CHATGPT.model_version == \"gpt-4\"){\n            CHATGPT.model_version = \"gpt-3.5-turbo\";\n            $(this).html(\"GPT 3.5 TURBO\");\n        }\n        else if(CHATGPT.model_version == 'gpt-3.5-turbo'){\n//183 lines hidden\n\n<<<<< index.html <<<<<<  \n<!DOCTYPE html>\n<html>\n  <head>\n    <meta charset=\"UTF-8\" />\n    <title>Stubs AI Commander</title>    \n    <link rel=\"stylesheet\" href=\"css/bulma.css\" />    \n    <link rel=\"stylesheet\" href=\"css/styles.css\" />\n    <link rel=\"stylesheet\" href=\"css/textarea.css\" />    \n    <link rel=\"stylesheet\" href=\"css/diff-panel.css\" />     \n    <link rel=\"stylesheet\" href=\"css/fonts.css\" />\n    <link rel=\"stylesheet\" href=\"css/tabler-icons.min.css\" />    \n    <link rel=\"stylesheet\" href=\"jslib/highlight.min.css\" /> \n    <link rel=\"stylesheet\" href=\"jslib/highlight.monokai-sublime.css\" />\n    <link rel=\"stylesheet\" href=\"jslib/tribute.css\">    \n    <!------ codemirror ------->\n    <link rel=\"stylesheet\" href=\"jslib/codemirror.min.css\">\n    <link rel=\"stylesheet\" href=\"jslib/addon/hint/show-hint.css\">  \n    <link rel=\"stylesheet\" href=\"jslib/addon/merge/merge.css\">   \n    <link rel=\"stylesheet\" href=\"jslib/theme/monokai.css\">             \n    <link rel=\"stylesheet\" href=\"jslib/theme/duotone-light.css\">    \n    <link rel=\"stylesheet\" href=\"jslib/theme/duotone-dark.css\">        \n  </head>\n  <body>\n    <div id=\"title-bar\">\n      <div id=\"title\">Stubs AI Commander</div>\n      <div id=\"title-bar-btns\">\n        <button id=\"min-btn\">-</button>\n        <button id=\"max-btn\">+</button>\n        <button id=\"close-btn\">x</button>\n      </div>\n    </div>\n    <div id=\"file-menu\">\n      <ul>\n        <li>\n          <div class=\"file-menu-item\">\n            File\n            <div class=\"file-dropdown\">\n              <a href=\"#\" id=\"menu-add-project\">Add New Project</a>\n            </div>\n          </div>\n        </li>\n        <li>\n          <div class=\"file-menu-item\">Settings</div>\n            <div class=\"file-dropdown\">\n              <a href=\"#\" id=\"menu-editor\">Editor</a>\n              <a href=\"#\" id=\"menu-stubs\">Stubs</a>              \n              <a href=\"#\" id=\"menu-devtools\">Toggle Devtools</a>                            \n            </div>          \n        </li>\n        <li>\n          <div class=\"file-menu-item\">Help</div>\n            <div class=\"file-dropdown\">\n              <a href=\"#\" id=\"menu-about\">About</a>                \n              <a href=\"#\" id=\"menu-tutorial\">Tutorial</a>\n            </div>          \n        </li>        \n      </ul>\n    </div>      \n    <div id=\"context-menu\" class=\"context-menu\">\n      <ul>\n        <li id=\"toggle-stub\">Toggle stub</li>\n      </ul>\n    </div>      \n    <div class=\"stubscontainer\">\n      <div class=\"left-panel\">\n        <div class=\"left-panel-rows\">\n            <div id=\"directory-tree-controls\">\n                <div class=\"button-panel\">\n                    <!--\n                    <div>\n                        <a id=\"uncheck_all\" class=\"button is-black button-badge is-small\">Uncheck All</a>\n                    </div>\n                    -->\n                    <div class=\"next-button\">\n                        <a id=\"add_project\" class=\"button is-black button-badge is-small\">Add Project</a>\n                    </div>                       \n                </div>\n            </div>\n            <div id=\"progress-container\">\n                <!-- Progress bars will be dynamically added here -->\n            </div>\n            <div id=\"directory-tree\"></div>\n            <div></div>\n        </div>\n        <br><br><br>\n      </div>\n      <div class=\"middle-panel\">\n        <div id=\"chatgpt-response-container\">\n            <div class=\"button-panel\">\n                <div>\n                    <a id=\"test_button\" class=\"button is-dark is-small\">copy</a>\n                </div>\n            </div>        \n            <!--\n            <div class=\"new-request-button\">\n                <div class=\"max-tokens-container\">\n                  <label>Response Tokens:</label>\n                  <input type=\"range\" min=\"1000\" max=\"6000\" value=\"3000\" class=\"slider\" id=\"max_tokens_slider\">\n                  <span id=\"max_tokens_label\">3000</span>\n                </div>                    \n                <span>Estimate Tokens: <span id=\"token_estimate\"></span></span>        \n                <a id=\"accept_all_changes\" class=\"button is-info\">Accept All Changes</a>  \n                <a id=\"add_response\" class=\"button is-info\">Add Response</a>                      \n            </div>\n            -->\n            <div id=\"chatgpt-response\"></div>\n            <div>\n                <div id=\"user_response_container\" style=\"display:none;\">\n                  <div class=\"flex flex-col w-full py-2 flex-grow md:py-3 md:pl-4 relative border border-black/10 bg-white dark:border-gray-900/50 dark:text-white dark:bg-gray-700 rounded-md shadow-[0_0_10px_rgba(0,0,0,0.10)] dark:shadow-[0_0_15px_rgba(0,0,0,0.10)]\">\n                    <textarea placeholder=\"Ask something else in this thread\" class=\"m-0 w-full resize-none border-0 bg-transparent p-0 pr-7 focus:ring-0 focus-visible:ring-0 dark:bg-transparent pl-2 md:pl-0 style-ECdTb\" id=\"user_response\"></textarea>\n                    <button id=\"respond_button\" class=\"absolute p-1 rounded-md text-gray-500 md:bottom-2.5 hover:bg-gray-100 enabled:dark:hover:text-gray-400 dark:hover:bg-gray-900 disabled:hover:bg-transparent dark:disabled:hover:bg-transparent right-1 md:right-2 disabled:opacity-40 snip-button\">\n                      <i class=\"ti ti-send\"></i>\n                    </button>\n                  </div>                      \n                </div>                    \n                <br><br><br><br><br>\n            </div>\n        </div>          \n        <div class=\"center_container\">\n            <div class=\"w-full border-t md:border-t-0 dark:border-white/20 md:border-transparent md:dark:border-transparent md:bg-vert-light-gradient bg-white dark:bg-gray-800 md:!bg-transparent dark:md:bg-vert-dark-gradient pt-2\">\n              <div class=\"px-3 pb-3 pt-2 text-center text-xs text-gray-600 dark:text-gray-300 md:px-4 md:pb-6 md:pt-3\">\n                <span>\n                  What feature or code changes would you like ChatGPT to add given the selected files at left as reference?\n                </span>\n              </div>\n              <div class=\"stretch mx-2 flex flex-row gap-3 last:mb-2 md:mx-4 md:last:mb-6 lg:mx-auto lg:max-w-2xl xl:max-w-3xl\">\n                <div class=\"relative flex h-full flex-1 items-stretch md:flex-col\">\n                  <div class=\"task-type-selector\" style=\"position:relative\"> \n                      <!--\n                    <div class=\"h-full flex ml-1 md:w-full md:m-auto md:mb-2 gap-0 md:gap-2 alignitemscenter\">\n                        <div class=\"select\">\n                          <select>\n                            <option value=\"task\" selected=\"selected\"><i class=\"ti ti-checklist\"></i>&nbsp;&nbsp;New Task, Feature or Fix</option>\n                            <option value=\"refactor\"><i class=\"ti ti-tools-kitchen\"></i>&nbsp;&nbsp;Refactor</option>\n                            <option value=\"question\"><i class=\"ti user-question\"></i>&nbsp;&nbsp;Question or Planning</option>    \n                            <option value=\"documentation\"><i class=\"ti user-question\"></i>&nbsp;&nbsp;Documentation</option>        \n                          </select>                                                   \n                        </div>\n                        <div>\n                            <span id=\"file_count\">0</span> Files, <span id=\"stub_count\">0<span> Stubs\n                        </div>                 \n                        <div>\n                            \n                        </div>                         \n                    </div>\n                      -->\n                      <span id=\"gpt_version\" class=\"tag is-black\" style=\"display:block;position:absolute;right:0px;top:5px;\">GPT 4</span>\n                    <div class=\"tasktabs-ix1zz\">\n                      <ul class=\"tasktabs-x2kv1\">\n                        <li class=\"tasktabs-dklix tasktabs-lp8pp \">\n                          <div class=\"tasktabs-hp9ok\">\n                            New Task\n                          </div>\n                        </li>\n                        <li class=\"tasktabs-dklix\">\n                          <div class=\"tasktabs-hp9ok\">\n                            Question\n//110 lines hidden\n\n\n\n`;
//let unescapedString = relevantCodeFiles.replace(/\\\"/g, '"').replace(/\\n/g, '\n');
// Now you can log it to see the unescaped version
//console.log(unescapedString);

//console.log("testing FormalizeChanges");
//testFormalizeChanges();


/*
    let logFolder = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\logs\\";
    let stubsFolder = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\";
    let logFile = 'formalize_code_changes_2023-11-26_06-32-45.txt';
    let logPath = logFolder + logFile;
    let jsonString = fs.readFileSync(logPath, 'utf-8');
    let formalizedChangesArr = JSON.parse(jsonString);
    //console.log(formalizedChangesArr);
    
    let originalCode = {};
    let allFileData = new Array();

    allFileData.push({
       short_path: 'css\styles.css',
       full_source: fs.readFileSync(stubsFolder + 'css\\styles.css', 'utf-8')       
    });
    allFileData.push({
       short_path: 'ui_handlers.js',
       full_source: fs.readFileSync(stubsFolder + 'ui_handlers.js', 'utf-8')       
    });
    allFileData.push({
       short_path: 'index.html',
       full_source: fs.readFileSync(stubsFolder + 'index.html', 'utf-8')       
    });
    allFileData.push({
       short_path: 'app-stubs.js',
       full_source: fs.readFileSync(stubsFolder + 'app-stubs.js', 'utf-8')       
    });    
    
    for(let m = 0; m < allFileData.length; m++){
        let origfileData = allFileData[m];
        
        originalCode[origfileData['short_path']] = origfileData['full_source'];
    }    
    //console.log("original code");
    //console.log(originalCode);
    let modifiedArr = DIFFR.getFileDiffs(originalCode, formalizedChangesArr);
    
    console.log("new code");
    console.log(modifiedArr);
    */
/*
    let logFolder = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\logs\\";
    let logFile = 'do_new_programming_task_2023-11-25_07-34-27.txt';
    let logPath = logFolder + logFile;
    let bossInstructionData = fs.readFileSync(logPath, 'utf-8'); 
console.log("testing parsing function");
let codeChangesArr = CHATGPT.parseCodeInstructions(bossInstructionData);
console.log(codeChangesArr);
*/


function generateUID() {
    var d = new Date().getTime(); // Timestamp
    var d2 = (process.hrtime && process.hrtime().valueOf() && (process.hrtime().valueOf() * 1000)) || 0; // Time in microseconds since process start or 0 if unsupported

    return 'xxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = Math.random() * 16; // Random number between 0 and 16
        if (d > 0) { // Use timestamp until depleted
            r = (d + r) % 16 | 0;
            d = Math.floor(d / 16);
        } else { // Use microseconds since process start if supported
            r = (d2 + r) % 16 | 0;
            d2 = Math.floor(d2 / 16);
        }
        return r.toString(16);
    });
}