const fs = require('fs-extra');
const path = require('path');
const { ESLint } = require('eslint');

async function testLint(fileContent, filePath){
    const eslint = new ESLint({ overrideConfigFile: path.join(__dirname, '.eslintrc.js') });

    const results = await eslint.lintText(fileContent);

    // Output any syntax errors
    const syntaxErrors = results[0].messages.filter(message => message.severity === 2);
    if (syntaxErrors.length > 0) {
        console.log(`Syntax errors found in ${filePath}:`);
        syntaxErrors.forEach(error => {
            console.log(`Line ${error.line}: ${error.message}`);
        });
    }else{
        console.log("no syntax errors");
    }
}

let file1 = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\main.js";
let fileData1 = fs.readFileSync(file1, 'utf-8');  


testLint(fileData1, file1);